<?php

// PATH

define('VAR_PATH', ROOT_PATH.'/var');
define('VENDOR_PATH', ROOT_PATH.'/vendor');

define('CLASS_PATH', SRC_PATH.'/class');
define('VIEWMODEL_PATH', SRC_PATH.'/viewmodel');
define('TEMPLATE_PATH', SRC_PATH.'/template');
define('TABLE_PATH', SRC_PATH.'/table');
define('ORM_PATH', SRC_PATH.'/orm');
define('MODEL_PATH', SRC_PATH.'/model');
define('CONTROLLER_PATH', SRC_PATH.'/controller');
define('SYNC_PATH', SRC_PATH.'/sync');

// DB

if (!defined("DB_HOST"))
	die('Please configure DB');
if (!defined("DB_P_HOST"))
	die('Please configure DB_P');
if (!defined("DB_D_HOST"))
	die('Please configure DB_D');


if (!defined("DB_P_PREFIX"))
	define('DB_P_PREFIX', 'ps_');
if (!defined("DB_D_PREFIX"))
	define('DB_D_PREFIX', 'llx_');

// DEBUG

if (!defined('DEBUG_AFF'))
	define('DEBUG_AFF', false);
if (!defined('DEBUG_ALL'))
	define('DEBUG_ALL', true);
if (!defined('DEBUG_SQL'))
	define('DEBUG_SQL', DEBUG_ALL);
if (!defined('DEBUG_SYNCHRO'))
	define('DEBUG_SYNCHRO', DEBUG_ALL);
if (!defined('DEBUG_WS'))
	define('DEBUG_WS', DEBUG_ALL);

if (!defined('DEBUG_EMAIL_TO'))
	die('Please configure DEBUG_EMAIL_TO');
if (!defined('DEBUG_EMAIL_FROM'))
	die('Please configure DEBUG_EMAIL_FROM');

// New system

if (!defined('NEWSYNC_ENABLE'))
	define('NEWSYNC_ENABLE', false);
//

// DOMAIN/WEBSITE
if (!defined("EMAIL_DOMAIN"))
	die('Please configure EMAIL_DOMAIN');
if (!defined("P_WEBSITE"))
	die('Please configure P_WEBSITE');
if (!defined("D_WEBSITE"))
	die('Please configure D_WEBSITE');

// P VERSION
if (!defined("P_VERSION"))
	define('P_VERSION', '1.7.8.7');
// D VERSION
if (!defined("D_VERSION"))
	define('D_VERSION', '19.0.1');

// P Lang
if (!defined("P_LANG_ID"))
	define("P_LANG_ID", 1);
if (!defined("P_LANG"))
	define("P_LANG", 'fr');
// P SHOP id
if (!defined("P_SHOP_ID"))
	define("P_SHOP_ID", 1);
if (!defined("P_SHOP_GROUP_ID"))
	define("P_SHOP_GROUP_ID", 0);
// P Hors catalogue
if (!defined('P_CATEGORY_DEFAULT_ID'))
	define("P_CATEGORY_DEFAULT_ID", 2);
if (!defined('P_CATEGORY_DISABLED_ID'))
	define("P_CATEGORY_DISABLED_ID", 2);
// P Attribute
if (!defined('P_ATTRIBUTE_TITLE_NAME'))
	define('P_ATTRIBUTE_TITLE_NAME', false);

// URLs
if (!defined('P_URL_PREFIX_LANG'))
	define('P_URL_PREFIX_LANG', false);
if (!defined('P_URL_PREFIX_CAT'))
	define('P_URL_PREFIX_CAT', true);
if (!defined('P_URL_SUFFIX_HTML'))
	define('P_URL_SUFFIX_HTML', true);

//define('P_ID_GROUP_DEFAULT', 3); // By default

// Sync (and override) units from Presta to Doli
if (!defined('PD_UNIT_UPDATE'))
	define("PD_UNIT_UPDATE", false);

// Synchro du statut actif : false|true|"all"|"buy"|"sell"
if (!defined("PRODUCT_ACTIVE_SYNC"))
	define('PRODUCT_ACTIVE_SYNC', false);

// Code compta par défaut. ATTENTION
if (!defined('PRODUCT_ACCOUNTANCY_CODE'))
	define('PRODUCT_ACCOUNTANCY_CODE', NULL);

// Gestion des lots produit & batch => module dluo prestashop
if (!defined("PRODUCT_LOT"))
	define('PRODUCT_LOT', false);
// Synchro uniquement du stock antigaspi s'il y en a
if (!defined("PRODUCT_LOT_STOCK_PERIME"))
	define("PRODUCT_LOT_STOCK_PERIME", false);
// Alerte si stock descend à ce niveau
if (!defined("PRODUCT_SEUIL_STOCK_ALERTE"))
	define("PRODUCT_SEUIL_STOCK_ALERTE", NULL);
// Stock de réappro par défaut
if (!defined("PRODUCT_DESIRED_STOCK"))
	define("PRODUCT_DESIRED_STOCK", NULL);
// Stock de réappro par défaut
if (!defined("PRODUCT_PACK_SPLIT"))
	define('PRODUCT_PACK_SPLIT', false);

// Délais promotion, antigaspi, péremption
if (!defined("PRODUCT_LOT_PROMOTION_DELAI"))
	define("PRODUCT_LOT_PROMOTION_DELAI", 30);
if (!defined("PRODUCT_LOT_PROMOTION_REMISE"))
	define("PRODUCT_LOT_PROMOTION_REMISE", 10);
if (!defined("PRODUCT_LOT_ANTIGASPI_DELAI"))
	define("PRODUCT_LOT_ANTIGASPI_DELAI", 2);
if (!defined("PRODUCT_LOT_ANTIGASPI_REMISE"))
	define("PRODUCT_LOT_ANTIGASPI_REMISE", 10);
if (!defined("PRODUCT_LOT_PERIME_DELAI"))
	define("PRODUCT_LOT_PERIME_DELAI", -60);

// Synchro Stock
if (!defined("STOCK_SYNC"))
	define('STOCK_SYNC', false);
// Enable synchro stock P=>D (only when 1-1) Discouraged and disables by default
if (!defined("STOCK_SYNC_FORCE_PD"))
	define('STOCK_SYNC_FORCE_PD', false);
// Type de sunchro dépôt : ALL => cumul tout, LIST => liste d'ids, ONE => id
if (!defined("D_WAREHOUSE_SYNC_MODE"))
	define('D_WAREHOUSE_SYNC_MODE', 'ALL');
// Liste des ids des warehouses Dolibarr à synchroniser (séparés par une virgule)
if (!defined("D_WAREHOUSE_SYNC_IDS"))
	define('D_WAREHOUSE_SYNC_IDS', '');

// Banque synchro CB, virement, etc.
if (!defined("D_K_BANK_CB"))
	die('Please configure D_K_BANK_CB');
// Banque synchro Caisse
if (!defined("D_K_BANK_CAISSE"))
	die('Please configure D_K_BANK_CAISSE');
// Banque autre par défaut
if (!defined("D_K_BANK_DEFAULT"))
	die('Please configure D_K_BANK_DEFAULT');
// Mode de réglement CBI Carte Bancaire Internet
if (!defined('D_K_PAIEMENT_CBI'))
	define('D_K_PAIEMENT_CBI', 54);
if (!defined('PAYMENT_SYNC'))
	define('PAYMENT_SYNC', false);
if (!defined('PAYMENT_DATE_BEGIN_SYNC'))
	define('PAYMENT_DATE_BEGIN_SYNC', NULL);
// Modules de paiement Prestashop Etransactions/Up2Pay
if (!defined('P_PAYMENT_ETRANSACTIONS'))
	define('P_PAYMENT_ETRANSACTIONS', false);
// Modules de paiement Dolibarr MBI Etransactions/Up2Pay
if (!defined('D_PAYMENT_ETRANSACTIONS'))
	define('D_PAYMENT_ETRANSACTIONS', false);
// Modules de paiement Prestashop Express Checkout
if (!defined('P_PAYMENT_CHECKOUT'))
	define('P_PAYMENT_CHECKOUT', false);
// Modules de paiement Prestashop Paypal Officiel
if (!defined('P_PAYMENT_PAYPAL'))
	define('P_PAYMENT_PAYPAL', false);

if (!defined('P_PRO_CATALOG_ORDER_STATUS'))
	define('P_PRO_CATALOG_ORDER_STATUS', NULL);

// Product fields
if (!defined("PRODUCT_FIELD_GARANTIE"))
	define("PRODUCT_FIELD_GARANTIE", false);
if (!defined('PRODUCT_FIELD_CUSTOM'))
	define('PRODUCT_FIELD_CUSTOM', false);
if (!defined('PRODUCT_FIELD_SUPPLIER_DIRECT_DELIVERY'))
	define('PRODUCT_FIELD_SUPPLIER_DIRECT_DELIVERY', false);
if (!defined('PRODUCT_FIELD_LABEL_NOSYNC'))
	define('PRODUCT_FIELD_LABEL_NOSYNC', false);
if (!defined('PRODUCT_FIELD_DESC_NOSYNC'))
	define('PRODUCT_FIELD_DESC_NOSYNC', false);
if (!defined('PRODUCT_FIELD_QUOTATION_FORM'))
	define('PRODUCT_FIELD_QUOTATION_FORM', false);
if (!defined('PRODUCT_FIELD_DECLI_DISABLED'))
	define('PRODUCT_FIELD_DECLI_DISABLED', false);
// Gestion ECOTAX
if (!defined("ECOTAX"))
	define('ECOTAX', false);
if (!defined("D_K_ECOTAX_PRODUCT"))
	define('D_K_ECOTAX_PRODUCT', NULL);
if (!defined("D_ECOTAX_PRODUCT_NAME"))
	define('D_ECOTAX_PRODUCT_NAME', 'ECOTAX');
// Gestion dimensions sur déclinaisons
if (!defined('P_PRODUCT_CDC_DIMENSIONS'))
	define('P_PRODUCT_CDC_DIMENSIONS', false);

// Prix public
if (!defined("PUBLIC_PRICE"))
	define('PUBLIC_PRICE', false);

// Default customer addresses
if (!defined("P_CUSTOMER_DEFAULT_ADDRESSES"))
	define('P_CUSTOMER_DEFAULT_ADDRESSES', false);



// Webservice Password/Key
if (!defined('WS_PASSWORD'))
	define('WS_PASSWORD', '');

//DoliBarr API Password/Key
if (!defined('D_API_KEY'))
	define('D_API_KEY', '');
//DoliBarr API Password/Key
if (!defined('P_API_KEY'))
	define('P_API_KEY', '');

