<?php

namespace Controller;

class Base
{

// Class

protected static $__db;
protected static $__logger;

public function __init()
{
	if (!isset(static::$__logger))
		static::__setlogger($GLOBALS['logger']);
	static::__log(__METHOD__);

	if (!isset(static::$__db))
		static::__setdb($GLOBALS['db']);
}

public static function __setdb($db)
{
	static::$__db = $db;
}

public static function __setlogger($logger)
{
	static::$__logger = $logger;
}

public static function __logger()
{
	return static::$__logger;
}

public static function __log($message, $t='notice')
{
	return static::$__logger->notice($message);
}

public static function __gettopost($name)
{
	if (!isset($_POST[$name]) && isset($_GET[$name]))
		$_POST[$name] = $_GET[$name];
}

public static function __gettopostall()
{
	foreach($_GET as $name=>$value)
		if (!isset($_POST[$name]) && isset($_GET[$name]))
			$_POST[$name] = $_GET[$name];
}

// Object

protected $name;

protected $data = [];
//protected $disp = [];

protected $actions = [];
protected $action;

protected $viewmodel_name;
protected $view;

public function __construct()
{
}

// ACTIONS

public function name()
{
	return $this->name;
}

public function actions()
{
	return $this->actions;
}

public function execute()
{
	static::__log(__METHOD__);
	
	if (!isset($_GET['action']))
		$m = "Aucune action définie";
	elseif (!is_string($action=$_GET['action']))
		$m = "Action invalide, chaine de caractères requise";
	elseif (!isset($this->actions[$action]))
		$m = "Action invalide, \"".$action."\"  introuvable/indéfinie";
	else {
		if (isset($this->actions[$action]['viewmodel']))
			$this->viewmodel_name = $this->actions[$action]['viewmodel'];
		$this->{$action."_action"}();
	}
}

// Display

/**
 * Displays template
 */
public function display($viewmodel_name=null)
{
	static::__log(__METHOD__);
	if (empty($viewmodel_name))
		$viewmodel_name = $this->viewmodel_name;
	$filename = VIEWMODEL_PATH.'/'.$viewmodel_name.'.php';
	$e = explode('/', $viewmodel_name);
	$classname = 'ViewModel\\'.array_pop($e).'ViewModel';

	require_once $filename;
	
	$template = $this->template = new $classname($this);
	$template->set_many($this->data);
	//$template->set_many($this->disp);
	// @todo
	$template->display();
}

}
