<?php

namespace Controller;

require_once 'base.php';
require_once CLASS_PATH.'/table/p_table.php';
require_once CLASS_PATH.'/table/d_table.php';

class Model extends Base {

protected $actions = [
	'index' => [
		'label'=>'Accueil',
		'viewmodel'=>'model/index',
	],
	'p_table' => [
		'label'=>'Tables Prestashop associées',
		'viewmodel'=>'model/table_list',
	],
	'p_field' => [
		'label'=>'Gestion des champs des tables Prestashop',
		'param'=>['table'],
		'viewmodel'=>'model/field_list',
	],
	'd_table' => [
		'label'=>'Tables Dolibarr associées',
		'viewmodel'=>'model/table_list',
	],
	'd_field' => [
		'label'=>'Gestion des champs des tables Dolibarr',
		'param'=>['table'],
		'viewmodel'=>'model/field_list',
	],
];

protected $viewmodel_name = 'table/index';

/**
 * Liste des tables
 */
public function index_action()
{
	static::__log(__METHOD__);
}

/**
 * Liste des tables
 */
public function p_table_action()
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	$this->data['_prefix'] = $_prefix;
	
	$classname = '\\Table\\'.$_prefix.'Table';
	$this->data['t_list'] = $classname::_list();
	$this->data['t_fields'] = $classname::_fields();
}

/**
 * Liste des tables
 */
public function d_table_action()
{
	static::__log(__METHOD__);
	
	return $this->list_action('p_');
}

/**
 * Liste des tables
 */
public function p_field_action()
{
	static::__log(__METHOD__);
	
	return $this->list_action('d_');
}

/**
 * Détails d'une table
 */
public function d_field_action()
{
	static::__log(__METHOD__);
	
	$table_name = $_GET['table'];
	
	$classname = '\\Table\\'.$_prefix.'Table';
	$field_classname = '\\Table\\'.$_prefix.'Field';
	$table = $classname::_get_by_name($table_name);
	//var_dump($table);
	
	// Indéxation champs manquant
	if (isset($_GET['index'])) {
		$table->fields_index();
	}
	
	$this->data['_prefix'] = $_prefix;
	$this->data['table'] = $table;
	
	// Obsolète ..? Accessible depuis $table
	$this->data['t_fields'] = $classname::_fields();
	$this->data['f_fields'] = $field_classname::_fields();
	$this->data['c_fields'] = $field_classname::_c_fields();
}

}

Table::__init();
