<?php

namespace Controller;

require_once 'base.php';
require_once CLASS_PATH.'/table/p_table.php';
use \Table\P_Table;
require_once CLASS_PATH.'/table/p_field.php';
use \Table\P_Field;

class Synchro extends Base {

protected $model_name;
protected $model;
protected $id;
protected $label;

protected $dt;
protected $pt;

protected $p_lang_id = 1;
protected $p_shop_id = 1;

protected $actions = [
	'map' => [
		'label'=>'Gestion des mappings',
	],
	'p_table' => [
		'label'=>'Gestion des tables Prestashop',
	],
	'd_table' => [
		'label'=>'Gestion des tables Dolibarr',
	],
	'clean' => [
		'label'=>'Nettoyage',
		'desc'=>'Vérifie les tables et supprime les données obsolètes',
	],
	'list' => [
		'label'=>'Liste',
		//'viewmodel'=>'sync/list',
	],
	'assoc' => [ // = create
		'label'=>'Association',
		'desc'=>'Associe des objets existant au sein d\'un nouveau modèle',
		//'viewmodel'=>'sync/assoc',
	],
	// Usage webservice possible
	'create' => [ 
		'label'=>'Création',
		'desc'=>'Créé un objet à partir de données',
		//'viewmodel'=>'sync/assoc',
	],
	'link' => [ // = create
		'label'=>'Lie un objet à un modèle',
		'desc'=>'Associe un objet existant à un modèle existant',
		//'viewmodel'=>'sync/assoc',
	],
	'unlink' => [ // = create
		'label'=>'Délie un objet à d\'un modèle',
		'desc'=>'Disssocie un objet existant d\'un modèle existant',
		//'viewmodel'=>'sync/assoc',
	],
	'sync_init' => [
		'label'=>'(re)Initialisation synchro',
		'desc'=>'Lance une (re)synchro complète d\'un modèle',
		//'viewmodel'=>'sync/sync',
	],
	'sync' => [
		'label'=>'Synchro',
		'desc'=>'Synchronise les objets d\'un modèle existant (se basant uniquement sur ce qui a été modifié)',
		//'viewmodel'=>'sync/sync',
	],
	'osync' => [
		'label'=>'Synchro ou création, c\'est selon',
		'desc'=>'Synchronise ou créé les objets d\'un modèle existant (se basant uniquement sur ce qui a été modifié)',
		//'viewmodel'=>'sync/sync',
	],
];

protected $o;

public function __construct()
{
	parent::__construct();
	static::__log(__METHOD__);
	
	$filename = MODEL_PATH.'/'.$this->model_name.'.php';
	require_once $filename;
	$classname = 'Model\\'.$this->model_name;
	
	$this->model = $model = new $classname();
	$this->id = $model::_id();
	$this->pt = $model::_pt();
	$this->dt = $model::_dt();
	
	//var_dump($this->id);
}

// Parameters

public function model()
{
	return $this->model;
}

// List Objects

public function o_list()
{
	static::__log(__METHOD__);
	return $this->model::_o_list();
}

public function p_list()
{
	static::__log(__METHOD__);
	return $this->model::_p_list();
}

public function d_list()
{
	static::__log(__METHOD__);
	return $this->model::_d_list();
}

// Tables and Fields

/**
 * Actions sur les tables Prestashop
 */
public function p_table_action()
{
	static::__log(__METHOD__);
	
	if (isset($_GET['table'])) {
		$this->p_table_default_action($_GET['table']);
	}
	else {
		$this->p_table_list_action();
	}
}

/**
 * Liste des tables Prestashop
 */
public function p_table_list_action()
{
	static::__log(__METHOD__);
	$db = static::$__db;
		
	$this->data['t_list'] = P_Table::_list();
	$this->data['t_fields'] = P_Table::_fields();
}

/**
 * Détails d'une table Prestashop
 */
public function p_table_default_action($table_name)
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	$table = P_Table::_get_by_name($table_name);
	
	// Indéxation champs manquant
	if (isset($_GET['index'])) {
		$this->p_table_index($f);
	}
	
	$this->data['table'] = $table;
	
	// Obsolète ..? Accessible depuis $table
	$this->data['t_fields'] = P_Table::_fields();
	$this->data['f_fields'] = P_Field::_fields();
	$this->data['c_fields'] = P_Field::_c_fields();
}

/**
 * Actions sur les tables Dolibarr
 */
public function d_table_action()
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	
}

// Clean DB

/**
 * Nettoyer
 */
public function clean_action()
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	$q = $db->query('SELECT *
		FROM _objects
		WHERE active=1 AND mid='.$this->id);
}


// List

public function list_action()
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	$o_list = $this->o_list();
	
	if (isset($_GET['ajax']))
		echo json_encode($o_list);
	else
		$this->list_display($o_list);
}

public function list_display($o_list)
{
	$this->data['o_list'] = $o_list;
}

/* Create & sync_init */

/**
 * Créé un objet du modèle à partir de données p & d
 */
public function create_action()
{
	static::__log(__METHOD__);
	static::__gettopostall();
	
	if (empty($_POST['sens']))
		die('sens manquant');
	$sens = $_POST['sens'];
	
	$type = ($sens=='pd') ?'p' :'d';
	if (empty($_POST['otype']))
		die('otype manquant');
	$otype = $_POST['otype'];
	
	if (empty($_POST['oid']))
		die('oid manquant');
	$oid = $_POST['oid'];
	
	$ref = isset($_POST['ref']) ?$_POST['ref'] :NULL;
	$data = isset($_POST['data']) ?$_POST['data'] :NULL;
	
	// Si existe on créé pas.
	// Ceci doit pouvoir être forcé.
	
	$res = $this->oexists_exec($type, $otype, $oid, $ref);
	if (!is_array($res) || !array_key_exists('response', $res))
		die('couille');
	elseif (!$res['response'])
		die($res['reason_label']);
	$this->create_exec($type, $otype, $oid, $ref, $data);
}

/**
 * Vérifie si un objet est dans une association
 * rtuorne un tableau avec entre autres :
 * response : true si oui, false sinon
 * reason : raison/pourquoi cette réponse
 * o : objet trouvé
 */
public function oexists_exec($type, $otype, $oid, $ref=null)
{
	static::__log(__METHOD__);
	//die('test mathou');
	
	// Check Mapping not exists
	// ATTENTION! On se connait pas le mapping a priori...
	// @todo mapping à récupérer SI l'objet est mappé au modèle.
	if (!($map = $this->model::_mapbyobject($type, $otype, $oid))) {
		//var_dump($map); die();
		return ['response'=>false, 'reason'=>'map_none', 'reason_label'=>'Aucun mapping...'];
	}
	//var_dump($map); //die();
	
	// Check OID not Exists
	$tableclass = '\\Table\\'.$type.'_Table';
	$t = $tableclass::_get($otype);
	//var_dump($t); //die();
	if (empty($r = $t->get($oid))) {
		//var_dump($r); die();
		return ['response'=>false, 'reason'=>'oid_incorrect', 'map'=>$map];
	}
	
	// Check OID already mapped
	//var_dump($map['id'].", $type, $otype, $oid");
	if ($id = $this->model::_getidbyoid($type, $otype, $oid)) {
		//var_dump($id); die();
		return ['response'=>false, 'reason'=>'id_already', 'map'=>$map, 't'=>$t, 'r'=>$r, 'id'=>$id, 'reason_label'=>'Objet déjà Mappé...'];
	}
	
	// Check ref already mapped with another OID
	$ref = !empty($t->f_ref) && !empty($r) ?$r[$t->f_ref] :NULL;
	if ($ref && ($id = $this->model::_getidbyref($ref))) {
		return ['r'=>false, 'reason'=>'ref_already', 'map'=>$map, 't'=>$t, 'r'=>$r, 'id'=>$id, 'reason_label'=>'Ref existante...'];
	}
	
	return ['response'=>true, 'reason'=>'ok_to_create', 'map'=>$map, 't'=>$t, 'r'=>$r];
}

/**
 * Créé un objet du modèle à partir de données p & d
 */
public function create_exec($type, $otype, $oid, $ref=null, $data=null)
{
	static::__log(__METHOD__);
	
	$orig = $type;
	$dest = ($type=='p') ?'d' :'p';
	$sens = ($type=='p') ?'pd' :'dp';
	
	$model = $this->model;
	$table = '\\Table\\'.$type.'_Table';
	
	$t = $table::_get($otype);
	//var_dump($t); die();
	
	$r = $model::_ws_oexists($type, $otype, $oid);
	if (empty($r) || empty($r['return'])) {
		
		var_dump($r);
		var_dump("$type, $otype, $oid");
		die('COUILLE oid inexistant sur serveur distant!');
	}
	//var_dump($r); die();
	// Ancienne version local...
	//if (!($r = $t->get($oid)))
	//	die('COUILLE oid');
	//var_dump($r); //die();
	
	$map = $model::_mapbyobject($type, $otype, $oid);
	//var_dump($type); var_dump($otype); var_dump($map); var_dump($r); die();
	// Check label
	$label = (!empty($t->f_label) && isset($r[$t->f_label])) ?$r[$t->f_label] :NULL;
	// @todo : Conflit de ref => envoi email pour validation
	// @todo : Conflit d'id idem ! faut pas associer 40 fois un objet, sinon ça va faire des synchro de merde...
	// Lien de confirmation ou de reverse (remet les valeurs d'avant en cas de modif de ref)
	//var_dump($ref); var_dump($label); //die();
	
	if ($ref && ($oid2=$model::_ws_oexists_ref($type, $otype, $ref)))
		die('COUILLE objet avec ref '.$ref.' existe déjà de l\'autre côté avec oid '.$oid2);
	
	// Add object model
	$id = $model::_add($map['id'], $ref, $label);
	//var_dump($id); 
	// Link object to table data
	$model::_t_assoc($type, $id, $t->id, $oid);
	
	// Sync object
	$this->sync_exec($sens, $id);
	// Sync ini object
	$this->sync_init_exec($sens, $id);
}

/* Assoc */

/**
 * Associe des objets
 * Ensuite on pourra les synchroniser
 * Ordre d'association : dp = Doli => Presta
 */
public function assoc_action($sens='dp')
{
	static::__log(__METHOD__);
	static::__gettopostall();
	
	if (isset($_POST['_assoc_exec'])) {
        if (isset($_POST['s']) && is_array($_POST['s'])) {
			if (empty($_POST['s']))
				echo "Argument manquant : Tableau d'association vide";
			foreach($_POST['s'] as $r)
				$this->assoc_exec($sens, $r);
		}
		elseif (is_string($_POST['s'])) {
			$this->assoc_exec($sens, $_POST['s']);
		}
		else {
            echo "Argument manquant : Tableau/Chaine d'association";
        }
	}
	
	if (!isset($_GET['ajax']))
		$this->assoc_display($sens);
}

protected function assoc_exec($sens='dp', $r)
{
	// @todo overload
}

/**
 * Liste des objets associés ou à associer
 * Ordre d'association : dp = Doli => Presta
 */
protected function assoc_display($sens='dp')
{
	// @todo overload
}

protected function assoc_p()
{
	static::__log(__METHOD__);
	
	// A Associer
	// Actifs sur Presta
	// Sans association active
	
	return $this->model::_p_list('nosync');
}

protected function assoc_d()
{
	static::__log(__METHOD__);
	
	// A Associer
	// Actifs sur Presta
	// Sans association active
	
	return $this->model::_d_list('nosync');
}


/* Version temporaire plus rapide à développer */

/*
 * Dolibarr est maitre d'une manière générale sur les produits ainsi que d'autres objets, mais
 * - On peut associer/dissocier ce qu'on veut dans le sens qu'on veut
 * - On peut toujours synchroniser ce qu'on veut (en terme de champs) dans le sens qu'on veut
 * - Seuls les stocks, marques, fournisseurs seront synchronisés par défaut dans le sens doli=>presta
 * - Si les champs non maître sont modifiés sur presta, il faut les resynchroniser
 */

/**
 * Créé les associations 
 */
public function assoc_list_temp()
{
	// Affiche le type de synchronisation par défaut (depuis/vers selon les champs et actions)
	// Récupérer la liste Presta
	// Récupérer la liste Doli
	// Donner l'état de l'association
	// Permettre d'associer et de dissocier
	// Permettre de synchroniser comme on veut, en créant, supprimant ou mettant à jour
	// Permettre de modifier/supprimer directement ? On peut très bien imaginer que l'outil soit aussi un outil de gestion, en fait... si on offre des fonctions manquantes ou plus pratiques c'est tout à fait envisageable
	
	$o_list = $this->o_list();
}


/* Synchro Init */

/**
 * Synchronise un ID modèle déjà mappé
 * selon les paramètres de synchro définis
 */
public function sync_init_action()
{
	static::__log(__METHOD__);
	static::__gettopostall();
	
	$id = $_POST['id'];
	$sens = $_POST['sens'];
	
	return $this->sync_init_exec($sens, $id);
	
}
public function sync_init_exec($sens, $id)
{
	static::__log(__METHOD__);
	
	return $this->model::_sync($sens, $id);
}

// Synchro

/**
 * Synchronise un ID modèle déjà mappé
 * selon les paramètres de synchro définis
 */
public function sync_action()
{
	static::__log(__METHOD__);
	static::__gettopostall();
	
	$id = $_POST['id'];
	$sens = $_POST['sens'];
	
	return $this->sync_exec($sens, $id);
}

public function sync_exec($sens, $id)
{
	return $this->model::_sync($sens, $id);
}

/**
 * Synchronise un OID d'un type donné, et réalise un mapping ou une création selon le cas
 * selon les paramètres de synchro définis
 */
public function osync_action()
{
	static::__log(__METHOD__);
	static::__gettopostall();
	
	if (empty($_POST['sens']))
		die('sens manquant');
	$sens = $_POST['sens'];
	
	$type = ($sens=='pd') ?'p' :'d';
	if (empty($_POST['otype']))
		die('otype manquant');
	$otype = $_POST['otype'];
	
	if (empty($_POST['oid']))
		die('oid manquant');
	$oid = $_POST['oid'];
	
	$ref = isset($_POST['ref']) ?$_POST['ref'] :NULL;
	$data = isset($_POST['data']) ?$_POST['data'] :NULL;
	
	// Si existe on créé pas.
	// Ceci doit pouvoir être forcé.
	
	$res = $this->oexists_exec($type, $otype, $oid, $ref);
	if (DEBUG_SYNCHRO) {
		var_dump("$type, $otype, $oid, $ref");
		var_dump($res);
		//die();
	}
	// Erreur
	if (!is_array($res) || !array_key_exists('response', $res))
		die('couille');
	// Déjà => Update
	elseif (!$res['response'] && $res['reason']=='id_already')
		$this->sync_exec($sens, $res['id']);
	// Pas => Create
	else
		$this->create_exec($type, $otype, $oid, $ref, $data);
}

// Obsolètes, trivial, aucun gain à les utiliser...

public function model_t_assoc($type, $id, $tid, $oid)
{
	return $this->model::_t_assoc($type, $id, $tid, $oid);
}
public function model_dt_assoc($id, $tid, $oid)
{
	return $this->model::_t_assoc('d', $id, $tid, $oid);
}
public function model_pt_assoc($id, $tid, $oid)
{
	return $this->model::_t_assoc('p', $id, $tid, $oid);
}
public function model_add($map_id, $ref=null, $label=null)
{
	return $this->model::_add($map_id, $ref, $label);
}

/**
 * Mapping
 */
public function map_action()
{
}

}
