<?php

namespace Controller;

require_once 'base.php';
require_once CLASS_PATH.'/table/p_table.php';
require_once CLASS_PATH.'/table/d_table.php';

class Table extends Base {

protected $actions = [
	'index' => [
		'label'=>'Accueil',
	],
	'p_list' => [
		'label'=>'Liste des tables Prestashop',
		'viewmodel'=>'table/list',
	],
	'p_table' => [
		'label'=>'Détails table Prestashop',
		'viewmodel'=>'table/table',
		'param'=>['table'],
	],
	'p_fields' => [
		'label'=>'Gestion des champs dune table Prestashop',
		'param'=>['table'],
	],
	'd_list' => [
		'label'=>'Liste des tables Dolibarr',
		'viewmodel'=>'table/list',
	],
	'd_table' => [
		'label'=>'Détails table Dolibarr',
		'viewmodel'=>'table/table',
		'param'=>['table'],
	],
	'd_fields' => [
		'label'=>'Gestion des champs dune table Dolibarr',
		'param'=>['table'],
	],
];

protected $viewmodel_name = 'table/index';

/**
 * Liste des tables
 */
public function index_action()
{
	static::__log(__METHOD__);
}

/**
 * Liste des tables
 */
public function list_action($_prefix)
{
	static::__log(__METHOD__);
	$db = static::$__db;
	
	$this->data['_prefix'] = $_prefix;
	
	$classname = '\\Table\\'.$_prefix.'Table';
	$this->data['t_list'] = $classname::_list();
	$this->data['t_fields'] = $classname::_fields();
}

/**
 * Liste des tables
 */
public function p_list_action()
{
	static::__log(__METHOD__);
	
	return $this->list_action('p_');
}

/**
 * Liste des tables
 */
public function d_list_action()
{
	static::__log(__METHOD__);
	
	return $this->list_action('d_');
}

/**
 * Détails d'une table
 */
public function table_action($_prefix)
{
	static::__log(__METHOD__);
	
	$table_name = $_GET['table'];
	
	$classname = '\\Table\\'.$_prefix.'Table';
	$field_classname = '\\Table\\'.$_prefix.'Field';
	$table = $classname::_get_by_name($table_name);
	//var_dump($table);
	
	// Indéxation champs manquant
	if (isset($_GET['index'])) {
		$table->fields_index();
	}
	
	$this->data['_prefix'] = $_prefix;
	$this->data['table'] = $table;
	
	// Obsolète ..? Accessible depuis $table
	$this->data['t_fields'] = $classname::_fields();
	$this->data['f_fields'] = $field_classname::_fields();
	$this->data['c_fields'] = $field_classname::_c_fields();
}

/**
 * Détails d'une table
 */
public function p_table_action()
{
	static::__log(__METHOD__);
	
	return $this->table_action('p_');
}


/**
 * Détails d'une table
 */
public function d_table_action()
{
	static::__log(__METHOD__);
	
	return $this->table_action('d_');
}

/**
 * IDétails des champs d'une table
 */
public function fields_action($prefix, $table_name=null)
{
	static::__log(__METHOD__);
	
	//
}

/**
 * IDétails des champs d'une table
 */
public function p_fields_action($table_name=null)
{
	static::__log(__METHOD__);
	
	$table_name = $_GET['table'];
	
	$this->fields_action('p_', $table_name);
}

/**
 * IDétails des champs d'une table
 */
public function d_fields_action($table_name=null)
{
	static::__log(__METHOD__);
	
	$table_name = $_GET['table'];
	
	$this->fields_action('d_', $table_name);
}


}

Table::__init();
