<?php

namespace logger;

define('LOG_DISPLAY', true);

class base
{

protected $l = [
	'notice' => [],
	'info' => [],
	'warning' => [],
	'error' => [],
	'critical' => [],
];

public function notice($infos, $context=[])
{
	$this->log('notice', $infos, $context);
}

public function info($infos, $context=[])
{
	$this->log('info', $infos, $context);
}

public function warning($infos, $context=[])
{
	$this->log('warning', $infos, $context);
}

public function error($infos, $context=[])
{
	$this->log('error', $infos, $context);
}

public function critical($infos, $context=[])
{
	$this->log('critical', $infos, $context);
}

public function log($type, $infos, $context=[])
{
	//static::_display_one($type, $infos, $context);
	
	$this->l[$type][] = [microtime(), $infos, $context];
}

public function display_all()
{
	foreach($this->l as $type=>$j) {
		echo '<b>'.$type.'</b><br />';
		foreach($j as $k) {
			var_dump($k);
			// @todo use display
		}
	}
}

public static function _display_one($type, $infos, $context)
{
	echo '<p><b>'.$type.'</b></p>';
	static::_display($infos, $context);
}

public static function _display($infos, $context)
{
	if (!empty($context))
		echo '<p>context :<br />File :'.$context[0].'<br />Method :'.$context[1].'<br />Line :'.$context[2].'</p>';
	
	echo '<p>infos :</p>';
	if (is_array($infos)) foreach($infos as $name=>$info) {
		echo '<p>'.$name.'</p>';
		print_r($info);
	}
	elseif (is_string($infos) || is_numeric($infos)) {
		echo '<p>'.$infos.'</p>';
	}
	else {
		var_dump($infos);
	}
}

}
