<?php

namespace ViewModel;

class BaseViewModel
{

// Class

protected static $__db;
protected static $__logger;

public function __init()
{
	if (!isset(static::$__logger))
		static::__setlogger($GLOBALS['logger']);
	static::__log(__METHOD__);

	if (!isset(static::$__db))
		static::__setdb($GLOBALS['db']);
}

public static function __setdb($db)
{
	static::$__db = $db;
}

public static function __setlogger($logger)
{
	static::$__logger = $logger;
}

public static function __logger()
{
	return static::$__logger;
}

public static function __log($message, $t='notice')
{
	return static::$__logger->notice($message);
}

// Oject

protected $controller;
protected $vars = [];
protected $filename = '';

public function __construct($controller)
{
	static::__log(__METHOD__);
	$this->controller = $controller;
}

public function set($name, $value)
{
	$this->vars[$name] = $value;
}

public function set_many($vars)
{
	foreach($vars as $i=>$j)
		$this->set($i, $j);
}

public function vars()
{
	return $this->vars;
}

public function get($name)
{
	return $this->vars[$name];
}

public function display()
{
	static::__log(__METHOD__);
	$controller = $this->controller;
	extract($this->vars);
	
	include TEMPLATE_PATH.'/'.$this->filename.'.php';
}

}

BaseViewModel::__init();

