<?php

namespace Controller;

require_once CLASS_PATH.'/controller/synchro.php';

class synchro_product extends Synchro
{

protected $name = 'product';

protected $model_name = 'product';
protected $viewmodel_name = 'sync/sync';

protected $p_product_tid = 1;
protected $p_product_attribute_tid = 5;
protected $d_product_tid = 1;

protected $params = [];

/**
 * Associe des objets
 * Ensuite on pourra les synchroniser
 * Ordre d'association : dp = Doli => Presta
 */
protected function assoc_exec($r, $order='dp')
{
	static::__log(__METHOD__);
	
	if(is_string($r))
		$r = explode('-', $r);
	//var_dump($r);
	
	$id = $r[0];
	$d_product_id = $r[1];
	$p_product_id = $r[2];
	$p_product_attribute_id = $r[3];
	$ref = $r[4];
	
	// Association CRUD
	
	// Add sync object
	if (empty($id)) {
		$id = $this->model_add($ref);
		
		if (!empty($d_product_id)) {
			$this->model_dt_assoc($id, $this->d_product_tid, $d_product_id);
		}
		if (!empty($p_product_id)) {
			$this->model_pt_assoc($id, $this->p_product_tid, $p_product_id);
		}
		if (!empty($p_product_attribute_id)) {
			$this->model_pt_assoc($id, $this->p_product_attribute_tid, $p_product_attribute_id);
		}
		die();
	}
	else {
	}
}

/**
 * Liste des objets associés ou à associer
 * Ordre d'association : dp = Doli => Presta
 */
protected function assoc_display($order='dp')
{
	static::__log(__METHOD__);
	
	// Objets déjà associés
	$ol = $this->o_list();
	$this->data['ol'] = $ol;
	$this->data['ol_nb'] = count($ol);
	// Objets Presta nouveaux
	$p = $this->assoc_p();
	$this->data['add_p'] = $p;
	$this->data['add_p_nb'] = count($p);
	// Objets Dolibarr nouveaux
	$d = $this->assoc_d();
	$this->data['add_d'] = $d;
	$this->data['add_d_nb'] = count($d);
	
	// Analyse
	$oref = [];
	$o = [];
	foreach($ol as &$j) {
		if (isset($j['dt'])) foreach($j['dt'] as $k) {
			if ($k['tid']==$this->d_product_tid)
				$j['d']['rowid'] = $k['oid'];
		}
		if (isset($j['pt'])) foreach($j['pt'] as $k) {
			if ($k['tid']==$this->p_product_tid)
				$j['p']['id_product'] = $k['oid'];
			if ($k['tid']==$this->p_product_attribute_tid)
				$j['p']['id_product_attribute'] = $k['oid'];
		}
		if (isset($j['ref']))
			$oref[$j['ref']] = &$j;
		//var_dump($j);
		$o[] = &$j;
	}
	if (isset($j))
		unset($j);
	
	// @todo : Il faut aussi comparer les nouveaux à ce qu'on a déjà en BDD !
	// Il a pu y avoir des erreurs de synchro
	
	// Ordre D->P (par défaut)
	// Création D
	foreach($d as $i=>&$j) {
		// Réf définie
		if (!empty($j['ref'])) {
			// Pas déjà ref => création
			if (!isset($oref[$j['ref']])) {
				$m = ['d'=>$j, 'status'=>[], 'todo'=>[]];
				$o[] = &$m;
				$oref[$j['ref']] = &$m;
				$m['todo'][] = "create-d";
			}
			// Déja réf mais pas doli => Synchro
			elseif (!isset($oref[$j['ref']]['d'])) {
				$oref[$j['ref']]['d'] = $j;
				$oref[$j['ref']]['todo'][] = "sync-d";
			}
			// Déjà réf doli => Erreur
			else {
				$m = ['p'=>$j, 'status'=>[], 'todo'=>[]];
				$o[] = &$m;
				$m['status'][] = "doublon-d";
				//$oref[$j['ref']]['status'][] = "doublon-d";
			}
		}
		// Pas de réf
		else {
			$m = ['d'=>$j, 'status'=>[], 'todo'=>[]];
			$o[] = &$m;
			$m['todo'][] = 'create-d';
		}
		//var_dump($m); die();
		unset($m);
	}
	$n = 0;
	// Association nouveau P à D
	foreach($p as $i=>&$j) {
		// Réf définie
		if (!empty($j['ref'])) {
			// Pas déjà ref => création
			if (!isset($oref[$j['ref']])) {
				$m = ['p'=>$j, 'status'=>[], 'todo'=>[]];
				$o[] = &$m;
				$oref[$j['ref']] = &$m;
				$m['todo'][] = "create-p";
			}
			// Déja réf mais pas presta => Synchro
			elseif (!isset($oref[$j['ref']]['p'])) {
				$oref[$j['ref']]['p'] = $j;
				$oref[$j['ref']]['todo'][] = 'assoc-p';
				//var_dump($oref[$j['ref']]);
			}
			// Déjà réf presta => Erreur
			else {
				$m = ['p'=>$j, 'status'=>[], 'todo'=>[]];
				$o[] = &$m;
				$m['status'][] = "doublon-p";
				//$oref[$j['ref']]['status'][] = "doublon-p";
			}
		}
		// NO réf => Création
		else {
			$m = ['p'=>$j, 'status'=>[], 'todo'=>[]];
			$o[] = &$m;
			$m['todo'][] = 'create-p';
		}
		unset($m);
	}
	
	$this->data['o'] = $o;
}

}

synchro_product::__init();
