<?php

// Récupère l'ensemble des commerciaux & managers
$sql = 'SELECT u.rowid, u.firstname, u.lastname, u.fk_user, u.accountancy_code, u2.p_id_user
    FROM '.DB_D_BASE.'.'.DB_D_PREFIX.'user u
    LEFT JOIN '.DB_D_BASE.'.'.DB_D_PREFIX.'user_extrafields u2
        ON u2.fk_object=u.rowid
    WHERE (u.accountancy_code IS NOT NULL AND u.accountancy_code != "")';
pre_sql($sql);
$q = DB::d_select($sql);
$users = [];
$comm_map_dp = $map_dp = [];
while($row = $q->fetch_assoc()) {
	$users[$row['rowid']] = $row;
    if ($row['p_id_user']) {
        if ($row['fk_user'])
            $comm_map_dp[$row['rowid']] = $row['p_id_user'];
        $map_dp[$row['rowid']] = $row['p_id_user'];
    }
}
$comm_map_pd = array_flip($comm_map_dp);
$map_pd = array_flip($map_dp);

$nbmax = isset($_GET['nbmax']) && is_numeric($_GET['nbmax']) && $_GET['nbmax']==(int)$_GET['nbmax'] && $_GET['nbmax']>=0 ?$_GET['nbmax'] :5000;
$limit = $nbmax;

$sql_d_fk_commerciaux = implode(',', $comm_map_pd);
$sql_p_fk_commerciaux = implode(',', $comm_map_dp);
$sql_d_fk_users = implode(',', $map_pd);
$sql_p_fk_users = implode(',', $map_dp);

$sql = 'SELECT *
    FROM '.DB_D_BASE.'.'.DB_D_PREFIX.'c_type_contact
    WHERE source="internal" AND element IN ("propal", "commande", "facture")';
$q = DB::d_select($sql);
$contacts = [
    'propal' => [],
    'commande' => [],
    'facture' => [],
];
$contact = [
    'propal' => [],
    'commande' => [],
    'facture' => [],
];
while($row = $q->fetch_assoc()) {
    $contacts[$row['element']][$row['rowid']] = $row;
    if (empty($contact[$row['element']]))
        $contact[$row['element']] = $row['rowid'];
}

function element_contact($type, $rowid, $userid)
{
    global $contact;
    $sql = 'INSERT INTO `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact`
        (datecreate, statut, element_id, fk_c_type_contact, fk_socpeople)
        VALUES
        (NOW(), 4, '.$rowid.', '.$contact[$type].', '.$userid.')';
    pre_sql($sql);
    if (isset($_GET['go']))
        DB::d_update($sql);
}

function societe_commercial($rowid, $userid)
{
    $sql = 'INSERT INTO '.DB_D_PREFIX.'societe_commerciaux (fk_soc, fk_user) VALUES ('.$rowid.', '.$userid.')';
    pre_sql($sql);
    if (isset($_GET['go']))
        DB::d_insert($sql);
}

// Affectation commercial à Propale
if (isset($_GET['propal_assoc'])) {
    $sql = 'SELECT p.rowid p_rowid, p.ref p_ref, p.fk_user_author p_fk_user_author, p.fk_user_modif p_fk_user_modif, p.fk_user_valid p_fk_user_valid,
        s.rowid, s.nom, s.email, GROUP_CONCAT(DISTINCT su.fk_user SEPARATOR ",") fk_users, s.fk_user_creat, s.fk_user_modif,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") p_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) p_actioncom_fk_user_nb

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
    INNER JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe` s
        ON s.rowid=p.fk_soc
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=p.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['propal'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe_commerciaux` su
        ON su.fk_soc=s.rowid

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=s.rowid AND ap.elementtype="propal" AND ap.fk_element=p.rowid

    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY p.rowid
    ORDER BY p.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    $q = DB::o_select($sql);

    pre_sql($sql);
    var_dump($q);

    echo '<p>TOTAL : '.mysqli_num_rows($q).'</p>';

    $ok = 0;
    $nb = 0;
    while($row=$q->fetch_assoc()) {
        $nb++;
        if ($nb>$nbmax)
            break;
        pre_dump($row);
        $u = [];
        foreach(['p_fk_user_author', 'p_fk_user_modif', 'p_fk_user_valid'] as $k) if ($row[$k]>0)
            $u[] = $row[$k];
        foreach(['p_actioncom_fk_user'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i)
                    $u[] = $i;
            }
        }
        $u2 = array_unique($u);
        // Suppression utilisateurs moisis
        foreach($u2 as $k=>$userid) {
            if (!in_array($userid, $map_pd))
                unset($u2[$k]);
        }
        $u2_save = $u2;
        pre_dump($u2);
        // Si un seul commercial sur le devis, on l'assigne
        if (count($u2) == 1) {
            foreach($u2 as $userid) {
                $ok++;
                element_contact('propal', $row['p_rowid'], $userid);
            }
        }
        // Sinon, on regarde les "vrais" commerciaux
        elseif (count($u2)>1) {
            foreach($u2 as $k=>$userid) if (!in_array($userid, $comm_map_pd))
                unset($u2[$k]);
            pre_dump($u2);
            // Un seul com spécifique
            if (count($u2) == 1) {
                foreach($u2 as $userid) {
                    $ok++;
                    element_contact('propal', $row['p_rowid'], $userid);
                }
            }
            // Pas de commercial spécifique => on prend le premier patron
            elseif (count($u2) == 0) {
                if (isset($_GET['force_boss_assign'])) {
                    foreach($u2_save as $userid) {
                        element_contact('propal', $row['p_rowid'], $userid);
                        // On prend le permier
                        break;
                    }
                }
            }
            else {
                // On regarde les commerciaux associés au client
                if (!empty($row['fk_users'])) {
                    $fk_users = explode(',', $row['fk_users']);
                }
                else {
                    $fk_users = [];
                }
                // Si on a un seul commercial associé au tiers et qu'il est dans la liste des potentiels, on l'assigne
                if (count($fk_users)==1 && in_array($fk_users[0], $u2_save)) {
                    $userid = $fk_users[0];
                    element_contact('propal', $row['p_rowid'], $userid);
                }
                // Afficher choix pour spécification à la main
                else {
                    foreach($u2_save as $userid) {
                        echo '<p>Associer =&gt; <a href="?t=customer&propal_assoc&map['.$row['p_rowid'].']='.$userid.'">#'.$userid.' - '.$users[$userid]['firstname'].'</a></p>';
                    }
                }
            }
        }
        // Spécification à la main
        elseif(!empty($_GET['map'][$row['p_rowid']])) {
            $userid = $_GET['map'][$row['p_rowid']];
            element_contact('propal', $row['p_rowid'], $userid);
        }
    }

    echo '<p>Modifications : '.$ok.'</p>';
    die();
}

// Affectation commercial à Commande
if (isset($_GET['order_assoc'])) {
    $sql = 'SELECT o.rowid o_rowid, o.ref o_ref, o.fk_user_author o_fk_user_author, o.fk_user_modif o_fk_user_modif, o.fk_user_valid o_fk_user_valid,
        s.rowid, s.nom, s.email, GROUP_CONCAT(DISTINCT su.fk_user SEPARATOR ",") fk_users, s.fk_user_creat, s.fk_user_modif,
        GROUP_CONCAT(DISTINCT ao.fk_user_action SEPARATOR ",") o_actioncom_fk_user, COUNT(DISTINCT ao.fk_user_action) o_actioncom_fk_user_nb

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe` s
        ON s.rowid=o.fk_soc
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe_commerciaux` su
        ON su.fk_soc=s.rowid

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ao
        ON ao.fk_soc=s.rowid AND ao.elementtype="commande" AND ao.fk_element=o.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) { 
        $list[$row['o_rowid']] = $row;
    }

    $sql = 'SELECT o.rowid o_rowid, GROUP_CONCAT(DISTINCT ps_oh.id_employee SEPARATOR ",") o_history_ids_employee

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')
    
    LEFT JOIN `'.DB_BASE.'`._objects_d o_d
        ON o_d.oid=o.rowid AND o_d.tid=14
    LEFT JOIN `'.DB_BASE.'`._objects_p o_p
        ON o_p.id=o_d.id
    LEFT JOIN `'.DB_P_BASE.'`.ps_order_history ps_oh
        ON ps_oh.id_order=o_p.oid AND ps_oh.id_employee IN ('.$sql_p_fk_users.')
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) { 
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // Propal associée
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid p_rowid, p.ref p_ref, p.fk_user_author p_fk_user_author, p.fk_user_modif p_fk_user_modif, p.fk_user_valid p_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") p_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) p_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ep_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.sourcetype="propal" AND ee.fk_target=o.rowid AND ee.targettype="commande")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
        ON p.rowid=ee.fk_source
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['propal'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="propal" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) {
        if (empty($row['p_rowid']))
            continue;
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // Propal associée 2
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid p_rowid, p.ref p_ref, p.fk_user_author p_fk_user_author, p.fk_user_modif p_fk_user_modif, p.fk_user_valid p_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") p_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) p_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ep_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.sourcetype="commande" AND ee.fk_source=o.rowid AND ee.targettype="propal")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
        ON p.rowid=ee.fk_target
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['propal'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="propal" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) { 
        if (empty($row['p_rowid']))
            continue;
        foreach(['p_actioncom_fk_user', 'p_actioncom_fk_user_nb', 'ep_fk_user'] as $i) {
            if (empty($row[$i]))
                unset($row[$i]);
        }
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    echo '<p>TOTAL : '.count($list).'</p>';

    $ok = 0;
    $nb = 0;
    foreach($list as $row) {
        pre_dump($row);
        $u = [];
        foreach(['p_fk_user_author', 'p_fk_user_modif', 'p_fk_user_valid', 'o_fk_user_author', 'o_fk_user_modif', 'o_fk_user_valid'] as $k) if (isset($row[$k]) && $row[$k]>0)
            $u[] = $row[$k];
        foreach(['p_actioncom_fk_user', 'o_actioncom_fk_user'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i)
                    $u[] = $i;
            }
        }
        foreach(['o_history_ids_employee'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i)
                    $u[] = $map_pd[$i];
            }
        }
        $u2 = array_unique($u);
        // Suppression utilisateurs moisis
        foreach($u2 as $k=>$userid) {
            if (!in_array($userid, $map_pd))
                unset($u2[$k]);
        }
        $u2_save = $u2;
        pre_dump($u2);
        // Si un seul commercial affecté proprement sur le devis, on l'assigne
        if (!empty($row['ep_fk_user']) && count($ep_fk_users=explode(',', $row['ep_fk_user']))==1) {
            $userid = $row['ep_fk_user'];
            element_contact('commande', $row['o_rowid'], $userid);
        }
        // Si un seul commercial qui a travaillé sur le devis, on l'assigne
        elseif (count($u2) == 1) {
            foreach($u2 as $userid) {
                element_contact('commande', $row['o_rowid'], $userid);
            }
        }
        // Sinon, si un seul "vrai" commercial sur le devis, on l'assigne
        elseif (count($u2)>1) {
            foreach($u2 as $k=>$userid) if (!in_array($userid, $comm_map_pd))
                unset($u2[$k]);
            pre_dump($u2);
            // Un seul commercial spécifique
            if (count($u2) == 1) {
                foreach($u2 as $userid) {
                    element_contact('commande', $row['o_rowid'], $userid);
                }
            }
            // Pas de commercial spécifique => on prend le premier patron
            elseif (count($u2) == 0) {
                if (isset($_GET['force_boss_assign'])) {
                    foreach($u2_save as $userid) {
                        element_contact('commande', $row['o_rowid'], $userid);
                        // On prend le permier
                        break;
                    }
                }
            }
            else {
                // On regarde les commerciaux associés au client
                if (!empty($row['fk_users'])) {
                    $fk_users = explode(',', $row['fk_users']);
                }
                else {
                    $fk_users = [];
                }
                // Si on a un seul commercial associé au tiers et qu'il est dans la liste des potentiels, on l'assigne
                if (count($fk_users)==1 && in_array($fk_users[0], $u2_save)) {
                    $userid = $fk_users[0];
                    element_contact('commande', $row['o_rowid'], $userid);
                }
                // Afficher choix pour spécification à la main
                else {
                    foreach($u2_save as $userid) {
                        echo '<p>Associer =&gt; <a href="?t=customer&propal_assoc&map['.$row['o_rowid'].']='.$userid.'">#'.$userid.' - '.$users[$userid]['firstname'].'</a></p>';
                    }
                }
            }
        }
        // Spécification à la main
        elseif(!empty($_GET['map'][$row['o_rowid']])) {
            $userid = $_GET['map'][$row['o_rowid']];
            element_contact('commande', $row['o_rowid'], $userid);
        }
    }

    echo '<p>Modifications : '.$ok.'</p>';
    die();
}

// Affectation commercial à Facture
if (isset($_GET['invoice_assoc'])) {
    // Infos de base
    $sql = 'SELECT o.rowid o_rowid, o.ref o_ref, o.fk_user_author o_fk_user_author, o.fk_user_modif o_fk_user_modif, o.fk_user_valid o_fk_user_valid,
        s.rowid, s.nom, s.email, GROUP_CONCAT(DISTINCT su.fk_user SEPARATOR ",") fk_users, s.fk_user_creat, s.fk_user_modif,
        GROUP_CONCAT(DISTINCT ao.fk_user_action SEPARATOR ",") o_actioncom_fk_user, COUNT(DISTINCT ao.fk_user_action) o_actioncom_fk_user_nb

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['facture'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe` s
        ON s.rowid=o.fk_soc
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe_commerciaux` su
        ON su.fk_soc=s.rowid

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ao
        ON ao.fk_soc=s.rowid AND ao.elementtype="facture" AND ao.fk_element=o.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) { 
        $list[$row['o_rowid']] = $row;
    }

    // Propale associée
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid p_rowid, p.ref p_ref, p.fk_user_author p_fk_user_author, p.fk_user_modif p_fk_user_modif, p.fk_user_valid p_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") p_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) p_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ep_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['facture'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.sourcetype="propal" AND ee.fk_target=o.rowid AND ee.targettype="facture")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
        ON p.rowid=ee.fk_source
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['propal'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="propal" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) {
        if (empty($row['p_rowid']))
            continue;
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // Propale associée 2
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid p_rowid, p.ref p_ref, p.fk_user_author p_fk_user_author, p.fk_user_modif p_fk_user_modif, p.fk_user_valid p_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") p_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) p_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ep_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['facture'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.targettype="propal" AND ee.fk_source=o.rowid AND ee.sourcetype="facture")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
        ON p.rowid=ee.fk_target
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['propal'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="propal" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) {
        if (empty($row['p_rowid']))
            continue;
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // Commande associée
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid c_rowid, p.ref c_ref, p.fk_user_author c_fk_user_author, p.fk_user_modif c_fk_user_modif, p.fk_user_valid c_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") c_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) c_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ec_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['facture'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.sourcetype="commande" AND ee.fk_target=o.rowid AND ee.targettype="commande")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` p
        ON p.rowid=ee.fk_source
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="commande" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) {
        if (empty($row['c_rowid']))
            continue;
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // Commande associée 2
    $sql = 'SELECT o.rowid o_rowid,
        p.rowid c_rowid, p.ref c_ref, p.fk_user_author c_fk_user_author, p.fk_user_modif c_fk_user_modif, p.fk_user_valid c_fk_user_valid,
        GROUP_CONCAT(DISTINCT ap.fk_user_action SEPARATOR ",") c_actioncom_fk_user, COUNT(DISTINCT ap.fk_user_action) c_actioncom_fk_user_nb,
        GROUP_CONCAT(DISTINCT ep.fk_socpeople) ec_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` o
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` e
        ON e.element_id=o.rowid AND e.fk_c_type_contact IN ('.implode(',', array_keys($contacts['facture'])).')
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_element` ee
        ON (ee.targettype="commande" AND ee.fk_source=o.rowid AND ee.sourcetype="commande")
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` p
        ON p.rowid=ee.fk_target
    
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'element_contact` ep
        ON ep.element_id=p.rowid AND ep.fk_c_type_contact IN ('.implode(',', array_keys($contacts['commande'])).')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` ap
        ON ap.fk_soc=o.fk_soc AND ap.elementtype="commande" AND ap.fk_element=p.rowid
    
    WHERE 1
        AND e.fk_socpeople IS NULL

    GROUP BY o.rowid
    ORDER BY o.rowid DESC'
    .($limit ?' LIMIT '.$limit :'');
    pre_sql($sql);
    $q = DB::o_select($sql);
    var_dump($q);
    while($row=$q->fetch_assoc()) {
        if (empty($row['c_rowid']))
            continue;
        $list[$row['o_rowid']] = array_merge($list[$row['o_rowid']], $row);
    }

    // 

    echo '<p>TOTAL : '.count($list).'</p>';

    $ok = 0;
    $nb = 0;
    foreach($list as $row) {
        pre_dump($row);
        $u = [];
        foreach(['p_fk_user_author', 'p_fk_user_modif', 'p_fk_user_valid', 'o_fk_user_author', 'o_fk_user_modif', 'o_fk_user_valid'] as $k) if (isset($row[$k]) && $row[$k]>0)
            $u[] = $row[$k];
        foreach(['p_actioncom_fk_user', 'o_actioncom_fk_user'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i)
                    $u[] = $i;
            }
        }
        foreach(['o_history_ids_employee'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i)
                    $u[] = $map_pd[$i];
            }
        }
        $u2 = array_unique($u);
        // Suppression utilisateurs moisis
        foreach($u2 as $k=>$userid) {
            if (!in_array($userid, $map_pd))
                unset($u2[$k]);
        }
        $u2_save = $u2;
        pre_dump($u2);
        // Si un seul commercial affecté proprement sur le devis, on l'assigne
        if (!empty($row['ep_fk_user']) && count($ep_fk_users=explode(',', $row['ep_fk_user']))==1) {
            $userid = $row['ep_fk_user'];
            element_contact('facture', $row['o_rowid'], $userid);
        }
        // Si un seul commercial affecté proprement sur la commande, on l'assigne
        elseif (!empty($row['ec_fk_user']) && count($ec_fk_users=explode(',', $row['ec_fk_user']))==1) {
            $userid = $row['ec_fk_user'];
            element_contact('facture', $row['o_rowid'], $userid);
        }
        // Si un seul commercial qui a travaillé sur le devis, on l'assigne
        elseif (count($u2) == 1) {
            foreach($u2 as $userid) {
                element_contact('facture', $row['o_rowid'], $userid);
            }
        }
        // Si un seul commercial qui a travaillé sur la commane, on l'assigne
        elseif (count($u2) == 1) {
            foreach($u2 as $userid) {
                element_contact('facture', $row['o_rowid'], $userid);
            }
        }
        // Sinon, si un seul "vrai" commercial sur le devis, on l'assigne
        elseif (count($u2)>1) {
            foreach($u2 as $k=>$userid) if (!in_array($userid, $comm_map_pd))
                unset($u2[$k]);
            pre_dump($u2);
            // Un seul commercial spécifique
            if (count($u2) == 1) {
                foreach($u2 as $userid) {
                    element_contact('facture', $row['o_rowid'], $userid);
                }
            }
            // Pas de commercial spécifique => on prend le premier patron
            elseif (count($u2) == 0) {
                if (isset($_GET['force_boss_assign'])) {
                    foreach($u2_save as $userid) {
                        element_contact('facture', $row['o_rowid'], $userid);
                        // On prend le permier
                        break;
                    }
                }
            }
            else {
                // On regarde les commerciaux associés au client
                if (!empty($row['fk_users'])) {
                    $fk_users = explode(',', $row['fk_users']);
                }
                else {
                    $fk_users = [];
                }
                // Si on a un seul commercial associé au tiers et qu'il est dans la liste des potentiels, on l'assigne
                if (count($fk_users)==1 && in_array($fk_users[0], $u2_save)) {
                    $userid = $fk_users[0];
                    element_contact('facture', $row['o_rowid'], $userid);
                }
                // Afficher choix pour spécification à la main
                else {
                    foreach($u2_save as $userid) {
                        echo '<p>Associer =&gt; <a href="?t=customer&invoice_assoc&map['.$row['o_rowid'].']='.$userid.'">#'.$userid.' - '.$users[$userid]['firstname'].'</a></p>';
                    }
                }
            }
        }
        // Spécification à la main
        elseif(!empty($_GET['map'][$row['o_rowid']])) {
            $userid = $_GET['map'][$row['o_rowid']];
            element_contact('facture', $row['o_rowid'], $userid);
        }
    }

    echo '<p>Modifications : '.$ok.'</p>';
    die();
}

// Affecation commercial à client
// Ayant au moins un devis ou une commande validée ou une facture
if (isset($_GET['soc_assoc'])) {
    $sql = 'SELECT s.rowid, s.nom, s.email, GROUP_CONCAT(DISTINCT o.rowid SEPARATOR ",") fk_orders, s.fk_user_creat, s.fk_user_modif,
    GROUP_CONCAT(DISTINCT p.fk_user_author SEPARATOR ",") p_fk_user_author, GROUP_CONCAT(DISTINCT p.fk_user_modif SEPARATOR ",") p_fk_user_modif, GROUP_CONCAT(DISTINCT p.fk_user_valid SEPARATOR ",") p_fk_user_valid,
    GROUP_CONCAT(DISTINCT o.fk_user_author SEPARATOR ",") o_fk_user_author, GROUP_CONCAT(DISTINCT o.fk_user_modif SEPARATOR ",") o_fk_user_modif, GROUP_CONCAT(DISTINCT o.fk_user_valid SEPARATOR ",") o_fk_user_valid,
    GROUP_CONCAT(DISTINCT i.fk_user_author SEPARATOR ",") i_fk_user_author, GROUP_CONCAT(DISTINCT i.fk_user_modif SEPARATOR ",") i_fk_user_modif, GROUP_CONCAT(DISTINCT i.fk_user_valid SEPARATOR ",") i_fk_user_valid,
    GROUP_CONCAT(DISTINCT ps_oh.id_employee SEPARATOR ",") o_history_ids_employee,
    GROUP_CONCAT(DISTINCT a.fk_user_action SEPARATOR ",") actioncom_fk_user

    FROM `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe` s
    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'societe_commerciaux` su
        ON su.fk_soc=s.rowid

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'actioncomm` a
        ON a.fk_soc=s.rowid AND a.fk_user_action IN ('.$sql_d_fk_users.')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'commande` o
        ON o.fk_soc=s.rowid AND o.fk_statut>0
    LEFT JOIN `'.DB_BASE.'`._objects_d o_d
        ON o_d.oid=o.rowid AND o_d.tid=14
    LEFT JOIN `'.DB_BASE.'`._objects_p o_p
        ON o_p.id=o_d.id
    LEFT JOIN `'.DB_P_BASE.'`.ps_order_history ps_oh
        ON ps_oh.id_order=o_p.oid AND ps_oh.id_employee IN ('.$sql_p_fk_users.')

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'propal` p
        ON p.fk_soc=s.rowid AND p.fk_statut>0

    LEFT JOIN `'.DB_D_BASE.'`.`'.DB_D_PREFIX.'facture` i
        ON i.fk_soc=s.rowid

    WHERE su.fk_user IS NULL
        AND (p.rowid IS NOT NULL OR o.rowid IS NOT NULL OR i.rowid IS NOT NULL)

    GROUP BY s.rowid';

    $q = DB::o_select($sql);

    echo '<p>'.$sql.'</p>';
    var_dump($q);

    echo '<p>TOTAL : '.mysqli_num_rows($q).'</p>';
    $nbmax = 5000;

    $ok = 0;
    $nb = 0;
    while($row=$q->fetch_assoc()) {
        $nb++;
        if ($nb>$nbmax)
            break;
        pre_dump($row);
        $u = [];
        if (in_array($row['fk_user_creat'], $map_pd))
            $u[] = $row['fk_user_creat'];
        if (in_array($row['fk_user_modif'], $map_pd))
            $u[] = $row['fk_user_modif'];
        foreach(['p_fk_user_author', 'p_fk_user_modif', 'p_fk_user_valid',
            'c_fk_user_author', 'c_fk_user_modif', 'o_fk_user_valid',
            'i_fk_user_author', 'i_fk_user_modif', 'i_fk_user_valid',
            'actioncom_fk_user'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i) if (in_array($i, $map_pd))
                    $u[] = $i;
            }
        }
        foreach(['o_history_ids_employee'] as $k) {
            if (!empty($row[$k])) {
                $l = explode(',', $row[$k]);
                foreach($l as $i) if (in_array($i, $map_dp))
                    $u[] = $map_pd[$i];
            }
        }
        $u2 = array_unique($u);
        // Suppression utilisateurs moisis
        foreach($u2 as $k=>$userid) {
            if (!in_array($userid, $map_pd))
                unset($u2[$k]);
        }
        $u2_save = $u2;
        var_dump($u, $u2); echo '<br />';
        if (count($u2)==1) {
                $ok++;
            echo '<p style="color: red;">1 Utilisateur ! => Traitement auto => '.$users[$userid]['lastname'].'</p>';
            societe_commercial($row['rowid'], $userid);
        }
        // Sinon, si un seul "vrai" commercial sur le devis, on l'assigne
        elseif (count($u2)>1) {
            foreach($u2 as $k=>$userid) if (!in_array($userid, $comm_map_pd))
                unset($u2[$k]);
            pre_dump($u2);
            // Un seul commercial spécifique
            if (count($u2) == 1) {
                foreach($u2 as $userid) {
                    echo '<p style="color: red;">1 Utilisateur spécifique ! => Traitement auto => '.$users[$userid]['lastname'].'</p>';
                    societe_commercial($row['rowid'], $userid);
                }
            }
            // Pas de commercial spécifique => on prend le premier patron
            elseif (count($u2) == 0) {
                foreach($u2_save as $userid) {
                    if (isset($_GET['force_boss_assign'])) {
                        echo '<p style="color: red;">1er patron ! => Traitement auto => '.$users[$userid]['lastname'].'</p>';
                        societe_commercial($row['rowid'], $userid);
                        // On prend le permier
                        break;
                    }
                }
            }
            // Afficher choix pour spécification à la main
            else {
                foreach($u2_save as $userid) {
                    echo '<p>Associer =&gt; <a href="?t=customer&soc_assoc&map['.$row['rowid'].']='.$userid.'">#'.$userid.' - '.$users[$userid]['firstname'].'</a></p>';
                }
            }
        }
        echo '<hr />';
    }

    echo '<p>Modifications : '.$ok.'</p>';
}