<?php

namespace Model;

require_once CLASS_PATH.'/model/base.php';

class product extends base
{

protected static $_cache = [];

protected static $_id;
protected static $_name;
protected static $_label;

protected static $_pt = [];
protected static $_pt_alias = [];
protected static $_dt = [];
protected static $_dt_alias = [];

protected static $_maps = [];

protected static $_map_val = [];
protected static $_map_fct = [
	'd' => [
		'product_url' => '',
		'barcode' => '',
		'barcode_type' => '',
		'is_batch' => '',
		'tva_tx' => '',
		'fk_supplier' => '',
	],
	'p' => [
		'id_tax_rules_group' => '',
		'ean' => '',
		'isbn' => '',
		'upc' => '',
		'fk_supplier' => '',
		'link_rewrite' => '',
	],
];

protected static $_p_product_tid = 1;
protected static $_p_product_attribute_tid = 5;
protected static $_d_product_tid = 1;

public static function _d_map_fk_supplier($orig_data, $dest_tree=[])
{
	$orig = 'p';
	//var_dump($orig_data); var_dump($dest_tree);
	$oid = $orig_data['product_supplier']['id_supplier'];
	//
	$modelname = 'supplier';
	$tablename = 'supplier';
	
	return static::_map_fk($orig, $modelname, $tablename, $oid);
}
public static function _p_map_fk_supplier($orig_data, $dest_tree=[])
{
	$orig = 'd';
	//var_dump($orig_data); var_dump($dest_tree);
	$oid = $orig_data['product_fournisseur_price']['fk_soc'];
	//
	$modelname = 'supplier';
	$tablename = 'societe';
	
	return static::_map_fk($orig, $modelname, $tablename, $oid);
}

public static function _d_map_product_url($orig_data, $dest_tree=[])
{
	return static::$__p_params['url'].'/'.static::$__p_params['lang'].'/'.$orig_data['product']['id_product'].'-'.$orig_data['product_lang']['link_rewrite'];
}
public static function _d_map_barcode($orig_data, $dest_tree=[])
{
	if (!empty($orig_data['product']['ean13']))
		return $orig_data['product']['ean13'];
	elseif (!empty($orig_data['product']['upc']))
		return $orig_data['product']['upc'];
	elseif (!empty($orig_data['product']['isbn']))
		return $orig_data['product']['isbn'];
}
public static function _d_map_barcode_type($orig_data, $dest_tree=[])
{
	if (!empty($orig_data['product']['ean13']))
		return'2';
	elseif (!empty($orig_data['product']['upc']))
		return '3';
	elseif (!empty($orig_data['product']['isbn']))
		return '4';
}
public static function _d_map_is_batch($orig_data, $dest_tree=[])
{
}
public static function _d_map_tva_tx($orig_data, $dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['product']['id_tax_rules_group']) {
		case '1':
			return 20;
		case '2':
			return 10;
		case '3':
			return 5.5;
		case '4':
			return 2.1;
		case '5':
			return 0;
	}
}
public static function _p_map_id_tax_rules_group($orig_data, $dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['product']['tva_tx']) {
		case '20':
			return 1;
		case '10':
			return 2;
		case '5.5':
			return 3;
		case '2.1':
			return 4;
		case '0':
			return 5;
	}
}
public static function _p_map_ean($orig_data, $dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==2) ?$orig_data['product']['barcode'] :NULL;
}
public static function _p_map_isbn($orig_data, $dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==4) ?$orig_data['product']['barcode'] :NULL;
}
public static function _p_map_upc($orig_data, $dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==3) ?$orig_data['product']['barcode'] :NULL;
}
public static function _p_map_link_rewrite($orig_data, $dest_tree=[])
{
	return static::_slugify($orig_data['product']['label']);
}

/**
 * Liste des produits Prestashop
 * A partir de deux listes/requêtes
 * deux familles d'ID : id_product et id_product_attribute
 */
public static function _p_list($params=null)
{
	$db = static::$__db;
	$ref_parse = false;
	
	$l = [];
	if ($ref_parse)
		$refs = [];
	
	// Produits non déclinés
	$sql = static::_p_sql_1($params);
	$q = $db->query($sql);
	while ($r = $q->fetch_assoc()) {
		//var_dump($r);
		$l[] = $r;
		if ($ref_parse) {
			if (!empty($r['ref']))
				$refs[] = $r['ref'];
		}
	}
	
	// Produits déclinés
	$sql = static::_p_sql_2($params);
	$q = $db->query($sql);
	while ($r = $q->fetch_assoc()) {
		//var_dump($r);
		$l[] = $r;
		if ($ref_parse) {
			if (!empty($r['ref']))
				$refs[] = $r['ref'];
		}
	}
	
	return $l;
}

/**
 * Produits Presta non déclinés
 */
public static function _p_sql_1($params=null)
{
	$_sql_p = 'FROM '.DB_P_PREFIX.'product AS p
		LEFT JOIN '.DB_P_PREFIX.'product_attribute AS pa
			ON pa.id_product=p.id_product
		LEFT JOIN '.DB_P_PREFIX.'product_lang AS pl
			ON pl.id_product=p.id_product AND pl.id_lang='.P_LANG_ID;

	$sql = 'SELECT
			p.id_product, pa.id_product_attribute,
			p.reference AS ref,
			pl.name AS label,
			p.date_upd AS ts,
			p.active,
			ol.id AS oid
		'.$_sql_p.'
		LEFT JOIN _objects_p ol
			ON ol.tid='.static::$_p_product_tid.' AND ol.oid=p.id_product
		LEFT JOIN _objects o
			ON o.id=ol.id AND o.active=1
		WHERE
			pa.id_product_attribute IS NULL
			AND p.active=1';
	
	if ($params=='nosync')
		$sql .= ' AND o.id IS NULL';
	
	//echo $sql;
	return $sql;
}

/**
 * Produits Presta déclinés
 */
public static function _p_sql_2($params=null)
{
	$_sql_p = 'FROM '.DB_P_PREFIX.'product AS p
		LEFT JOIN '.DB_P_PREFIX.'product_attribute AS pa
			ON pa.id_product=p.id_product
		LEFT JOIN '.DB_P_PREFIX.'product_lang AS pl
			ON pl.id_product=p.id_product AND pl.id_lang='.P_LANG_ID;

	$sql = 'SELECT
			p.id_product, pa.id_product_attribute,
			pa.reference AS ref,
			pl.name AS label,
			pa.date_upd AS ts,
			p.active,
			ol.id AS oid
		'.$_sql_p.'
		LEFT JOIN _objects_p ol
			ON ol.tid='.static::$_p_product_attribute_tid.' AND ol.oid=pa.id_product_attribute
		LEFT JOIN _objects o
			ON o.id=ol.id AND o.active=1
		WHERE
			pa.id_product_attribute IS NOT NULL
			AND p.active=1';
	
	if ($params=='nosync')
		$sql .= ' AND o.id IS NULL';
	
	//echo $sql;
	return $sql;
}

public static function _d_sql($params=null)
{
	$_sql_d = 'FROM '.DB_D_PREFIX.'product AS p';
	
	$sql = 'SELECT
			p.rowid,
			p.ref,
			p.label,
			p.tms AS ts,
			1 AS active,
			ol.id AS oid
		'.$_sql_d.'
		LEFT JOIN _objects_d ol
			ON ol.tid='.static::$_d_product_tid.' AND ol.oid=p.rowid
		LEFT JOIN _objects o
			ON o.id=ol.id AND o.active=1
		WHERE
			1';
	
	if ($params=='nosync')
		$sql .= ' AND o.id IS NULL';
	//echo $sql;
	return $sql;
}


/* MAPPING */

public static function _map_pd(&$o)
{
	$tree = [];
	
	// Rien dans la source
	// => Suppression destination ?
	if (empty($o[$from.'_tree_web'])) {
		// Doit-on cascader la suppression ..?
		//if ($sync['delete'])
		$tree[$tablename] = [];
	}
	// Rien dans la destination
	// => Création destination
	elseif (empty($o[$dest.'_tree_web'])) {
		// On créé le même objet que pour la modification ..?
		//if ($sync['insert'])
		$table = static::${'_'.$dest.'t'}[$tablename];
		$tree[$tablename] = [];
		$tree[$tablename]['row'] = static::_map_table_row($sens, $table, $map, $o['d_tree_web'], $o['p_tree_web']);
	}
	// Qque chose partout
	// => Mise à jour destination
	else {
		//if ($sync['update'])
		$table = static::${'_'.$dest.'t'}[$tablename];
		$tree[$tablename] = [];
		$tree[$tablename]['row'] = static::_map_table_row($sens, $table, $map, $o['d_tree_web'], $o['p_tree_web']);
	}
	
	//var_dump($tree); die();
}

}

product::__init();
