<?php
/**
* 2020 iProspective & Mathieu Moulin
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Mathieu Moulin <contact@iprospective.fr>
*  @copyright 2020 iProspective & Mathieu Moulin
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of iProspective & Mathieu Moulin
*/

if (!defined('_PS_VERSION_')) {
	exit;
}

if (! class_exists('MMI_Singleton_1_0'))
	require_once 'mmi_singleton.php';

/**
 * Décale l'envoi/execution de notifications.
 */
class MMI_Notification_1_0 extends MMI_Singleton_1_0
{

// CLASS

protected static $_instance;

// OBJECT

protected $l = [
    'email' => [],
    'sql' => [],
    'sync' => [],
];

/**
 * Trucs qui se passent en fin de script
 */
public function __destruct()
{
	//thrigger_error('yo');
	$this->execute();
}

public function add($action, $type, $ref, $params=null)
{
    $this->l[$action][$type][$ref] = $params;
	
	return;
	foreach($this->l as $action=>$list) {
		// Boucle types dans actions
		var_dump($action); var_dump($list);
	}
	die();
}

public function execute()
{
	//var_dump($this->l); die();
	// Boucle actions
	foreach($this->l as $action=>$list) {
		// Boucle types dans actions
		foreach($list as $type=>$details) {
			$this->{$action.'_execute'}($type, $details);
		}
	}
}

public function sql_execute($type, $details)
{
    echo '<p>Execute SQL :</p>';
	var_dump($type); var_dump($details);
    // execution requête
}

public function email_execute($type, $details)
{
    //echo '<p>Execute Email :</p>';
    //var_dump($type); var_dump($details);

    if($type=='pack_alert') {
    	$infos = '';
    	foreach($details as $id=>$detail) {
    		$infos .= $detail;
    	}
		mail('mathieu@iprospective.fr', 'Remise sur produit dans un pack', $infos."Vous pouvez recevoir ce message en plusieurs exemplaires, et il peut parfois s'agir d'une simple suppression de la catégorie promo d'un produit packagé, cette fonctionnalité est encore en bêta et sera améliorée sous peu...", 'From: no-reply@calicote.com'."\r\n".'Content-Type: text/plain; charset=utf-8'."\r\n");
   	}
}

public function sync_execute($type, $details)
{
    //echo '<p>Execute Sync :</p>';
    //var_dump($type); //var_dump($details);
    
    foreach($details as $ref=>$params) {
    	//echo '<p>Sync object</p>';
		//var_dump($ref); var_dump($params); var_dump($type.'/'.$params['action']); var_dump(['sens'=>static::WS_SYNC_SENS, 'otype'=>$params['otype'], 'oid'=>$params['oid']]);
		$r = $this->ws_sync_url($type.'/'.$params['action'], ['sens'=>static::WS_SYNC_SENS, 'otype'=>$params['otype'], 'oid'=>$params['oid']]);
		//var_dump($r);
	}
}

/* Webservice */

const WS_SYNC_URL = 'https://calicote-sync.dev.iprospective.fr';
const WS_SYNC_SENS = 'pd';

public function ws_sync_url($url, $post=null)
{
	$url = static::WS_SYNC_URL.'/'.$url;
	//$url = $this->getConfigFieldsValue('sync_url').'/'.$url;
	//var_dump($url); var_dump($post); die();
	
	$timeout = 30;
	$ch = curl_init($url); // initialize curl with given url
	curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]); // set  useragent
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // write the response to a variable
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // follow redirects if any
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout); // max. seconds to execute
	curl_setopt($ch, CURLOPT_FAILONERROR, 1); // stop when it encounters an error
	if (!empty($post)) {
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
	}
	$raw_data = @curl_exec($ch);
	//echo $raw_data; die();
	$data = json_decode($raw_data, true);
	//echo $url; var_dump($data);
	return $data;
}

}

MMI_Notification_1_0::__init();
