<?php
/**
* 2021 Mathieu Moulin iProspective
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Mathieu Moulin <contact@iprospective.fr>
*  @copyright 2021 Mathieu Moulin iProspective
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of iProspective & Mathieu Moulin
*/

if (!defined('_PS_VERSION_')) {
	exit;
}

//use PrestaShop\PrestaShop\Core\Module\WidgetInterface;
use Symfony\Component\Validator\Constraints\Url;
use Symfony\Component\Validator\Validation;

// Use autoload ..?
require_once 'classes/mmi_module.php';

class MMI_CustomerVerif extends MMI_Module
{
	const TPL_ADMIN = 'module:mmi_customerverif/views/templates/admin/config.tpl';

	const PARAMETERS_PREFIX = 'MMI_CUSTOMERVERIF_';
	const PARAMETERS = [
		'addr'=>[
			'type'=>'bool',
			'form_type'=>'radio',
			//'sf_constraint'=>'Url',
			'label'=>'Doublon d\'adresse',
			'desc'=> 'Vérification des doublons d\'adresse postale',
		],
	];
	
	const TRANS_PREFIX = 'MMICustomerVerif';
	
	const FOLDER_PREFIX = 'mmi_customerverif';
	
	const HOOKS = [
		'actionCustomerAccountAdd',
	];
	
	// Info
	const NAME = 'mmi_customerverif';
	const TAB = 'administration';
	const VERSION = '1.0.0';
	const IS_CONFIGURABLE = 1;
	const NEED_INSTANCE = 0;
	const BOOTSTRAP = true;
	const DISPLAY_NAME = 'Vérification client';
	const DESCRIPTION = 'Gestion des doublons, etc.';
	const MODULE_KEY = '';
	const VERSION_PS_MIN = '1.7';
	
	/* HOOKS */

	public function hookActionCustomerAccountAdd($param)
	{
		/* Place your code here. */
		//var_dump($param);
	}
}
