<?php

// GET to POST (for easy tests)
foreach(['id', 'ids', 'days', 'onlynew'] as $i)
    if (!isset($_POST[$i]) && isset($_GET[$i]))
        $_POST[$i] = $_GET[$i];

// Sync list ids
if (!empty($_POST['ids']) && is_array($ids=$_POST['ids'])) {
    foreach($ids as $id) if (is_numeric($id)) {
        devis_form_send($id);
    }
}
// Sync id
if (!empty($_POST['id']) && is_numeric($id=$_POST['id'])) {
    devis_form_send($id);
}
// Sync last days
if (!empty($_POST['days']) && is_numeric($days=$_POST['days'])) {
    $sql = 'SELECT id_gformrequest as id
        FROM '.DB_P_PREFIX.'gformrequest
        WHERE DATEDIFF(date_add, NOW()) >= -'.$days;
    $q = DB::p_select($sql);
    while($row=$q->fetch_assoc()) {
        var_dump($row);
        devis_form_send($row['id'], ['onlynew'=>!empty($_POST['onlynew'])]);
    }
}

function devis_form_send($id, $options=NULL)
{
    $sql = 'SELECT r.*
        FROM '.DB_P_PREFIX.'gformrequest r
        INNER JOIN '.DB_P_PREFIX.'gformbuilderpro f ON f.id_gformbuilderpro = r.id_gformbuilderpro
        INNER JOIN '.DB_P_PREFIX.'gformbuilderpro_lang fl ON fl.id_gformbuilderpro = r.id_gformbuilderpro AND fl.id_lang='.P_LANG_ID.'
        WHERE fl.title LIKE "% devis%" AND r.id_gformrequest='.$id;
    $q = DB::p_select($sql);
    if(!($row=$q->fetch_assoc()))
        die('NADA');

    var_dump($row);
    // id request
    $row['id_gformrequest'];
    // id modèle form
    $row['id_gformbuilderpro'];
    // email client sender
    $row['sender'];
    // subject : nom form
    $row['subject'];
    // date
    $row['date_add'];
    // IP
    $row['user_ip'];
    // json request
    $request = json_decode($row['jsonrequest'], true);
    var_dump($request);

    $fields_input = [
        'gender',
        'lastname',
        'firstname',
        'address',
        'postalcode',
        'city',
        'email',
        'phone1',
        'phone2',
        'demand', // détails texte
    ];
    $a = [];
    foreach($fields_input as $fieldname)
        $a[$fieldname] = (isset($request['{'.$fieldname.'_input}']) ?$request['{'.$fieldname.'_input}'] :'');
    $fields = [
        'product_name', // label product
        'pays', // Label Pays
        'fileupload', // contient un nom de fichier présent dans upload/ à mettre dans 
    ];
    foreach($fields as $fieldname) {
        if (isset($request['{'.$fieldname.'}']))
            $a[$fieldname] = $request['{'.$fieldname.'}'];
    }

    var_dump($a);

    // Recherche client déjà présent

    $sql = 'SELECT c.*
        FROM '.DB_D_PREFIX.'societe c
        WHERE c.email LIKE "%'.$a['email'].'%"
        LIMIT 1';
    $q = DB::D_select($sql);
    if($societe=$q->fetch_assoc())
        var_dump($societe);

    // Recherche adresse déjà présente

    $sql = 'SELECT c.*
        FROM '.DB_D_PREFIX.'socpeople c
        WHERE c.email LIKE "%'.$a['email'].'%"
        LIMIT 1';
    $q = DB::D_select($sql);
    if($socpeople=$q->fetch_assoc()) {
        var_dump($socpeople);
        if (empty($societe)) {
            $societe = ['rowid'=>$socpeople['fk_soc']];
        }
    }

    // Si onlynew on stoppe
    if (!empty($options['onlynew']) && !empty($societe)) {
        echo '<p>STOP onlynew</p>';
        return;
    }

    // Création Client

    $ts = date('Y-m-d H:i:s');
    $date = substr($ts, 0, 10);
    $nb = sync::_class('customer', 'pd')::d_ref_nb();
    $nb++;
    for ($i=strlen($nb); $i<6; $i++)
        $nb = '0'.$nb;

    if (empty($societe)) {
        if (!empty($a['pays']) && is_string($a['pays'])) {
            $sql = 'SELECT c.iso_code
                FROM `'.DB_P_PREFIX.'country` c
                INNER JOIN  `'.DB_P_PREFIX.'country_lang` cl ON cl.id_country=c.id_country
                WHERE cl.`name` LIKE "'.DB::string_escape($a['pays']).'"';
            $q = DB::p_select($sql);
            if ($q->num_rows) {
                list($code_pays) = $q->fetch_row();
                $sql = 'SELECT rowid
                    FROM `'.DB_D_PREFIX.'c_country` c
                    WHERE c.`code` LIKE "'.DB::string_escape($code_pays).'"';
                $q = DB::d_select($sql);
                if ($q->num_rows)
                    list($fk_pays) = $q->fetch_row();
                else
                    $fk_pays = 1;
            }
            else
                $fk_pays = 1;
        }
        else {
            $fk_pays = 1;
        }
        $societe = [
            //'rowid' => NULL,
            'nom' => $a['lastname'].' '.$a['firstname'],
            'name_alias' => NULL,
            'entity' => 1,
            'ref_ext' => NULL,
            'ref_int' => NULL,
            'statut' => 0,
            'parent' => NULL,
            'status' => 1,
            'code_client' => 'CU'.substr($date, 2, 2).substr($date, 5, 2).'-'.$nb,
            'code_fournisseur' => NULL,
            'code_compta' => NULL,
            'code_compta_fournisseur' => NULL,
            'address' => $a['address'],
            'zip' => $a['postalcode'],
            'town' => $a['city'],
            'fk_departement' => NULL,
            'fk_pays' => $fk_pays,
            'fk_account' => NULL,
            'phone' => $a['phone1'],
            'fax' => $a['phone2'],
            'url' => NULL,
            'email' => $a['email'],
            // 'socialnetworks' => NULL,
            // 'skype' => NULL,
            // 'twitter' => NULL,
            // 'facebook' => NULL,
            // 'linkedin' => NULL,
            // 'instagram' => NULL,
            // 'snapchat' => NULL,
            // 'googleplus' => NULL,
            // 'youtube' => NULL,
            // 'whatsapp' => NULL,
            'fk_effectif' => NULL,
            'fk_typent' => 0,
            'fk_forme_juridique' => NULL,
            'fk_currency' => NULL,
            'siren' => '',
            'siret' => NULL,
            'ape' => NULL,
            'idprof4' => '',
            'idprof5' => '',
            'idprof6' => '',
            'tva_intra' => '',
            'capital' => NULL,
            'fk_stcomm' => 0,
            'note_private' => NULL,
            'note_public' => NULL,
            'model_pdf' => NULL,
            'prefix_comm' => NULL,
            'client' => 1,
            'fournisseur' => 0,
            'supplier_account' => NULL,
            'fk_prospectlevel' => '',
            'fk_incoterms' => 0,
            'location_incoterms' => NULL,
            'customer_bad' => 0,
            'customer_rate' => 0,
            'supplier_rate' => 0,
            'remise_client' => 0,
            'remise_supplier' => 0,
            'mode_reglement' => NULL,
            'cond_reglement' => NULL,
            'mode_reglement_supplier' => NULL,
            'cond_reglement_supplier' => NULL,
            'fk_shipping_method' => NULL,
            'tva_assuj' => 1,
            'localtax1_assuj' => NULL,
            'localtax1_value' => 0,
            'localtax2_assuj' => NULL,
            'localtax2_value' => 0,
            'barcode' => NULL,
            'fk_barcode_type' => 0,
            'price_level' => NULL,
            'outstanding_limit' => NULL,
            'order_min_amount' => NULL,
            'supplier_order_min_amount' => NULL,
            'default_lang' => NULL,
            'logo' => NULL,
            'logo_squarred' => NULL,
            'canvas' => NULL,
            'webservices_url' => NULL,
            'webservices_key' => NULL,
            'tms' => $ts,
            'datec' => $ts,
            'fk_user_creat' => sync::D_K_USER,
            'fk_user_modif' => sync::D_K_USER,
            'fk_multicurrency' => 0,
            'multicurrency_code' => '',
            'import_key' => NULL,
            'transport_mode' => NULL,
            'transport_mode_supplier' => NULL,
            'fk_warehouse' => NULL,
            'accountancy_code_sell' => NULL,
            'accountancy_code_buy' => NULL,
        ];
        $societe_extrafields = [
            'p_lastname' => $a['lastname'],
            'p_firstname' => $a['firstname'],
            'p_company' => NULL,
        ];
        var_dump($societe);
        if ($id = DB::d_insert_row('societe', $societe)) {
            $societe['rowid'] = $id;
            $societe_extrafields['fk_object'] = $id;
            DB::d_insert_row('societe_extrafields', $societe_extrafields);
            sync::_action('customer', 'dp', 'osync', 'societe', $id);
        }
        else {
            // @todo email anomalie synchro
        }
    };

    $origin = 'SRC_PS_DEVIS';
    $sql = 'SELECT c.rowid
        FROM `'.DB_D_PREFIX.'c_input_reason` c
        WHERE c.`code` = "'.$origin.'"';
    $q = DB::d_select($sql);
    if ($q->num_rows)
        list($fk_origin) = $q->fetch_row();
    else
        $fk_origin = 0;

    $propal = [
        //'rowid' => NULL,
        'ref' => '(PROV)',
        'entity' => 1,
        'ref_ext' => NULL,
        'ref_int' => NULL,
        'ref_client' => $a['product_name'],
        'fk_soc' => $societe['rowid'],
        'fk_projet' => NULL,
        'tms' => $ts,
        'datec' => $ts,
        'datep' => $date,
        'fin_validite' => NULL,
        'date_valid' => NULL,
        'date_signature' => NULL,
        'date_cloture' => NULL,
        'fk_user_author' => sync::D_K_USER,
        'fk_user_modif' => NULL,
        'fk_user_valid' => NULL,
        'fk_user_signature' => NULL,
        'fk_user_cloture' => NULL,
        'fk_statut' => 0,
        'price' => 0,
        'remise_percent' => NULL,
        'remise_absolue' => NULL,
        'remise' => 0,
        'total_ht' => 0,
        'total_tva' => 0,
        'localtax1' => 0,
        'localtax2' => 0,
        'total_ttc' => 0,
        'fk_account' => NULL,
        'fk_currency' => NULL,
        'fk_cond_reglement' => NULL,
        'fk_mode_reglement' => NULL,
        'note_private' => NULL,
        'note_public' => '',
        'model_pdf' => 'azur',
        'last_main_doc' => NULL,
        'date_livraison' => NULL,
        'fk_shipping_method' => NULL,
        'fk_warehouse' => NULL,
        'fk_availability' => 0,
        'fk_input_reason' => $fk_origin,
        'fk_incoterms' => 0,
        'location_incoterms' => '',
        'import_key' => NULL,
        'extraparams' => NULL,
        'fk_delivery_address' => NULL,
        'fk_multicurrency' => 0,
        'multicurrency_code' => 'EUR',
        'multicurrency_tx' => 1,
        'multicurrency_total_ht' => 0,
        'multicurrency_total_tva' => 0,
        'multicurrency_total_ttc' => 0,
    ];
    var_dump($propal);
    $propal_line = [
        //'rowid' => NULL,
        'fk_propal' => NULL,
        'fk_parent_line' => NULL,
        'fk_product' => NULL,
        'label' => 'Votre demande',
        'description' => $a['demand'],
        'fk_remise_except' => NULL,
        'vat_src_code' => '',
        'tva_tx' => 0,
        'localtax1_tx' => 0,
        'localtax1_type' => 0,
        'localtax2_tx' => 0,
        'localtax2_type' => 0,
        'qty' => 0,
        'remise_percent' => 0,
        'remise' => 0,
        'price' => NULL,
        'subprice' => 0,
        'total_ht' => 0,
        'total_tva' => 0,
        'total_localtax1' => 0,
        'total_localtax2' => 0,
        'total_ttc' => 0,
        'product_type' => 9,
        'date_start' => NULL,
        'date_end' => NULL,
        'info_bits' => 0,
        'buy_price_ht' => 0,
        'fk_product_fournisseur_price' => NULL,
        'special_code' => 1790,
        'rang' => 1,
        'fk_unit' => NULL,
        'fk_multicurrency' => NULL,
        'multicurrency_code' => 'EUR',
        'multicurrency_subprice' => 0,
        'multicurrency_total_ht' => 0,
        'multicurrency_total_tva' => 0,
        'multicurrency_total_ttc' => 0,
    ];
    var_dump($propal_line);

    if ($id = DB::d_insert_row('propal', $propal)) {
        $propal['rowid'] = $id;
        $propal['ref'] = '(PROV'.$id.')';
        DB::d_update_row('propal', ['ref' => '(PROV'.$id.')'], ['rowid'=>$id]);

        $propal_line['fk_propal'] = $id;
        DB::d_insert_row('propaldet', $propal_line);

        var_dump($a);
        if (!empty($a['fileupload']) && file_exists(P_FOLDER_ROOT.'/upload/'.$a['fileupload'])) {
            if (!file_exists(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'])) {
                mkdir(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'], 0777);
                chmod(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'], 0777);
            }
            copy(P_FOLDER_ROOT.'/upload/'.$a['fileupload'], D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'].'/'.$propal['ref'].'-'.$a['fileupload']);
            chmod(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'].'/'.$propal['ref'].'-'.$a['fileupload'], 0666);
        }
    }
}
