<?php

//var_dump($_GET); var_dump($_POST); var_dump($_FILES);


class csv_file
{
	const FOLDER = '../data/facebook_leads';
	
	const FB_FIELDS = [
		'id',
		'created_time',
		'ad_id',
		'ad_name',
		'adset_id',
		'adset_name',
		'campaign_id',
		'campaign_name',
		'form_id',
		'form_name',
		'is_organic',
		'platform',
	];
	const CA_FIELDS = [
		'nom_de_famille' => ['nom_de_famille', 'last_name'],
		'prénom' => ['prénom', 'first_name'],
		'numéro_de_téléphone' => ['numéro_de_téléphone', 'phone_number'],
		'adresse' => ['adresse', 'street_address'],
		'ville' => ['ville', 'city'],
		'code_postal' => ['code_postal', 'post_code'],
		'e-mail' => ['e-mail', 'email'],
	];
	const AD_FIELDS = [
		'ag:23851183027460742' => [
			'label' => 'Volet Piscine',
			'fields' => [
				'dimensions_de_votre_piscine_?',
				'forme_de_votre_piscine_?',
				'présence_d\'un_escalier_?',
				'votre_traitement_d\'eau_?',
				'quel_type_de_volet_vous_intéresse_?',
			],
		],
		'ag:23851276817520742' => [
			'label' => 'Abri Piscine',
			'fields' => [
				'dimensions_de_votre_piscine_?',
				'forme_de_votre_piscine_?',
				'présence_d\'un_escalier_?',
				'quel_type_d\'abri_vous_intéresse_?',
				'quel_type_de_parois_pour_votre_abri_?',
				'souhaitez-vous_que_l’abri_découvre_entièrement_votre_piscine_?',
				'abri_en_kit_ou_pré-monté_?',
				'plage_de_votre_piscine_?',
			],
		],
		'ag:23851276890500742' => [
			'label' => 'Couverture à barres Piscine',
			'fields' => [
				'dimensions_de_votre_piscine_?',
				'forme_de_votre_piscine_?',
				'présence_d’un_escalier_ou_d’une_échelle_?',
				'nature_des_plages_de_votre_piscine_?',
				'avez-vous_besoin_de_la_couverture_assez_rapidement_?',
			],
		],
		'ag:23851592274860742' => [
			'label' => 'Abri Piscine',
			'fields' => [
				'quel_type_d\'abri_vous_intéresse_?',
				'dimensions_de_votre_piscine__?',
				'souhaitez-vous_que_l’abri_découvre_entièrement_votre_piscine_?',
			],
		],
		'ag:23851592613260742' => [
			'label' => "Publicité de Prospects Volet",
			'fields' => [
				'dimensions_de_votre_piscine_?',
				'forme_de_votre_piscine_?',
				'présence_d\'un_escalier_?',
				'votre_traitement_d\'eau_?',
				'quel_type_de_volet_vous_intéresse_?',
			],
		],
		'ag:23852302741080742' => [
			'label' => "Publicité de Prospects Volet Video",
			'fields' => [
				'dimensions_de_votre_piscine_?',
				'forme_de_votre_piscine_?',
				'présence_d\'un_escalier_?',
				'votre_traitement_d\'eau_?',
				'quel_type_de_volet_vous_intéresse_?',
			],
		],
		'ag:23852396278340742' => [
			'label' => "Publicité de Prospects Abri",
			'fields' => [
				"quel_type_d'abri_vous_intéresse_?",
				"dimensions_de_votre_piscine__?",
				"souhaitez-vous_que_l’abri_découvre_entièrement_votre_piscine_?",
			], 
		],
	];

	Const PROPAL_ORIGIN = 'SRC_FB_FORM';
	protected static $fk_origin;

	static function __init()
	{
		//var_dump(static::FIELDS);

		$sql = 'SELECT i.rowid
			FROM `'.DB_D_PREFIX.'c_input_reason` i
			WHERE i.`code` = "'.static::PROPAL_ORIGIN.'"
				AND i.active=1';
		//echo $sql;
		$q = DB::d_select($sql);
		if ($q->num_rows)
			list(static::$fk_origin) = $q->fetch_row();
	}

	static function file_read($filename)
	{
		$lines = [];

		$file = fopen($filename, 'r');
		while (!feof($file) ) {
			$lines[] = fgetcsv($file, NULL, "\t");
		}
		fclose($file);

		return $lines;
	}

	static function file_import($filename)
	{
		$newfilename = static::FOLDER.'/'.time().'.csv';
		move_uploaded_file($filename, $newfilename);
		//var_dump($newfilename);

		$filedata = file_get_contents($newfilename);
		if (isset($_POST['utf-16']))
			$filedata = iconv('utf-16', 'utf-8', $filedata);
		file_put_contents($newfilename, $filedata);
		//echo mb_detect_encoding($filedata); die();

		$lines = static::file_read($newfilename);
		if (empty($lines)) {
			echo '<p>Fichier vide</p>';
			return;
		}
		$fields = array_shift($lines);
		//var_dump($fields);
		if (empty($lines)) {
			echo '<p>Tableau vide</p>';
			return;
		}
		//var_dump($lines);

		$ad_id = $lines[0][2];
		$form_id = '';
		if (empty(static::AD_FIELDS[$ad_id])) {
			echo '<p>Paramétrage inconnu : '.$ad_id.'</p>';
		//	return;
		}
		else {
			echo '<p>Paramétrage trouvé : '.static::AD_FIELDS[$ad_id]['label'].'</p>';
		}

		$fields_ad = [];
		foreach($fields as $i=>$fieldname) {
			if (in_array($fieldname, static::FB_FIELDS))
				continue;
			foreach(static::CA_FIELDS as $j) {
				//var_dump($fieldname, $j);
				if (in_array($fieldname, $j))
					continue 2;
			}
			// AD-Specific
			$fields_ad[$i] = $fieldname;
		}
		//var_dump($fields_ad); die();

		// Analyse champs
		// Champs FB principaux
		foreach(static::FB_FIELDS as $col) {
			if (!in_array($col, $fields)) {
				echo '<p>Colonnes principale manquante : '.$col.'</p>';
				return;
			}
		}
		// Champs FB Contact
		foreach(static::CA_FIELDS as $colref=>$cols) {
			$ok = false;
			foreach($cols as $col) {
				if (($i = array_search($col, $fields, true)) !== false) {
					$ok = true;
					// On renomme le champ pour le retrouver correctement plus loin
					$fields[$i] = $colref;
					break;
				}
			}
			if (!$ok) {
				echo '<p>Colonnes contact manquante : '.$colref.' ('.implode(', ', $col).')</p>';
				return;
			}
		}

		// Useless
		if (false) foreach(static::AD_FIELDS[$ad_id]['fields'] as $field) {
			// On s'en cogne ..?
			break;

			echo '<p>Colonnes non conformes</p>';
			return;
		}

		echo '<p>'.count($lines).' lignes à importer</p>';

		foreach($lines as $line) {
			static::line_import($line, $fields, $fields_ad);
		}

	}

	static function line_import($line, $fields, $fields_ad=[])
	{
		//var_dump($line);
		if (empty($line)) {
			echo '<p>Ligne vide</p>';
			return;
		}

		$row = [];
		foreach($fields as $i=>$name) {
			$row[$name] = $line[$i];
		}

		$ad_id = $line[2];
		if (isset(static::AD_FIELDS[$ad_id])) {
			$ad_label = static::AD_FIELDS[$ad_id]['label'];
			$ad_fields = static::AD_FIELDS[$ad_id]['fields'];
		}
		if (empty($ad_label))
			$ad_label = $row['form_name'];
		if (!empty($fields_ad))
			$ad_fields = $fields_ad;

		//var_dump($line, $row); die();

		// Recherche import déjà effectué

		$sql = 'SELECT 1
			FROM '.DB_D_PREFIX.'propal_extrafields p2
			INNER JOIN '.DB_D_PREFIX.'propal p ON p.rowid=p2.fk_object
			WHERE p2.fk_origin_id="'.$row['id'].'"';
		$q = DB::D_select($sql);
		if($q->num_rows) {
			echo '<p>Déjà importé : ID '.$row['id'].'</p>';
			return;
		}

		// Recherche client déjà présent

		$sql = 'SELECT c.*
			FROM '.DB_D_PREFIX.'societe c
			WHERE c.email LIKE "%'.$row['e-mail'].'%"
			LIMIT 1';
		$q = DB::D_select($sql);
		if($societe=$q->fetch_assoc()) {
			echo '<p>Société déjà en base</p>';
			//var_dump($societe);
		}
		// Recherche adresse déjà présente

		$sql = 'SELECT c.*
			FROM '.DB_D_PREFIX.'socpeople c
			WHERE c.email LIKE "%'.$row['e-mail'].'%"
			LIMIT 1';
		$q = DB::D_select($sql);
		if($socpeople=$q->fetch_assoc()) {
			echo '<p>Contact déjà en base</p>';
			//var_dump($socpeople);
			if (empty($societe)) {
				$societe = ['rowid'=>$socpeople['fk_soc']];
			}
		}

		// Création Client

		$ts = date('Y-m-d H:i:s');
		$date = substr($ts, 0, 10);
		$nb = sync::_class('customer', 'pd')::d_ref_nb();
		$nb++;
		for ($i=strlen($nb); $i<6; $i++)
			$nb = '0'.$nb;

		if (empty($societe)) {
			$cpe = explode(':', $row['code_postal']);
			$cp = $cpe[count($cpe)-1];
			if (empty($code_pays) && count($cpe)==3 && is_string($cpe[1]) && strlen($cpe[1])==2) {
				$code_pays = $cpe[1];
			}
			// Normalement 25 mais on va restreindre un peu plus
			if (strlen($cp)>20) {
				$cp = substr($cp, 0, 20);
			}

			if (!empty($row['pays']) && is_string($row['pays'])) {
				$sql = 'SELECT c.iso_code
					FROM `'.DB_P_PREFIX.'country` c
					INNER JOIN  `'.DB_P_PREFIX.'country_lang` cl ON cl.id_country=c.id_country
					WHERE cl.`name` LIKE "'.DB::string_escape($row['pays']).'"';
				$q = DB::p_select($sql);
				if ($q->num_rows)
					list($code_pays) = $q->fetch_row();
			}

			if (!empty($code_pays) && is_string($code_pays)) {
				$sql = 'SELECT rowid
					FROM `'.DB_D_PREFIX.'c_country` c
					WHERE c.`code` LIKE "'.DB::string_escape($code_pays).'"';
				$q = DB::d_select($sql);
				if ($q->num_rows)
					list($fk_pays) = $q->fetch_row();
				else
					$fk_pays = 1;
			}
			else {
				$fk_pays = 1;
			}

			$societe = [
				//'rowid' => NULL,
				'nom' => $row['nom_de_famille'].' '.$row['prénom'],
				'name_alias' => NULL,
				'entity' => 1,
				'ref_ext' => NULL,
				'ref_int' => NULL,
				'statut' => 0,
				'parent' => NULL,
				'status' => 1,
				'code_client' => 'CU'.substr($date, 2, 2).substr($date, 5, 2).'-'.$nb,
				'code_fournisseur' => NULL,
				'code_compta' => NULL,
				'code_compta_fournisseur' => NULL,
				'address' => $row['adresse'],
				'zip' => $cp,
				'town' => $row['ville'],
				'fk_departement' => NULL,
				'fk_pays' => $fk_pays,
				'fk_account' => NULL,
				'phone' => str_replace('p:', '', $row['numéro_de_téléphone']),
				'fax' => NULL,
				'url' => NULL,
				'email' => $row['e-mail'],
				// 'socialnetworks' => NULL,
				// 'skype' => NULL,
				// 'twitter' => NULL,
				// 'facebook' => NULL,
				// 'linkedin' => NULL,
				// 'instagram' => NULL,
				// 'snapchat' => NULL,
				// 'googleplus' => NULL,
				// 'youtube' => NULL,
				// 'whatsapp' => NULL,
				'fk_effectif' => NULL,
				'fk_typent' => 0,
				'fk_forme_juridique' => NULL,
				'fk_currency' => NULL,
				'siren' => '',
				'siret' => NULL,
				'ape' => NULL,
				'idprof4' => '',
				'idprof5' => '',
				'idprof6' => '',
				'tva_intra' => '',
				'capital' => NULL,
				'fk_stcomm' => 0,
				'note_private' => NULL,
				'note_public' => NULL,
				'model_pdf' => NULL,
				'prefix_comm' => NULL,
				'client' => 2, // 2 => Prospect
				'fournisseur' => 0,
				'supplier_account' => NULL,
				'fk_prospectlevel' => '',
				'fk_incoterms' => 0,
				'location_incoterms' => NULL,
				'customer_bad' => 0,
				'customer_rate' => 0,
				'supplier_rate' => 0,
				'remise_client' => 0,
				'remise_supplier' => 0,
				'mode_reglement' => NULL,
				'cond_reglement' => NULL,
				'mode_reglement_supplier' => NULL,
				'cond_reglement_supplier' => NULL,
				'fk_shipping_method' => NULL,
				'tva_assuj' => 1,
				'localtax1_assuj' => NULL,
				'localtax1_value' => 0,
				'localtax2_assuj' => NULL,
				'localtax2_value' => 0,
				'barcode' => NULL,
				'fk_barcode_type' => 0,
				'price_level' => NULL,
				'outstanding_limit' => NULL,
				'order_min_amount' => NULL,
				'supplier_order_min_amount' => NULL,
				'default_lang' => NULL,
				'logo' => NULL,
				'logo_squarred' => NULL,
				'canvas' => NULL,
				'webservices_url' => NULL,
				'webservices_key' => NULL,
				'tms' => $ts,
				'datec' => $ts,
				'fk_user_creat' => sync::D_K_USER,
				'fk_user_modif' => sync::D_K_USER,
				'fk_multicurrency' => 0,
				'multicurrency_code' => '',
				'import_key' => NULL,
				'transport_mode' => NULL,
				'transport_mode_supplier' => NULL,
				'fk_warehouse' => NULL,
				'accountancy_code_sell' => NULL,
				'accountancy_code_buy' => NULL,
			];
			$societe_extrafields = [
				//'fk_object' => ,
				'p_lastname' => $row['nom_de_famille'],
				'p_firstname' => $row['prénom'],
				'p_company' => NULL,
				'p_group' => 1,
			];
			$socpeople = [
				//'rowid' => NULL,
				'datec' => $date,
				'tms' => $ts,
				//'fk_soc' => static::_pd_map_fk_soc($p_data),
				'entity' => 1,
				'ref_ext' => '',
				'civility' => '',
				'lastname' => $row['nom_de_famille'],
				'firstname' => $row['prénom'],
				'address' => $row['adresse'],
				'zip' => $cp,
				'town' => $row['ville'],
				//'fk_departement' => NULL,
				'fk_pays' => $fk_pays,
				//'birthday' => (isset($p_data['customer']['birthday']) ?$p_data['customer']['birthday'] :NULL),
				'poste' => '',
				'phone' => str_replace('p:', '', $row['numéro_de_téléphone']),
				'phone_perso' => '',
				//'phone_mobile' => $p_data['address']['phone_mobile'],
				'fax' => '',
				'email' => $row['e-mail'],
				//'socialnetworks' => '[]',
				//'jabberid' => NULL,
				//'skype' => NULL,
				//'twitter' => NULL,
				//'facebook' => NULL,
				//'linkedin' => NULL,
				//'instagram' => NULL,
				//'snapchat' => NULL,
				//'googleplus' => NULL,
				//'youtube' => NULL,
				//'whatsapp' => NULL,
				'photo' => '',
				'no_email' => 0,
				'priv' => 0,
				'fk_user_creat' => sync::D_K_USER,
				'fk_user_modif' => sync::D_K_USER,
				//'note_private' => NULL,
				//'note_public' => NULL,
				//'default_lang' => NULL,
				//'canvas' => NULL,
				//'import_key' => NULL,
				'statut' => 1,
				//'fk_prospectcontactlevel' => NULL,
				'fk_stcommcontact' => 0,
			];
			$socpeople_extrafields = [
				'p_deleted' => 0,
				'p_alias' => 'adresse',
				'p_address2' => '',
				'p_company' => '',
			];
			//var_dump($societe);
			if ($id = DB::d_insert_row('societe', $societe)) {
				$societe['rowid'] = $id;
				$societe_extrafields['fk_object'] = $id;
				DB::d_insert_row('societe_extrafields', $societe_extrafields);
				// Socpeople
				$socpeople['fk_soc'] = $id;
				$sid = DB::d_insert_row('socpeople', $socpeople);
				$socpeople_extrafields['fk_object'] = $sid;
				DB::d_insert_row('socpeople_extrafields', $socpeople_extrafields);
				sync::_action('customer', 'dp', 'osync', 'societe', $id);
				sync::_action('address', 'dp', 'osync', 'socpeople', $sid);
			}
			else {
				// @todo email anomalie synchro
			}
		};

		/*
			'dimensions_de_votre_piscine_?' => string '9x4,5' (length=5)
			'forme_de_votre_piscine_?' => string 'rectangle' (length=9)
			'présence_d'un_escalier_?' => string 'oui,_situé_sur_la_largeur_du_bassin' (length=36)
			'votre_traitement_d'eau_?' => string 'electrolyseur_au_sel' (length=20)
			'quel_type_de_volet_vous_intéresse_?' => string 'hors-sol' (length=8)
		*/

		$ref_client = $ad_label;
		$demande = '';
		foreach ($ad_fields as $f)
			$demande .= $f.' : '.$row[$f]."<br />\r\n";

		$propal = [
			//'rowid' => NULL,
			'ref' => '(PROV)',
			'entity' => 1,
			'ref_ext' => NULL,
			'ref_int' => NULL,
			'ref_client' => $ref_client,
			'fk_soc' => $societe['rowid'],
			'fk_projet' => NULL,
			'tms' => $ts,
			'datec' => $ts,
			'datep' => $date,
			'fin_validite' => NULL,
			'date_valid' => NULL,
			'date_signature' => NULL,
			'date_cloture' => NULL,
			'fk_user_author' => sync::D_K_USER,
			'fk_user_modif' => NULL,
			'fk_user_valid' => NULL,
			'fk_user_signature' => NULL,
			'fk_user_cloture' => NULL,
			'fk_statut' => 0,
			'price' => 0,
			'remise_percent' => NULL,
			'remise_absolue' => NULL,
			'remise' => 0,
			'total_ht' => 0,
			'total_tva' => 0,
			'localtax1' => 0,
			'localtax2' => 0,
			'total_ttc' => 0,
			'fk_account' => NULL,
			'fk_currency' => NULL,
			'fk_cond_reglement' => NULL,
			'fk_mode_reglement' => NULL,
			'note_private' => NULL,
			'note_public' => '',
			'model_pdf' => 'azur',
			'last_main_doc' => NULL,
			'date_livraison' => NULL,
			'fk_shipping_method' => NULL,
			'fk_warehouse' => NULL,
			'fk_availability' => 0,
			'fk_input_reason' => static::$fk_origin,
			'fk_incoterms' => 0,
			'location_incoterms' => '',
			'import_key' => NULL,
			'extraparams' => NULL,
			'fk_delivery_address' => NULL,
			'fk_multicurrency' => 0,
			'multicurrency_code' => 'EUR',
			'multicurrency_tx' => 1,
			'multicurrency_total_ht' => 0,
			'multicurrency_total_tva' => 0,
			'multicurrency_total_ttc' => 0,
		];
		$propal_extrafields = [
			//'rowid' => NULL//
			'tms' => $ts,
			'fk_object' => NULL,
			'fk_origin_id' => $row['id'],
		];
		//var_dump($propal);
		$propal_line = [
			//'rowid' => NULL,
			'fk_propal' => NULL,
			'fk_parent_line' => NULL,
			'fk_product' => NULL,
			'label' => 'Votre demande',
			'description' => $demande,
			'fk_remise_except' => NULL,
			'vat_src_code' => '',
			'tva_tx' => 0,
			'localtax1_tx' => 0,
			'localtax1_type' => 0,
			'localtax2_tx' => 0,
			'localtax2_type' => 0,
			'qty' => 0,
			'remise_percent' => 0,
			'remise' => 0,
			'price' => NULL,
			'subprice' => 0,
			'total_ht' => 0,
			'total_tva' => 0,
			'total_localtax1' => 0,
			'total_localtax2' => 0,
			'total_ttc' => 0,
			'product_type' => 9,
			'date_start' => NULL,
			'date_end' => NULL,
			'info_bits' => 0,
			'buy_price_ht' => 0,
			'fk_product_fournisseur_price' => NULL,
			'special_code' => 1790,
			'rang' => 1,
			'fk_unit' => NULL,
			'fk_multicurrency' => NULL,
			'multicurrency_code' => 'EUR',
			'multicurrency_subprice' => 0,
			'multicurrency_total_ht' => 0,
			'multicurrency_total_tva' => 0,
			'multicurrency_total_ttc' => 0,
		];
		//var_dump($propal_line);
	
		if ($id = DB::d_insert_row('propal', $propal)) {
			$propal['rowid'] = $id;
			$propal['ref'] = '(PROV'.$id.')';
			DB::d_update_row('propal', ['ref' => '(PROV'.$id.')'], ['rowid'=>$id]);
	
			$propal_line['fk_propal'] = $id;
			DB::d_insert_row('propaldet', $propal_line);
	
			$propal_extrafields['fk_object'] = $id;
			DB::d_insert_row('propal_extrafields', $propal_extrafields);
	
			// Fichiers joint
			if (!empty($row['fileupload']) && file_exists(P_FOLDER_ROOT.'/upload/'.$row['fileupload'])) {
				if (!file_exists(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'])) {
					mkdir(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'], 0777);
					chmod(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'], 0777);
				}
				copy(P_FOLDER_ROOT.'/upload/'.$row['fileupload'], D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'].'/'.$propal['ref'].'-'.$row['fileupload']);
				chmod(D_FOLDER_ROOT.'/documents/propale/'.$propal['ref'].'/'.$propal['ref'].'-'.$row['fileupload'], 0666);
			}
		}

		//var_dump($row);
	}
}

csv_file::__init();

if (isset($_GET['file_upload']) && !empty($_FILES['facebook_file'])) {
	echo '<hr />';
	csv_file::file_import($_FILES['facebook_file']['tmp_name']);
}

?>
<hr />
<form method="POST" action="?t=facebook_devis&file_upload" enctype="multipart/form-data">
	<p><input type="checkbox" name="utf-16" checked /> Import par fichier CSV en UTF-16 (format par défaut exporté via Facebook Leads)</p>
	<p><input type="file" name="facebook_file" />
	<input type="submit" name="_file_submit" value="Intégrer le fichier" /></p>
</form>

