<?php

class sync_address_dp extends sync_address
{

// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	$tms = max($d_data['socpeople']['tms'], (!empty($p_data["address"]) ?$p_data['address']['date_upd'] :'0000-00-00'));
	if (empty($d_data['socpeople_extrafields']['p_alias'])) {
		$alias = static::uniqid(16);
		DB::d_update_row('socpeople_extrafields', ['p_alias'=>$alias], ['fk_object'=>$d_data['socpeople_extrafields']['fk_object']]);
	}
	else
		$alias = $d_data['socpeople_extrafields']['p_alias'];

	// Type d'adresse
	if (!empty($p_data['address']['id_supplier']))
		$type = 'supplier';
	elseif (!empty($p_data['address']['id_customer']))
		$type = 'customer';
	elseif (!empty($p_data['address']['id_manufacturer']))
		$type = 'manufacturer';
	elseif (!empty($p_data['address']['id_warehouse']))
		$type = 'warehouse';
	else
		$type = '';
	
	$p_data_map = [
		'address' => [
			'id_country' => static::_dp_map_fk_country($d_data),
			'id_customer' => static::_dp_map_fk_customer($d_data),
			'id_manufacturer' => static::_dp_map_fk_manufacturer($d_data),
			'id_supplier' => static::_dp_map_fk_supplier($d_data),
			'alias' => $alias,
			'lastname' => $type=='supplier' ?'supplier' :$d_data['socpeople']['lastname'],
			'firstname' => $type=='supplier' ?'supplier' :$d_data['socpeople']['firstname'],
			'company' => (!empty($d_data['socpeople_extrafields']['p_company']) ?$d_data['socpeople_extrafields']['p_company'] :''),
			'address1' => (!empty($d_data['socpeople']['address']) ?$d_data['socpeople']['address'] :''),
			'address2' => (!empty($d_data['socpeople_extrafields']['p_address2']) ?$d_data['socpeople_extrafields']['p_address2'] :''),
			'postcode' => $d_data['socpeople']['zip'],
			'city' => $d_data['socpeople']['town'],
			//'other' => '',
			'phone' => (!empty($d_data['socpeople']['phone']) ?$d_data['socpeople']['phone'] :''),
			'phone_mobile' => (!empty($d_data['socpeople']['phone_mobile']) ?$d_data['socpeople']['phone_mobile'] :''),
			'date_upd' => $tms,
			'deleted' => (!empty($d_data['socpeople_extrafields']['p_deleted']) ?1 :0),
		],
	];
	//var_dump($p_data_map);

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	$p_data_map = [
		'address' => [
			//'id_address' => '',
			'id_country' => static::_dp_map_fk_country($d_data),
			'id_state' => static::_dp_map_fk_state($d_data),
			'id_customer' => static::_dp_map_fk_customer($d_data),
			'id_manufacturer' => static::_dp_map_fk_manufacturer($d_data),
			'id_supplier' => static::_dp_map_fk_supplier($d_data),
			'id_warehouse' => 0,
			'alias' => '',
			'company' => '',
			'lastname' => '',
			'firstname' => '',
			'address1' => '',
			'address2' => '',
			'postcode' => '',
			'city' => '',
			'other' => '',
			'phone' => '',
			'phone_mobile' => '',
			'vat_number' => '',
			'dni' => '',
			'date_add' => $d_data['socpeople']['datec'],
			'date_upd' => '0000-00-00 00:00:00',
			'active' => '1',
			'deleted' => '0',
		],
	];

	return $p_data_map;
}

// -----------

// Field MAPPING

public static function _dp_map_fk_customer(&$orig_data, &$dest_tree=[])
{
	if (!$orig_data['societe']['client'])
		return 0;
	return static::_dp_map_fk('customer', 'societe', $orig_data['socpeople']['fk_soc']);
}
public static function _dp_map_fk_manufacturer(&$orig_data, &$dest_tree=[])
{
	if (true) // @todo
		return 0;
	return static::_dp_map_fk('manufacturer', 'societe', $orig_data['socpeople']['fk_soc']);
}
public static function _dp_map_fk_supplier(&$orig_data, &$dest_tree=[])
{
	if (!$orig_data['societe']['fournisseur'])
		return 0;
	return static::_dp_map_fk('supplier', 'societe', $orig_data['socpeople']['fk_soc']);
}

public static function _dp_map_fk_country(&$orig_data, &$dest_tree=[])
{
	static::_country_load();

	if (!empty($orig_data['socpeople']['fk_pays'])) {
		$id_country = $orig_data['socpeople']['fk_pays'];
		if (isset(static::$_dp_country[$id_country]))
			return static::$_dp_country[$id_country];
	}
}

public static function _dp_map_fk_state(&$orig_data, &$dest_tree=[])
{
	return 0; // @todo
}

}

sync_address_dp::__init();
