<?php

class sync_address_pd extends sync_address
{

// -- ACTIONS --

public function pd_execute_delete($otype, $oid)
{
	if (empty($o = static::p_o_oid('address', $otype, $oid)))
		return;
	//ar_dump($o); die();
	
	DB::d_update_row('socpeople_extrafields', ['p_sync'=>0], ['fk_object'=>$o['d_oid']]);
}

// -- SUB ACTIONS --

public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
	$id = $o['d_oid'];
	// @todo
	
	static::d_update_row('socpeople_extrafields', (!empty($d_data['socpeople_extrafields']) ?['rowid'=>$d_data['socpeople_extrafields']['rowid']] :['fk_object'=>$id]), $d_data_map, $d_data_map_create, $d_data);
}

// -- MAPPING --

public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	$tms = max($p_data['address']['date_upd'], (isset($d_data['socpeople']) ?$d_data['socpeople']['tms'] :'0000-00-00'));

	// Type d'adresse
	if (!empty($p_data['address']['id_supplier']))
		$type = 'supplier';
	elseif (!empty($p_data['address']['id_customer']))
		$type = 'customer';
	elseif (!empty($p_data['address']['id_manufacturer']))
		$type = 'manufacturer';
	elseif (!empty($p_data['address']['id_warehouse']))
		$type = 'warehouse';
	else
		$type = '';
	
	$d_data_map = [
		'socpeople' => [
			//'rowid' => NULL,
			//'datec' => $p_data['address']['date_add'],
			'tms' => $tms,
			//'fk_soc' => static::_pd_map_fk_soc($p_data),
			//'entity' => 1,
			//'ref_ext' => '',
			//'civility' => '',
			'lastname' => $type=='supplier' ?$p_data['supplier']['name'] :$p_data['address']['lastname'],
			'firstname' => $type=='supplier' ?'-' :$p_data['address']['firstname'],
			'address' => $p_data['address']['address1'],
			'zip' => $p_data['address']['postcode'],
			'town' => $p_data['address']['city'],
			//'fk_departement' => NULL,
			'fk_pays' => static::_pd_map_fk_pays($p_data),
			//'birthday' => (isset($p_data['customer']['birthday']) ?$p_data['customer']['birthday'] :NULL),
			//'poste' => '',
			'phone' => $p_data['address']['phone'],
			//'phone_perso' => '',
			'phone_mobile' => $p_data['address']['phone_mobile'],
			//'fax' => '',
			//'email' => (isset($p_data['customer']['email']) ?$p_data['customer']['email'] :''),
			//'socialnetworks' => '[]',
			//'jabberid' => NULL,
			//'skype' => NULL,
			//'twitter' => NULL,
			//'facebook' => NULL,
			//'linkedin' => NULL,
			//'instagram' => NULL,
			//'snapchat' => NULL,
			//'googleplus' => NULL,
			//'youtube' => NULL,
			//'whatsapp' => NULL,
			//'photo' => '',
			//'no_email' => 0,
			//'priv' => 0,
			//'fk_user_creat' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			//'note_private' => NULL,
			//'note_public' => NULL,
			//'default_lang' => NULL,
			//'canvas' => NULL,
			//'import_key' => NULL,
			//'statut' => 1,
			//'fk_prospectlevel' => NULL,
			//'fk_stcommcontact' => 0,
		],
		'socpeople_extrafields' => [
			'p_deleted' => (!empty($p_data['address']['deleted']) ?1 :0),
			'p_alias' => $p_data['address']['alias'],
			'p_address2' => $p_data['address']['address2'],
			'p_company' => $p_data['address']['company'],
		],
	];

	// Champs spécifiques Client
	if (isset($p_data['customer'])) {
		$d_data_map['socpeople']['email'] = $p_data['customer']['email'];
		$d_data_map['socpeople']['birthday'] = $p_data['customer']['birthday'];
	}

	return $d_data_map;
}

public function pd_map_create(&$o, &$p_data)
{
	$d_data_map = [
		'socpeople' => [
			//'rowid' => NULL,
			'datec' => $p_data['address']['date_add'],
			//'tms' => $p_data['address']['date_upd'],
			'fk_soc' => static::_pd_map_fk_soc($p_data),
			'entity' => 1,
			'ref_ext' => '',
			'civility' => '',
			//'lastname' => $p_data['address']['lastname'],
			//'firstname' => $p_data['address']['firstname'],
			//'address' => $p_data['address']['address1'].($p_data['address']['address2'] ?"\r\n".$p_data['address']['address2'] :''),
			//'zip' => $p_data['address']['postcode'],
			//'town' => $p_data['address']['city'],
			'fk_departement' => NULL,
			//'fk_pays' => static::_pd_map_fk_pays($p_data),
			//'birthday' => (isset($p_data['customer']['birthday']) ?$p_data['customer']['birthday'] :NULL),
			'poste' => '',
			//'phone' => $p_data['address']['phone'],
			'phone_perso' => '',
			//'phone_mobile' => $p_data['address']['phone_mobile'],
			'fax' => '',
			//'email' => (isset($p_data['customer']['email']) ?$p_data['customer']['email'] :''),
			// 'socialnetworks' => '[]',
			// 'jabberid' => NULL,
			// 'skype' => NULL,
			// 'twitter' => NULL,
			// 'facebook' => NULL,
			// 'linkedin' => NULL,
			// 'instagram' => NULL,
			// 'snapchat' => NULL,
			// 'googleplus' => NULL,
			// 'youtube' => NULL,
			// 'whatsapp' => NULL,
			'photo' => '',
			'no_email' => 0,
			'priv' => 0,
			'fk_user_creat' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			'note_private' => NULL,
			'note_public' => NULL,
			'default_lang' => NULL,
			'canvas' => NULL,
			'import_key' => NULL,
			'statut' => 1,
			//'fk_prospectlevel' => NULL,
			'fk_stcommcontact' => 0,
		],
		'socpeople_extrafields' => [
			//'p_deleted' => (!empty($p_data['address']['deleted']) ?1 :0),
		]
	];

	return $d_data_map;
}

// -----------

// Field MAPPING

public static function _pd_map_fk_soc(&$orig_data, &$dest_tree=[])
{
	if (!empty($orig_data['address']['id_supplier']))
		return static::_pd_map_fk('supplier', 'supplier', $orig_data['address']['id_supplier']);
	if (!empty($orig_data['address']['id_customer']))
		return static::_pd_map_fk('customer', 'customer', $orig_data['address']['id_customer']);
	if (!empty($orig_data['address']['id_manufacturer']))
		return static::_pd_map_fk('manufacturer', 'manufacturer', $orig_data['address']['id_manufacturer']);
	if (!empty($orig_data['address']['id_warehouse']))
		return static::_pd_map_fk('warehouse', 'warehouse', $orig_data['address']['id_warehouse']);
}

public static function _pd_map_fk_pays(&$orig_data, &$dest_tree=[])
{
	static::_country_load();

	if (!empty($orig_data['address']['id_country'])) {
		$id_country = $orig_data['address']['id_country'];
		if (isset(static::$_pd_country[$id_country]))
			return static::$_pd_country[$id_country];
	}
}

}

sync_address_pd::__init();
