<?php

class sync_customer_dp extends sync_customer
{

public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
	$p_id = $o['p_oid'];
	
	// Groupe Client !
	$p_data_map['customer_group']['id_customer'] = $p_id;
	DB::p_insert_row('customer_group', $p_data_map['customer_group']);
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	$p_id = $o['p_oid'];
	$d_id = $o['d_oid'];
	
	// Groupe Client !
	if (!empty($p_data['customer']) && !empty($p_data_map['customer']['id_default_group']) && $p_data['customer']['id_default_group'] != $p_data_map['customer']['id_default_group']) {
		// Modif groupe existant
		if (!empty($p_data['customer_group'])) foreach($p_data['customer_group'] as $row) {
			if ($row['id_group']>=3 && $row['id_group'] != $p_data_map['customer']['id_default_group']) {
				DB::p_update_row('customer_group', ['id_group'=>$p_data_map['customer']['id_default_group']], $row);
			}
		}
		else {
			$p_data_map['customer_group']['id_customer'] = $p_id;
			DB::p_insert_row('customer_group', ['id_group'=>$p_data_map['customer']['id_default_group'], 'id_customer'=>$p_data['id_customer']]);
		}
	}

	// Civilité via socpeople
	// @todo
	
	$pos = strpos($d_data['societe']['nom'], ' ');
	$lastname = (is_numeric($pos) ?substr($d_data['societe']['nom'], 0, $pos) :$d_data['societe']['nom']);
	$firstname = (is_numeric($pos) ?substr($d_data['societe']['nom'], $pos+1) :'');

	// Création adresses inexistante
	if (empty($d_data['socpeople']) && !empty($d_data['societe']['address']) && !empty($d_data['societe']['zip']) && !empty($d_data['societe']['town'])) {
		$socpeople = [
			//'rowid' => NULL,
			'datec' => $d_data['societe']['datec'],
			'tms' => $d_data['societe']['tms'],
			'fk_soc' => $d_id,
			'entity' => 1,
			'ref_ext' => '',
			'civility' => '',
			'firstname' => (!empty($d_data['societe_extrafields']['p_firstname']) ?$d_data['societe_extrafields']['p_firstname'] :$firstname),
			'lastname' => (!empty($d_data['societe_extrafields']['p_lastname']) ?$d_data['societe_extrafields']['p_lastname'] :$lastname),
			'address' => $d_data['societe']['address'],
			'zip' => $d_data['societe']['zip'],
			'town' => $d_data['societe']['town'],
			'fk_departement' => $d_data['societe']['fk_departement'],
			'fk_pays' => $d_data['societe']['fk_pays'],
			//'birthday' => (isset($p_data['customer']['birthday']) ?$p_data['customer']['birthday'] :NULL),
			'poste' => '',
			'phone' => $d_data['societe']['phone'],
			'phone_perso' => '',
			//'phone_mobile' => $p_data['address']['phone_mobile'],
			'fax' => '',
			'email' => $d_data['societe']['email'],
			// 'socialnetworks' => '[]',
			// 'jabberid' => NULL,
			// 'skype' => NULL,
			// 'twitter' => NULL,
			// 'facebook' => NULL,
			// 'linkedin' => NULL,
			// 'instagram' => NULL,
			// 'snapchat' => NULL,
			// 'googleplus' => NULL,
			// 'youtube' => NULL,
			// 'whatsapp' => NULL,
			'photo' => '',
			'no_email' => 0,
			'priv' => 0,
			'fk_user_creat' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			'note_private' => NULL,
			'note_public' => NULL,
			'default_lang' => NULL,
			'canvas' => NULL,
			'import_key' => NULL,
			'statut' => 1,
			//'fk_prospectlevel' => NULL,
			'fk_stcommcontact' => 0,
		];
		if (DEBUG_AFF)
			var_dump($socpeople);
		if ($rowid = DB::d_insert_row('socpeople', $socpeople)) {
			$socpeople_extrafields = [
				'fk_object' => $rowid,
				'p_alias' => 'Adresse',
			];
			DB::d_insert_row('socpeople_extrafields', $socpeople_extrafields);
			sync::_action('address', 'dp', 'osync', 'socpeople', $rowid);
		}
	}
	
	if (P_CUSTOMER_DEFAULT_ADDRESSES) {
		$p_data_map_more['customer'] = [];
		$shipping_contact_type_id = static::$_d_type_contact_code['commande']['external']['SHIPPING'];
		$invoice_contact_type_id = static::$_d_type_contact_code['commande']['external']['BILLING'];
		//var_dump($shipping_contact_type_id);
		if (!empty($d_data['societe_contacts'])) {
			foreach ($d_data['societe_contacts'] as $row) {
				//var_dump($row);
				if ($row['fk_c_type_contact'] == $shipping_contact_type_id) {
					//var_dump('yoooo');
					$p_data_map_more['customer']['default_shipping_address_id'] = static::_dp_map_fk('address', 'socpeople', $row['fk_socpeople']);
					//var_dump('yoooo');
				}
				if ($row['fk_c_type_contact']==$invoice_contact_type_id) {
					$p_data_map_more['customer']['default_invoice_address_id'] = static::_dp_map_fk('address', 'socpeople', $row['fk_socpeople']);
				}
			}
		}
		if (!empty($p_data_map_more['customer'])) {
			var_dump($p_data_map_more['customer']);
			DB::p_update_row('customer', $p_data_map_more['customer'], ['id_customer'=>$p_id]);
		}
	}
}

// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	$tms = max($d_data['societe']['tms'], (!empty($p_data['customer']) ?$p_data['customer']['date_upd'] :'0000-00-00'));

	//var_dump($d_data['societe']); die();
	$pos = strpos($d_data['societe']['nom'], ' ');
	$lastname = (is_numeric($pos) ?substr($d_data['societe']['nom'], 0, $pos) :$d_data['societe']['nom']);
	$firstname = (is_numeric($pos) ?substr($d_data['societe']['nom'], $pos+1) :'');

	// @todo utiliser address

	$p_data_map = [
		'customer' => [
			'company' => (!empty($d_data['societe_extrafields']['p_company']) ?$d_data['societe_extrafields']['p_company'] :$d_data['societe']['name_alias']),
			'firstname' => (!empty($d_data['societe_extrafields']['p_firstname']) ?$d_data['societe_extrafields']['p_firstname'] :$firstname),
			'lastname' => (!empty($d_data['societe_extrafields']['p_lastname']) ?$d_data['societe_extrafields']['p_lastname'] :$lastname),
			'email' => $d_data['societe']['email'],
			'siret' => $d_data['societe']['siret'],
			'ape' => $d_data['societe']['ape'],
			'date_upd' => $tms,
			'id_default_group' => !empty($d_data['societe_extrafields']['p_group']) ?$d_data['societe_extrafields']['p_group'] :static::P_ID_GROUP_DEFAULT,
			'note' => $d_data['societe']['note_private'],
		],
	];

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	// @todo utiliser address pour les champs manquant

	$id_group = !empty($d_data['societe_extrafields']['p_group']) ?$d_data['societe_extrafields']['p_group'] :static::P_ID_GROUP_DEFAULT;

	$p_data_map = [
		'customer' => [
			//'id_customer' => '',
			'id_shop_group' => static::P_ID_SHOP_GROUP,
			'id_shop' => P_SHOP_ID,
			'id_gender' => 0, // 1 H 2 F
			'id_default_group' => $id_group,
			'id_lang' => P_LANG_ID,
			'id_risk' => 0,
			'company' => '',
			'siret' => '',
			'ape' => '',
			'firstname' => '',
			'lastname' => '',
			'email' => '',
			'passwd' => '$2y$10$xBaM8s5k9r1sm2z3pmSEcuzBwaOltqVv.UxgX5VlHWCOON7Z7b44C',
			'last_passwd_gen' => NULL,
			'birthday' => '0000-00-00',
			'newsletter' => 0,
			'ip_registration_newsletter' => NULL,
			'newsletter_date_add' => '0000-00-00 00:00:00',
			'optin' => 0,
			'website' => NULL,
			'outstanding_allow_amount' => 0,
			'show_public_prices' => 0,
			'max_payment_days' => 0,
			'secure_key' => md5(uniqid(mt_rand(0, mt_getrandmax()), true)),
			'note' => NULL,
			'active' => 1,
			'is_guest' => 0,
			'deleted' => 0,
			'date_add' => $d_data['societe']['datec'],
			'date_upd' => $d_data['societe']['tms'],
			'reset_password_token' => NULL,
			'reset_password_validity' => '0000-00-00 00:00:00',
		],
		'customer_group' => [
			'id_customer' => NULL,
			'id_group' => $id_group,
		],
	];

	return $p_data_map;
}

// -----------

// Field MAPPING

}

sync_customer_dp::__init();
