<?php

class sync_customer_pd extends sync_customer
{

// -- CHECK --

public static function pd_check_create(&$o, &$d_data_map, &$p_data)
{
	if (!empty($d_data_map['societe']['email'])) {
		$sql = 'SELECT 1
			FROM '.DB_D_PREFIX.'societe
			WHERE email LIKE "'.$d_data_map['societe']['email'].'"';
		if (DB::d_count($sql))
			return false;
	}
}

// -- SUB ACTIONS --

public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
	$id = $o['d_oid'];
	// @todo
	
	static::d_update_row('societe_extrafields', (!empty($d_data['societe_extrafields']) ?['rowid'=>$d_data['societe_extrafields']['rowid']] :['fk_object'=>$id]), $d_data_map, $d_data_map_create, $d_data);
}

// -- MAPPING --

public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	$tms = max($p_data['customer']['date_upd'], (isset($d_data['societe']) ?$d_data['societe']['tms'] :'0000-00-00'));

	$societe = trim(strtolower($p_data['customer']['company']));
	if (in_array($societe, ['personnel', 'particulier', 'madame', 'monsieur', 'année', 'femme', 'pas de societe', 'sans societe', 'individuel']) || empty($societe)) {
		$p_data['customer']['company'] = '';
	}
	$pro = $p_data['customer']['company'] ?1 :0;

	$d_data_map = [
		'societe' => [
			//'rowid' => NULL,
			'nom' => trim(($pro ?$p_data['customer']['company'] :$p_data['customer']['lastname'].($p_data['customer']['firstname'] ?' '.$p_data['customer']['firstname'] :''))),
			'name_alias' => trim(($pro ?$p_data['customer']['lastname'].($p_data['customer']['firstname'] ?' '.$p_data['customer']['firstname'] :'') :'')),
			//'entity' => 1,
			//'ref_ext' => NULL,
			//'ref_int' => NULL,
			//'statut' => 0,
			//'parent' => NULL,
			//'status' => 1,
			//'code_client' => static::_p_map_code_client($p_data),
			//'code_fournisseur' => NULL,
			//'code_compta' => NULL,
			//'code_compta_fournisseur' => NULL,
			//'address' => '',
			//'zip' => NULL,
			//'town' => NULL,
			//'fk_departement' => NULL,
			//'fk_pays' => NULL,
			//'fk_account' => NULL,
			//'phone' => NULL,
			//'fax' => NULL,
			//'url' => NULL,
			'email' => $p_data['customer']['email'],
			//'socialnetworks' => NULL,
			//'skype' => NULL,
			//'twitter' => NULL,
			//'facebook' => NULL,
			//'linkedin' => NULL,
			//'instagram' => NULL,
			//'snapchat' => NULL,
			//'googleplus' => NULL,
			//'youtube' => NULL,
			//'whatsapp' => NULL,
			//'fk_effectif' => NULL,
			//'fk_typent' => 0,
			//'fk_forme_juridique' => NULL,
			//'fk_currency' => NULL,
			//'siren' => '',
			'siret' => $p_data['customer']['siret'],
			'ape' => $p_data['customer']['ape'],
			//'idprof4' => '',
			//'idprof5' => '',
			//'idprof6' => '',
			//'tva_intra' => '',
			//'capital' => NULL,
			//'fk_stcomm' => 0,
			'note_private' => $p_data['customer']['note'],
			//'note_public' => NULL,
			//'model_pdf' => NULL,
			//'prefix_comm' => NULL,
			//'client' => 1,
			//'fournisseur' => 0,
			//'supplier_account' => NULL,
			//'fk_prospectlevel' => '',
			//'fk_incoterms' => 0,
			//'location_incoterms' => NULL,
			//'customer_bad' => 0,
			//'customer_rate' => 0,
			//'supplier_rate' => 0,
			//'remise_client' => 0,
			//'remise_supplier' => 0,
			//'mode_reglement' => NULL,
			//'cond_reglement' => NULL,
			//'mode_reglement_supplier' => NULL,
			//'cond_reglement_supplier' => NULL,
			//'fk_shipping_method' => NULL,
			//'tva_assuj' => 1,
			//'localtax1_assuj' => NULL,
			//'localtax1_value' => 0,
			//'localtax2_assuj' => NULL,
			//'localtax2_value' => 0,
			//'barcode' => NULL,
			//'fk_barcode_type' => 0,
			//'price_level' => NULL,
			//'outstanding_limit' => NULL,
			//'order_min_amount' => NULL,
			//'supplier_order_min_amount' => NULL,
			//'default_lang' => NULL,
			//'logo' => NULL,
			//'logo_squarred' => NULL,
			//'canvas' => NULL,
			//'webservices_url' => NULL,
			//'webservices_key' => NULL,
			'tms' => $tms,
			//'datec' => $p_data['customer']['date_add'],
			//'fk_user_creat' => static::D_K_USER,
			//'fk_user_modif' => static::D_K_USER,
			//'fk_multicurrency' => 0,
			//'multicurrency_code' => '',
			//'import_key' => NULL,
			//'transport_mode' => NULL,
			//'transport_mode_supplier' => NULL,
			//'fk_warehouse' => NULL,
			//'accountancy_code_sell' => NULL,
			//'accountancy_code_buy' => NULL,
		],
		'societe_extrafields' => [
			'p_lastname' => trim($p_data['customer']['lastname']),
			'p_firstname' => trim($p_data['customer']['firstname']),
			'p_company' => trim($p_data['customer']['company']),
			'p_group' => $p_data['customer']['id_default_group'],
			'pro' => (!empty($d_data['societe_extrafields']['pro']) || $p_data['customer']['id_default_group']>3 ?1 :0),
		],
	];
	
	$map_invoice = $this->map_invoice($o, $p_data);
	static::_array_merge_recursive($d_data_map, $map_invoice);

	return $d_data_map;
}

public function pd_map_create(&$o, &$p_data)
{
	$address = (!empty($p_data['address']) ?current($p_data['address']) :NULL);

	$d_data_map = [
		'societe' => [
			//'rowid' => NULL,
			'nom' => trim($p_data['customer']['lastname'].' '.$p_data['customer']['firstname']),
			'name_alias' => $p_data['customer']['company'],
			'entity' => 1,
			'ref_ext' => NULL,
			'ref_int' => NULL,
			'statut' => 0,
			'parent' => NULL,
			'status' => 1,
			'code_client' => static::d_ref($p_data['customer']['date_add']),
			'code_fournisseur' => NULL,
			'code_compta' => NULL,
			'code_compta_fournisseur' => NULL,
			'address' => ($address ?$address['address1'].($address['address2'] ?"\r\n".$address['address2'] :'') :''),
			'zip' => ($address ?$address['postcode'] :NULL),
			'town' => ($address ?$address['city'] :NULL),
			'fk_departement' => NULL,
			'fk_pays' => static::_pd_map_fk_pays($p_data),
			'fk_account' => NULL,
			'phone' => NULL,
			'fax' => NULL,
			'url' => NULL,
			'email' => $p_data['customer']['email'],
			// 'socialnetworks' => NULL,
			// 'skype' => NULL,
			// 'twitter' => NULL,
			// 'facebook' => NULL,
			// 'linkedin' => NULL,
			// 'instagram' => NULL,
			// 'snapchat' => NULL,
			// 'googleplus' => NULL,
			// 'youtube' => NULL,
			// 'whatsapp' => NULL,
			'fk_effectif' => NULL,
			'fk_typent' => 0,
			'fk_forme_juridique' => NULL,
			'fk_currency' => NULL,
			'siren' => '',
			'siret' => $p_data['customer']['siret'],
			'ape' => $p_data['customer']['ape'],
			'idprof4' => '',
			'idprof5' => '',
			'idprof6' => '',
			'tva_intra' => '',
			'capital' => NULL,
			'fk_stcomm' => 0,
			'note_private' => NULL,
			'note_public' => NULL,
			'model_pdf' => NULL,
			'prefix_comm' => NULL,
			'client' => 1,
			'fournisseur' => 0,
			'supplier_account' => NULL,
			'fk_prospectlevel' => '',
			'fk_incoterms' => 0,
			'location_incoterms' => NULL,
			'customer_bad' => 0,
			'customer_rate' => 0,
			'supplier_rate' => 0,
			'remise_client' => 0,
			'remise_supplier' => 0,
			'mode_reglement' => NULL,
			'cond_reglement' => NULL,
			'mode_reglement_supplier' => NULL,
			'cond_reglement_supplier' => NULL,
			'fk_shipping_method' => NULL,
			'tva_assuj' => 1,
			'localtax1_assuj' => NULL,
			'localtax1_value' => 0,
			'localtax2_assuj' => NULL,
			'localtax2_value' => 0,
			'barcode' => NULL,
			'fk_barcode_type' => 0,
			'price_level' => NULL,
			'outstanding_limit' => NULL,
			'order_min_amount' => NULL,
			'supplier_order_min_amount' => NULL,
			'default_lang' => NULL,
			'logo' => NULL,
			'logo_squarred' => NULL,
			'canvas' => NULL,
			'webservices_url' => NULL,
			'webservices_key' => NULL,
			'tms' => $p_data['customer']['date_upd'],
			'datec' => $p_data['customer']['date_add'],
			'fk_user_creat' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			'fk_multicurrency' => 0,
			'multicurrency_code' => '',
			'import_key' => NULL,
			'transport_mode' => NULL,
			'transport_mode_supplier' => NULL,
			'fk_warehouse' => NULL,
			'accountancy_code_sell' => NULL,
			'accountancy_code_buy' => NULL,
		],
		'societe_extrafields' => [
			'p_lastname' => $p_data['customer']['lastname'],
			'p_firstname' => $p_data['customer']['firstname'],
			'p_company' => $p_data['customer']['company'],
			'pro' => $p_data['customer']['id_default_group']>3 ?1 :0,
		],
	];
	
	$map_invoice = $this->map_invoice($o, $p_data);
	static::_array_merge_recursive($d_data_map, $map_invoice);

	return $d_data_map;
}

public function map_invoice(&$o, &$p_data)
{
	if(!empty($p_data['order'])) {
		$id_address_invoice = $p_data['order']['id_address_invoice'];
		$id_address_delivery = $p_data['order']['id_address_delivery'];
	}
	elseif (!empty($p_data['address'])) {
		$id_address_invoice = $p_data['address'][0]['id_address'];
		$id_address_delivery = $p_data['address'][0]['id_address'];
	}
	
	if (!empty($p_data['address'])) foreach($p_data['address'] as $address) {
		if ($address['id_address']==$id_address_invoice)
			$address_invoice = $address;
		if ($address['id_address']==$id_address_delivery)
			$address_delivery = $address;
	}
	
	if (!empty($address_invoice)) {
		$d_data_map = [
			'societe' => [
				//'rowid' => NULL,
				//'nom' => $p_data['customer']['firstname'].' '.$p_data['customer']['lastname'],
				//'name_alias' => $p_data['customer']['company'],
				//'entity' => 1,
				//'ref_ext' => NULL,
				//'ref_int' => NULL,
				//'statut' => 0,
				//'parent' => NULL,
				//'status' => 1,
				//'code_client' => static::_p_map_code_client($p_data),
				//'code_fournisseur' => NULL,
				//'code_compta' => NULL,
				//'code_compta_fournisseur' => NULL,
				'address' => $address_invoice['address1'].($address_invoice['address2'] ?"\r\n".$address_invoice['address2'] :''),
				'zip' => $address_invoice['postcode'],
				'town' => $address_invoice['city'],
				//'fk_departement' => NULL,
				//'fk_pays' => NULL,
				//'fk_account' => NULL,
				'phone' => ($address_invoice['phone_mobile'] ?$address_invoice['phone_mobile'] :$address_invoice['phone']),
				//'fax' => NULL,
				//'url' => NULL,
				//'email' => $p_data['customer']['email'],
				//'socialnetworks' => NULL,
				//'skype' => NULL,
				//'twitter' => NULL,
				//'facebook' => NULL,
				//'linkedin' => NULL,
				//'instagram' => NULL,
				//'snapchat' => NULL,
				//'googleplus' => NULL,
				//'youtube' => NULL,
				//'whatsapp' => NULL,
				//'fk_effectif' => NULL,
				//'fk_typent' => 0,
				//'fk_forme_juridique' => NULL,
				//'fk_currency' => NULL,
				//'siren' => '',
				//'siret' => $p_data['customer']['siret'],
				//'ape' => $p_data['customer']['ape'],
				//'idprof4' => '',
				//'idprof5' => '',
				//'idprof6' => '',
				//'tva_intra' => '',
				//'capital' => NULL,
				//'fk_stcomm' => 0,
				//'note_private' => NULL,
				//'note_public' => NULL,
				//'model_pdf' => NULL,
				//'prefix_comm' => NULL,
				//'client' => 1,
				//'fournisseur' => 0,
				//'supplier_account' => NULL,
				//'fk_prospectlevel' => '',
				//'fk_incoterms' => 0,
				//'location_incoterms' => NULL,
				//'customer_bad' => 0,
				//'customer_rate' => 0,
				//'supplier_rate' => 0,
				//'remise_client' => 0,
				//'remise_supplier' => 0,
				//'mode_reglement' => NULL,
				//'cond_reglement' => NULL,
				//'mode_reglement_supplier' => NULL,
				//'cond_reglement_supplier' => NULL,
				//'fk_shipping_method' => NULL,
				//'tva_assuj' => 1,
				//'localtax1_assuj' => NULL,
				//'localtax1_value' => 0,
				//'localtax2_assuj' => NULL,
				//'localtax2_value' => 0,
				//'barcode' => NULL,
				//'fk_barcode_type' => 0,
				//'price_level' => NULL,
				//'outstanding_limit' => NULL,
				//'order_min_amount' => NULL,
				//'supplier_order_min_amount' => NULL,
				//'default_lang' => NULL,
				//'logo' => NULL,
				//'logo_squarred' => NULL,
				//'canvas' => NULL,
				//'webservices_url' => NULL,
				//'webservices_key' => NULL,
				//'tms' => $p_data['customer']['date_upd'], //@todo tms
				//'datec' => $p_data['customer']['date_add'],
				//'fk_user_creat' => static::D_K_USER,
				//'fk_user_modif' => static::D_K_USER,
				//'fk_multicurrency' => 0,
				//'multicurrency_code' => '',
				//'import_key' => NULL,
				//'transport_mode' => NULL,
				//'transport_mode_supplier' => NULL,
				//'fk_warehouse' => NULL,
				//'accountancy_code_sell' => NULL,
				//'accountancy_code_buy' => NULL,
			],
		];
		
		return $d_data_map;
	}
	
	return [];
}

// -----------

// Field MAPPING

public static function _pd_map_fk_pays(&$orig_data, &$dest_tree=[])
{
	static::_country_load();

	$address = (!empty($orig_data['address']) ?current($orig_data['address']) :NULL);

	if (!empty($address['id_country'])) {
		$id_country = $address['id_country'];
	}
	else {
		// France by default, otherwise c'est la grosse merde...
		return 1;
	}

	if (!empty($id_country) && isset(static::$_pd_country[$id_country]))
		return static::$_pd_country[$id_country];
}

}

sync_customer_pd::__init();
