<?php

// Order

class sync_order extends sync
{

const MODEL_NAME = 'order';
const MODEL_ID = 15;
const MAP_ID = 8;

const P_TABLE_MAIN = 'orders';
const P_TABLE_MAIN_ID = 'id_order';

const D_TABLE_MAIN = 'commande';
const D_TABLE_MAIN_REF = 'ref';
const D_REF_CODE = 'CO';
const D_REF_LENGTH = 6;
const D_REF_DATE = true;
protected static $nb;

protected static $_d_status = [
	//-3 => 'Pas assez de stock',
	-1 => 'Annulé',
	0 => 'Brouillon',
	1 => 'Validé',
	2 => 'Expédition en cours',
	3 => 'Fermé',
];

protected static $d_contact_map = [
	'shipping' => 102,
	'invoice' => 100,
];

public static function __init()
{
	parent::__init();
	
	if (empty(static::$_p_order_state_map))
		static::_p_order_state_map_load();
	
	if (empty(static::$_p_carriers))
		static::_p_carriers_load();
}

function d_data($otype, $oid)
{
	$data = [];
	$data['commande'] = DB::d_get_row('commande', ['rowid'=>$oid]);
	if (empty($data['commande']))
		return;
	
	$data['commande_extrafields'] = DB::d_get_row('commande_extrafields', ['fk_object'=>$oid]);

	// Détail produits
	$data['commandedet'] = DB::d_get_rows('commandedet', ['fk_commande'=>$oid]);
	
	// Client tiers
	$data['societe'] = DB::d_get_row('societe', ['rowid'=>$data['commande']['fk_soc']]);

	// Association contact
	$data['element_contact_shipping'] = DB::d_get_row('element_contact', 'element_id='.$oid.' AND fk_c_type_contact='.static::$d_contact_map['shipping']);
	$data['element_contact_invoice'] = DB::d_get_row('element_contact', 'element_id='.$oid.' AND fk_c_type_contact='.static::$d_contact_map['invoice']);

	// association autres objets
	$data['element_element_source'] = DB::d_get_rows('element_element', ['fk_source'=>$oid, 'sourcetype'=>'commande']);
	$data['element_element_target'] = DB::d_get_rows('element_element', ['fk_target'=>$oid, 'targettype'=>'commande']);

	$data['expedition'] = [];
	foreach($data['element_element_source'] as $row) if ($row['targettype']=='shipping')
		$data['expedition'][] = DB::d_get_row('expedition', ['rowid'=>$row['fk_target']]);

	return $data;
}

function p_data($otype, $oid)
{
	$data = [];
	$data['orders'] = DB::p_get_row('orders', ['id_order'=>$oid]);
	if (empty($data['orders']))
		return;
	
	// order_cart_rule
	$data['order_cart_rule'] = DB::p_get_rows('order_cart_rule', ['id_order'=>$oid, 'deleted'=>0]);
	
	// Details & tax
	$data['order_detail'] = DB::p_get_rows('order_detail', ['id_order'=>$oid]);
	//$data['order_detail_tax'] = DB::p_get_rows('order_detail_tax', ['id_order_detail'=>$oid]);
	if (PRODUCT_LOT) {
		$data['products_dlc_dluo_orders'] = DB::p_get_rows('products_dlc_dluo_orders', ['id_order'=>$oid]);
	}

	// Carrier
	$data['order_carrier'] = DB::p_get_rows('order_carrier', ['id_order'=>$oid]);

	// Payment
	if (P_PAYMENT_ETRANSACTIONS) {
		$data['etransactions_order'] = DB::p_get_row('etransactions_order', ['id_order'=>$oid]);
	}

	// customer
	$data['customer'] = DB::p_get_row('customer', ['id_customer'=>$data['orders']['id_customer']]);
	if (empty($data['customer'])) {
		$customer_id = $this->p_customer_insert($data);
		$data['customer'] = DB::p_get_row('customer', ['id_customer'=>$data['orders']['id_customer']]);
		//var_dump($data['customer']); die();
	}
	
	$ref = $data['orders']['reference'];
	$data['order_payment'] = DB::p_get_rows('order_payment', ['order_reference'=>$ref]);
	
	// cart
	$data['cart'] = DB::p_get_row('cart', ['id_cart'=>$data['orders']['id_cart']]);

	// Obsolète, utilisation de static::$p_carriers
	// if (!empty($data['orders']['id_carrier'])) {
	// 	$data['carrier'] = DB::p_get_row('carrier', ['id_carrier'=>$data['orders']['id_carrier']]);
	// 	$data['carrier_lang'] = DB::p_get_row('carrier_lang', ['id_carrier'=>$data['orders']['id_carrier']]);
	// }

	// invoice_addr
	//$data['invoice_address'] = DB::p_get_row('address', ['id_address'=>$data['orders']['id_address_invoice']]);
	// shipping_addr
	//$data['shipping_address'] = DB::p_get_row('address', ['id_address'=>$data['orders']['id_address_delivery']]);
	
	// Stock mvt
	//$data['stock_mvt'] = DB::p_get_rows('stock_mvt', ['id_order'=>$oid]);

	return $data;
}

function p_customer_insert(&$p_data)
{
	$data = [
		'id_customer' => $p_data['orders']['id_customer'],
		'id_shop_group' => static::P_ID_SHOP_GROUP,
		'id_shop' => P_SHOP_ID,
		'id_gender' => 0, // 1 H 2 F
		'id_default_group' => static::P_ID_GROUP_DEFAULT,
		'id_lang' => P_LANG_ID,
		'id_risk' => 0,
		'company' => NULL,
		'siret' => NULL,
		'ape' => NULL,
		'firstname' => 'Anonymous',
		'lastname' => 'Deleted Recovered',
		'email' => 'anonymous@'.EMAIL_DOMAIN,
		'passwd' => '',
		'last_passwd_gen' => NULL,
		'birthday' => '0000-00-00',
		'newsletter' => 0,
		'ip_registration_newsletter' => NULL,
		'newsletter_date_add' => '0000-00-00 00:00:00',
		'optin' => 0,
		'website' => NULL,
		'outstanding_allow_amount' => 0,
		'show_public_prices' => 0,
		'max_payment_days' => 0,
		'secure_key' => '',
		'note' => NULL,
		'active' => 1,
		'is_guest' => 0,
		'deleted' => 0,
		'date_add' => $p_data['orders']['date_add'],
		'date_upd' => $p_data['orders']['date_upd'],
		'reset_password_token' => NULL,
		'reset_password_validity' => '0000-00-00 00:00:00',
	];
	
	return DB::p_insert_row('customer', $data);
}

/**
 * Commande bloquée
 */
public static function d_locked(&$d_data)
{
	return (!empty($d_data['commande']) && in_array($d_data['commande']['fk_statut'], [2, 3]))
		|| (!empty($d_data['commande_extrafields']) && !$d_data['commande_extrafields']['sync']);
}

}
