<?php

class sync_order_dp extends sync_order
{

public static function dp_check_sync(&$o, &$d_data)
{
	// @todo modifier avec P >= 1.7.8
	
	// Uniquement resynchro ! On n'envoie pas les commandes créées sur DOli vers Presta
	// @todo : Du moins tant qu'on a pas réglé le cas des produits libres
	if (empty($o['p_oid']))
		return false;
	
	return true;
}

public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
	// identique update_more...
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	$id = $o['p_oid'];

	// @todo vérif si commande statut bloqué
	//if ()
	
	// Sous-totaux
	$orders = [
		// Products
		'total_products' => 0,
		'total_products_wt' => 0,
		// Discounts
		'total_discounts' => 0,
		'total_discounts_tax_excl' => 0,
		'total_discounts_tax_incl' => 0,
		// Shipping
		'total_shipping' => 0,
		'total_shipping_tax_excl' => 0,
		'total_shipping_tax_incl' => 0,
	];

	// Product details
	if (!empty($d_data['commandedet'])) foreach($d_data['commandedet'] as $row) {
		// Shipping detail
		$product_row = (!empty($row['fk_product']) ?DB::d_get_row('product', ['rowid'=>$row['fk_product']]) :NULL);
		
		// Custom product ..?
		if (empty($product_row)) {

		}
		// Shipping line
		elseif ($product_row['ref']=='PrestaShipping' || $product_row['label']=='PrestaShipping') {
			$orders['total_shipping'] += $row['total_ttc'];
			$orders['total_shipping_tax_excl'] += $row['total_ht'];
			$orders['total_shipping_tax_incl'] += $row['total_ttc'];
		}
		// Discount detail
		elseif ($product_row['ref']=='PrestaDiscount' || $product_row['label']=='PrestaDiscount') {
			$orders['total_discounts'] += -$row['total_ttc'];
			$orders['total_discounts_tax_excl'] += -$row['total_ht'];
			$orders['total_discounts_tax_incl'] += -$row['total_ttc'];
			// Synchro ligne
			static::_action('order_detail', 'dp', 'osync', 'commandedet', $row['rowid']);
		}
		// Produit/Service "normal"
		else {
			$orders['total_products'] += $row['total_ht'];
			$orders['total_products_wt'] += $row['total_ttc'];
			// Synchro ligne
			static::_action('order_detail', 'dp', 'osync', 'commandedet', $row['rowid']);
		}
	}

	foreach($orders as $i=>$j)
		$orders[$i] = round($j, 5);

	//var_dump($orders);
	DB::p_update_row('orders', $orders, ['id_order'=>$id], $p_data['orders']);

	// Log state modif
	if (!empty($p_data_map['orders']['current_state']) && $p_data_map['orders']['current_state']!=$p_data['orders']['current_state']) {
		// @todo log state modif
		DB::p_insert_row('order_history', ['id_order'=>$id, 'id_employee'=>0, 'id_order_state'=>$p_data_map['orders']['current_state'], 'date_add'=>static::$datetime]);
	}

}


// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	$p_data_map = [
		'orders' => [
			//'reference' => substr($d_data['commande']['ref'], 0, 9),

			//'id_customer' => static::_dp_map_fk_customer($d_data),
			//'id_address_delivery' => static::_dp_map_fk_address_delivery($d_data),
			//'id_address_invoice' => static::_dp_map_fk_address_invoice($d_data),
			
			//'total_paid' => $d_data['commande']['total_ttc'],
			//'total_paid_tax_incl' => $d_data['commande']['total_ttc'],
			//'total_paid_tax_excl' => $d_data['commande']['total_ht'],
			
			'date_upd' => max($d_data['commande']['tms'], !empty($p_data['orders']['date_upd']) ?$p_data['orders']['date_upd'] :'0000-00-00 00:00:00'),

			//'note' => strip_tags($d_data['commande']['note_private']),
		],
	];

	// Si note privée
	if(isset($p_data['orders']['note']))
		$p_data_map['orders']['note'] = strip_tags($d_data['commande']['note_private']);

	/*
	if (is_numeric($current_state = static::_dp_map_state($d_data)))
		$p_data_map['orders']['current_state'] = $current_state;
	*/

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	$p_data_map = [
		'orders' => [
			//'id_order' => '',
			'reference' => $d_data['commande']['ref'],
			'id_shop_group' => static::P_ID_SHOP_GROUP,
			'id_shop' => P_SHOP_ID,
			'id_carrier' => 0, // @todo static::P_ID_CARRIER_DEFAULT,
			'id_lang' => P_LANG_ID,
			'id_customer' => static::_dp_map_fk_customer($d_data),
			'id_cart' => 0, // @todo créer un panier
			'id_currency' => static::P_ID_CURRENCY,
			'id_address_delivery' => static::_dp_map_fk_address_delivery($d_data),
			'id_address_invoice' => static::_dp_map_fk_address_invoice($d_data),
			'current_state' => static::_dp_map_state($d_data),
			'secure_key' => '',
			'payment' => '',
			'conversion_rate' => 1,
			'module' => static::_dp_map_module($d_data),
			'recyclable' => 0,
			'gift' => 0,
			'gift_message' => '',
			'mobile_theme' => 0,
			'shipping_number' => '', //@todo
			'total_discounts' => 0, //@todo
			'total_discounts_tax_incl' => 0,
			'total_discounts_tax_excl' => 0,
			'total_paid' => $d_data['commande']['total_ttc'],
			'total_paid_tax_incl' => $d_data['commande']['total_ttc'],
			'total_paid_tax_excl' => $d_data['commande']['total_ht'],
			'total_paid_real' => 0, // ?
			'total_products' => 0,
			'total_products_wt' => 0,
			'total_shipping' => 0, //@todo
			'total_shipping_tax_incl' => 0,
			'total_shipping_tax_excl' => 0,
			'carrier_tax_rate' => 20, // @todo calcul
			'total_wrapping' => 0, // @todo ?
			'total_wrapping_tax_incl' => 0,
			'total_wrapping_tax_excl' => 0,
			'round_mode' => 2,
			'round_type' => 2,
			'invoice_number' => 0, // @todo invoice
			'delivery_number' => 0, // @todo delivery
			'invoice_date' => '0000-00-00 00:00:00',
			'delivery_date' => '0000-00-00 00:00:00',
			'valid' => 1, //@todo ?
			'date_add' => $d_data['commande']['date_creation'],
			'date_upd' => $d_data['commande']['tms'],
		],
	];

	return $p_data_map;
}

// -----------

// Field MAPPING

public static function _dp_map_state(&$orig_data, &$dest_tree=[])
{
	switch($orig_data['commande']['fk_statut']) {
		//'Pas assez de stock',
		case -3:
			return 9;
		// Annulé
		case -1:
			return 6;
		// 'Brouillon' => on laisse, trop de choix possibles... @todo : ou bien mettre 'En attente de traitement'
		//case 0:
		// Validé => on sait pas à quoi ça correspond
		//case 1:
		// Expédition en cours
		case 2:
			return 3;
		// Fermé
		case 3:
			return 5;
	}
}

public static function _dp_map_payment(&$orig_data, &$dest_tree=[])
{
	// @todo
	return 'E-Transactions';
}

public static function _dp_map_module(&$orig_data, &$dest_tree=[])
{
	// @todo
	return 'etransactions';
}

public static function _dp_map_fk_customer(&$orig_data, &$dest_tree=[])
{
	return static::_dp_map_fk('customer', 'societe', $orig_data['commande']['fk_soc']);
}

public static function _dp_map_fk_address_delivery(&$orig_data, &$dest_tree=[])
{
	if (!empty($orig_data['element_contact_shipping'])) {
		// address
		if (!($o = static::d_o_oid('address', 'socpeople', $orig_data['element_contact_shipping']['fk_socpeople']))) {
			$o = static::_action('address', 'dp', 'create', 'socpeople', $orig_data['element_contact_shipping']['fk_socpeople']);
		}
		return $o['p_oid'];
	}
}

public static function _dp_map_fk_address_invoice(&$orig_data, &$dest_tree=[])
{
	if (!empty($orig_data['element_contact_invoice'])) {
		// address
		if (!($o = static::d_o_oid('address', 'socpeople', $orig_data['element_contact_invoice']['fk_socpeople']))) {
			$o = static::_action('address', 'dp', 'create', 'socpeople', $orig_data['element_contact_invoice']['fk_socpeople']);
		}
		return $o['p_oid'];
	}
}

}

sync_order_dp::__init();
