<?php

class sync_order_pd extends sync_order
{

// -- CHECK --

public static function pd_check_update(&$o, &$d_data_map_update, &$d_data_map_create, &$d_data, &$p_data)
{
	// Don't update fk_status if 3 => use ORDER_VALIDATE
	// Only if API configured...
	if (D_API_KEY && isset($d_data_map_update['commande']['fk_statut'])) if (
		($d_data_map_update['commande']['fk_statut']==3)
		&& (isset($d_data['commande']['fk_statut']) && $d_data['commande']['fk_statut'] != 3)
	) {
			$d_data_map_update_real = array_merge($d_data_map_update); // Kind of clone
			unset($d_data_map_update_real['commande']['fk_statut']);
			//echo '<hr />'; var_dump($d_data_map_update_real); echo '<hr />';
			return $d_data_map_update_real;
	}
}

// -- SUB ACTIONS --

public function pd_insert_more(&$o, &$d_data, &$p_data)
{
	$id = $o['d_oid'];
	
	// Expédition à créer pour le picking
	$this->pd_expedition_create($id, $d_data, $p_data);
}

public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
	$id = $o['d_oid'];
	$locked = static::d_locked($d_data);

	// commande_extrafields
	static::d_update_row('commande_extrafields', ['fk_object'=>$id], $d_data_map, $d_data_map_create, $d_data);

	// Payments
	if (PAYMENT_SYNC && !empty($p_data['order_payment'])) foreach($p_data['order_payment'] as $row) {
		static::_action('payment', 'pd', 'osync', 'order_payment', $row['id_order_payment']);
	}
	
	// Si bloqué, on ne met presque rien à jour
	// Sauf statut presta.
	// Ensuite on fait validationn expé, etc.
	if (!$locked) {
		// invoice contact
		if (isset($d_data_map['element_contact_invoice'])) {
			if (!empty($d_data['element_contact_invoice']))
				DB::d_update_row('element_contact', $d_data_map['element_contact_invoice'], ['rowid'=>$d_data['element_contact_invoice']['rowid']], $d_data['element_contact_invoice']);
			else
				DB::d_insert_row('element_contact', array_merge($d_data_map_create['element_contact_invoice'], $d_data_map['element_contact_invoice'], ['element_id'=>$id]));
		}
			
		// shipping contact
		if (isset($d_data_map['element_contact_shipping'])) {
			if (!empty($d_data['element_contact_shipping']))
				DB::d_update_row('element_contact', $d_data_map['element_contact_shipping'], ['rowid'=>$d_data['element_contact_shipping']['rowid']], $d_data['element_contact_shipping']);
			else
				DB::d_insert_row('element_contact', array_merge($d_data_map_create['element_contact_shipping'], $d_data_map['element_contact_shipping'], ['element_id'=>$id]));
		}

		// Order Contents

		// Product details
		if (!empty($p_data['order_detail'])) foreach($p_data['order_detail'] as $row) {
			static::_action('order_detail', 'pd', 'osync', 'order_detail', $row['id_order_detail']);
		}

		// Discount details
		if (!empty($p_data['order_cart_rule'])) foreach($p_data['order_cart_rule'] as $row) {
			static::_action('order_detail', 'pd', 'osync', 'order_cart_rule', $row['id_order_cart_rule']);
		}
		else {
			// Si on a des lignes sur Doli, il faut les supprimer !
		}

		// Shipping row
		if ($row = $this->shipping_row($p_data, $id)) {
			$sok = false;
			// Recherche une ligne livraison correspondante
			if (!empty($d_data['commandedet'])) foreach($d_data['commandedet'] as $crow) {
				if ($crow['fk_product']==static::D_K_SHIPPING_PRODUCT) {
					// Update existante
					DB::d_update_row('commandedet', $row, ['rowid'=>$crow['rowid']], $crow);
					$sok = true;
					break;
				}
			}
			// Création si pas trouvé
			if (!$sok)
				DB::d_insert_row('commandedet', $row);
		}
		else {
			// Si on a des lignes sur Doli, il faut les supprimer !
			if (!empty($d_data['commandedet'])) foreach($d_data['commandedet'] as $crow) {
				if ($crow['fk_product']==static::D_K_SHIPPING_PRODUCT) {
					DB::d_delete_row('commandedet', ['rowid'=>$crow['rowid']]);
					break;
				}
			}
		}

		// Ecotax Row
		if (ECOTAX) if ($row = $this->ecotax_row($p_data, $d_data, $id)) {
			$sok = false;
			// Recherche une ligne livraison correspondante
			if (!empty($d_data['commandedet'])) foreach($d_data['commandedet'] as $crow) {
				if ($crow['fk_product']==D_K_ECOTAX_PRODUCT) {
					// Update existante
					DB::d_update_row('commandedet', $row, ['rowid'=>$crow['rowid']], $crow);
					$sok = true;
					break;
				}
			}
			// Création si pas trouvé
			if (!$sok)
				DB::d_insert_row('commandedet', $row);
			//var_dump($row);
		}
	}

	// Trigger Dolibarr
	// @todo mettre dans une autre méthode inédpendante pour la lisibilité du code
	if (D_API_KEY) {
		// Changement de statut
		if (
			isset($d_data['commande']['fk_statut']) && isset($d_data_map['commande']['fk_statut'])
			&& $d_data_map['commande']['fk_statut'] != $d_data['commande']['fk_statut']
		) {
			// Livré => ORDER_CLOSE
			if ($d_data_map['commande']['fk_statut'] == 3)
				static::_d_api('POST', 'orders/'.$id.'/close', 0);
		}
		// Prépa particulier Presta ou commande pro outil catalogue => Création expé Doli
		// Les conditions impliquent bien !$locked
		if (
			// Pro créé nouvelle commande via catalogue
			(
				$p_data['customer']['id_default_group'] != 3
				&& empty($d_data['commande'])
				&& $p_data['orders']['current_state'] == P_PRO_CATALOG_ORDER_STATUS
			)
			// Part : commande déjà créée passée en prépa pour la première fois
			|| (
				$p_data['customer']['id_default_group'] == 3
				&& !empty($d_data['commande']) && $d_data['commande']['fk_statut'] == 1
				&& $p_data['orders']['current_state'] == 3
			)
		) {
			$lots = [];
			foreach($p_data['products_dlc_dluo_orders'] as $ddm) {
				$fk_product_lot = static::_pd_map_fk('product_lot', 'products_dlc_dluo', $ddm['id_dlc_dluo']);
				$lots[] = ['fk_product_lot'=>$fk_product_lot, 'qte'=>$ddm['quantity']];
			}
			var_dump($lots);
			static::_d_api('GET', 'sfycustomapi/commande_expe/'.$id, ['lots'=>$lots]);
		}
	}
}

public function pd_expedition_create($id, $d_data, $p_data)
{
	return;
	
	// expedition
	$data = $this->pd_expedition_insert_map($id, $d_data, $p_data);
	//$e_id = DB::d_insert_row('expedition', $row);

	// expedition_extrafields
	// expeditiondet
	// expeditiondet_extrafields
	// expeditiondet_batch

}
public function pd_expedition_insert_map($id, $d_data, $p_data)
{
	//
	$row = [
		//'rowid' => NULL,
		'tms' => static::$datetime,
		'ref' => '', // @todo
		'entity' => 1,
		'fk_soc' => $d_data['commande']['fk_soc'],
		'fk_projet' => 0,
		'ref_ext' => NULL,
		'ref_int' => NULL,
		'ref_customer' => NULL,
		'date_creation' => static::$datetime,
		'fk_user_author' => static::D_K_USER,
		'fk_user_modif' => NULL,
		'date_valid' => NULL,
		'fk_user_valid' => NULL,
		'date_delivery' => NULL,
		'date_expedition' => NULL,
		'fk_address' => '',
		'fk_shipping_method' => '',
		'tracking_number' => '',
		'fk_statut' => '',
		'billed' => '',
		'height' => '',
		'width' => '',
		'size_units' => '',
		'size' => '',
		'weight_units' => '',
		'weight' => '',
		'note_private' => '',
		'note_public' => '',
		'model_pdf' => '',
		'last_main_doc' => '',
		'fk_incoterms' => '',
		'location_incoterms' => '',
		'import_key' => '',
		'extraparams' => '',
	];

	return $row;
}
public function pd_expedition_update_map($id, $d_data, $p_data)
{
	//
	$row = [
		'tms' => static::$datetime,
		'fk_user_modif' => static::D_K_USER,
	];

	return $row;
}

public function shipping_row(&$p_data, $fk_order)
{
	if (empty($p_data['orders']['total_shipping_tax_incl']) || $p_data['orders']['total_shipping_tax_incl']==0)
		return;

	// @todo
	$p_data['order_carrier'];
	var_dump($p_data['orders']['total_shipping_tax_excl']);
	var_dump($p_data['orders']['total_shipping_tax_excl']!=0);
	$tva = ($p_data['orders']['total_shipping_tax_incl']-$p_data['orders']['total_shipping_tax_excl']);
	$tva_coeff = (isset($p_data['orders']['total_shipping_tax_excl']) ?round($p_data['orders']['total_shipping_tax_incl']/$p_data['orders']['total_shipping_tax_excl'], 3) :1);
	$tva_coeff_2 = (isset($p_data['orders']['total_shipping_tax_excl']) ?round($p_data['orders']['total_shipping_tax_incl']/$p_data['orders']['total_shipping_tax_excl'], 2) :1);
	// On se prémuit des bugs d'arrondi de TVA
	if ($tva_coeff_2==1.2)
		$tva_coeff = 1.2;
	$tva_tx = round(100*($tva_coeff-1), 2);
	
	// @todo: fk_product_fournisseur_price
	
	$row = [
		//'rowid' => NULL,
		'fk_commande' => $fk_order,
		'fk_parent_line' => NULL,
		'fk_product' => static::D_K_SHIPPING_PRODUCT,
		'label' => static::D_SHIPPING_PRODUCT_NAME,
		'description' => '',
		'vat_src_code' => '',
		'tva_tx' => $tva_tx,
		'localtax1_tx' => 0,
		'localtax1_type' => 0,
		'localtax2_tx' => 0,
		'localtax2_type' => 0,
		'qty' => 1,
		'remise_percent' => 0,
		'remise' => 0,
		'fk_remise_except' => NULL,
		'price' => $p_data['orders']['total_shipping_tax_excl'],
		'subprice' => $p_data['orders']['total_shipping_tax_excl'],
		'total_ht' => $p_data['orders']['total_shipping_tax_excl'],
		'total_tva' => $tva,
		'total_localtax1' => 0,
		'total_localtax2' => 0,
		'total_ttc' => $p_data['orders']['total_shipping_tax_incl'],
		'product_type' => 1,
		'date_start' => NULL,
		'date_end' => NULL,
		'info_bits' => 0,
		'buy_price_ht' => $p_data['orders']['total_shipping_tax_excl'],
		'fk_product_fournisseur_price' => NULL, // @todo
		'special_code' => 0,
		'rang' => 0,
		'fk_unit' => NULL,
		'import_key' => NULL,
		'fk_commandefourndet' => NULL,
		'fk_multicurrency' => NULL,
		'multicurrency_code' => 'EUR',
		'multicurrency_subprice' => $p_data['orders']['total_shipping_tax_excl'],
		'multicurrency_total_ht' => $p_data['orders']['total_shipping_tax_excl'],
		'multicurrency_total_tva' => $tva,
		'multicurrency_total_ttc' => $p_data['orders']['total_shipping_tax_incl'],
		'ref_ext' => NULL,
	];
	
	return $row;
}

public function ecotax_row(&$p_data, &$d_data, $fk_order)
{
	// @todo tax depends only of shipping/client
	$ecotax_tva_tx = 20;
	$ecotax_tva_coeff = 1+$ecotax_tva_tx/100;

	$price = 0;

	foreach($p_data['order_detail'] as $crow) {
		//var_dump($crow);
		if ($crow['ecotax']>0) {
			$price += round($crow['ecotax']*$crow['product_quantity'], 2);
		}
	}
	
	if ($price==0)
		return;

	$price_tva = round($price*($ecotax_tva_tx/100), 2);
	$price_ttc = $price+$price_tva;

	$row = [
		//'rowid' => NULL,
		'fk_commande' => $fk_order,
		'fk_parent_line' => NULL,
		'fk_product' => D_K_ECOTAX_PRODUCT,
		'label' => D_ECOTAX_PRODUCT_NAME,
		'description' => '',
		'vat_src_code' => '',
		'tva_tx' => $ecotax_tva_tx,
		'localtax1_tx' => 0,
		'localtax1_type' => 0,
		'localtax2_tx' => 0,
		'localtax2_type' => 0,
		'qty' => 1,
		'remise_percent' => 0,
		'remise' => 0,
		'fk_remise_except' => NULL,
		'price' => $price,
		'subprice' => $price,
		'total_ht' => $price,
		'total_tva' => $price_tva,
		'total_localtax1' => 0,
		'total_localtax2' => 0,
		'total_ttc' => $price_ttc,
		'product_type' => 1,
		'date_start' => NULL,
		'date_end' => NULL,
		'info_bits' => 0,
		'buy_price_ht' => $price,
		'fk_product_fournisseur_price' => NULL, // @todo
		'special_code' => 2, // 2 = ECOTAX
		'rang' => 0,
		'fk_unit' => NULL,
		'import_key' => NULL,
		'fk_commandefourndet' => NULL,
		'fk_multicurrency' => NULL,
		'multicurrency_code' => 'EUR',
		'multicurrency_subprice' => $price,
		'multicurrency_total_ht' => $price,
		'multicurrency_total_tva' => $price_tva,
		'multicurrency_total_ttc' => $price_ttc,
		'ref_ext' => NULL,
	];

	return $row;
}

public function discount_rows(&$p_data, $fk_order)
{
	if (!isset($p_data['orders']['total_discounts_tax_incl']) || $p_data['orders']['total_discounts_tax_incl']==0)
		return;
	
	$lines = [];
	foreach($p_data['order_cart_rule'] as $row) {
		$tva = ($row['value']-$row['value_tax_excl']);
		$tva_tx = ($row['value_tax_excl']!=0 ?round(100*$tva/$row['value_tax_excl'], 2) :0);

		$lines[] = [
			//'rowid' => NULL,
			'fk_commande' => $fk_order,
			'fk_parent_line' => NULL,
			'fk_product' => static::D_K_DISCOUNT_PRODUCT,
			'label' => static::D_DISCOUNT_PRODUCT_NAME,
			'description' => $row['name'],
			'vat_src_code' => '',
			'tva_tx' => $tva_tx, // @todo
			'localtax1_tx' => 0,
			'localtax1_type' => 0,
			'localtax2_tx' => 0,
			'localtax2_type' => 0,
			'qty' => 1,
			'remise_percent' => 0,
			'remise' => 0,
			'fk_remise_except' => NULL,
			'price' => $row['value_tax_excl'],
			'subprice' => $row['value_tax_excl'],
			'total_ht' => -$row['value_tax_excl'],
			'total_tva' => -$tva,
			'total_localtax1' => 0,
			'total_localtax2' => 0,
			'total_ttc' => -$row['value'],
			'product_type' => 1,
			'date_start' => NULL,
			'date_end' => NULL,
			'info_bits' => 0,
			'buy_price_ht' => 0,
			'fk_product_fournisseur_price' => NULL, // @todo
			'special_code' => 0,
			'rang' => 0,
			'fk_unit' => NULL,
			'import_key' => NULL,
			'fk_commandefourndet' => NULL,
			'fk_multicurrency' => NULL,
			'multicurrency_code' => 'EUR',
			'multicurrency_subprice' => $row['value_tax_excl'],
			'multicurrency_total_ht' => -$row['value_tax_excl'],
			'multicurrency_total_tva' => -$tva,
			'multicurrency_total_ttc' => -$row['value'],
			'ref_ext' => NULL,
		];
	}
	return $lines;
}

// -- MAPPING --

public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	// Sous condition expédié/livré, on bloque les modifications P=>D sauf les statuts
	//$id = $o['d_oid'];
	if (static::d_locked($d_data)) {
		$d_data_map = [
			'commande' => [
				'tms' => max($p_data['orders']['date_upd'], $d_data['commande']['tms']),
			],
			'commande_extrafields' => [
				'p_state' => $p_data['orders']['current_state'],
				'p_ref' => $p_data['orders']['reference'],
			],
		];

		// Shipping method if not defined
		if (empty($d_data['commande']['fk_shipping_method']))
			$d_data_map['commande']['fk_shipping_method'] =  static::_pd_map_fk_shipping_method($p_data);
	}
	else {
		$d_data_map = [
			'commande' => [
				//'ref' => $ref,

				'total_ht' => $p_data['orders']['total_paid_tax_excl'],
				'total_tva' => ($p_data['orders']['total_paid_tax_incl']-$p_data['orders']['total_paid_tax_excl']),
				'total_ttc' => $p_data['orders']['total_paid_tax_incl'],
				'multicurrency_total_ht' => $p_data['orders']['total_paid_tax_excl'], // @todo
				'multicurrency_total_tva' => ($p_data['orders']['total_paid_tax_incl']-$p_data['orders']['total_paid_tax_excl']), // @todo
				'multicurrency_total_ttc' => $p_data['orders']['total_paid_tax_incl'], // @todo
				
				//'date_commande' => substr(($p_data['orders']['invoice_date']&&$p_data['orders']['invoice_date']!='0000-00-00 00:00:00' ?$p_data['orders']['invoice_date'] :$p_data['orders']['date_add']), 0, 10),
				
				//'fk_statut' => static::_pd_map_fk_status($p_data),
				'fk_mode_reglement' => static::_pd_map_fk_mode_reglement($p_data),
				'fk_shipping_method' => static::_pd_map_fk_shipping_method($p_data),

				'fk_user_modif' => static::D_K_USER,
				'tms' => max($p_data['orders']['date_upd'], isset($d_data['commande']) ?$d_data['commande']['tms']: 0),
				//'note_private' => $p_data['orders']['note'],
			],
			'commande_extrafields' => [
				'p_state' => $p_data['orders']['current_state'],
				'p_ref' => $p_data['orders']['reference'],
			],
			'element_contact_shipping' => [
				//'datecreate' => static::$datetime,
				//'statut' => 4,
				//'element_id' => $id,
				//'fk_c_type_contact' => static::$d_contact_map['shipping'],
				'fk_socpeople' => static::_pd_map_fk_shipping_addr($p_data),
			],
			'element_contact_invoice' => [
				//'datecreate' => static::$datetime,
				//'statut' => 4,
				//'element_id' => $id,
				//'fk_c_type_contact' => static::$d_contact_map['invoice'],
				'fk_socpeople' => static::_pd_map_fk_invoice_addr($p_data),
			],
		];

		// Si note privée
		if (isset($p_data['orders']['note'])) {
			$d_data_map['commande']['note_private'] = $p_data['orders']['note'];
		}
	}

	// Uniquement les status pris en charge !
	if (is_numeric($fk_statut=static::_pd_map_fk_status($p_data))) {
		// Passage en Expédié/Livré depuis Presta
		if ($fk_statut>=2) {
			// Expédié sans expédition => on laisse en statut validé si on avait pas déjà un statut expédié/livré
			if (empty($d_data['expedition']) && (empty($d_data['commande']['fk_statut']) || $d_data['commande']['fk_statut']<=1))
				$d_data_map['commande']['fk_statut'] = 1;
			// Si passage libvré avec au moins une expé ou déjà un statut expédié
			elseif ($fk_statut == 3)
				$d_data_map['commande']['fk_statut'] = $fk_statut;
		}
		// Passage Brouillon/Validé
		elseif (empty($d_data['commande']['fk_statut']) || $d_data['commande']['fk_statut']<=1)
			$d_data_map['commande']['fk_statut'] = $fk_statut;
	}
	
	return $d_data_map;
}

public function pd_map_create(&$o, &$p_data)
{
	//$id = $o['p_oid'];

	$date_commande = substr(($p_data['orders']['invoice_date']&&$p_data['orders']['invoice_date']!='0000-00-00 00:00:00' ?$p_data['orders']['invoice_date'] :$p_data['orders']['date_add']), 0, 10);
	$ref = static::d_ref($date_commande);
		
	$d_data_map = [
		'commande' => [
			//'rowid' => NULL,
			'ref' => $ref,
			'entity' => 1,
			'ref_ext' => NULL,
			'ref_int' => NULL,
			'ref_client' => !empty($p_data['orders']['ref_client']) ?$p_data['orders']['ref_client'] :'',
			'fk_soc' => static::_pd_map_fk_customer($p_data),
			'fk_projet' => NULL,
			'tms' => $p_data['orders']['date_upd'],
			'date_creation' => $p_data['orders']['date_add'],
			'date_valid' => NULL,
			'date_cloture' => NULL,
			'date_commande' => $date_commande,
			'fk_user_author' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			'fk_user_valid' => NULL,
			'fk_user_cloture' => NULL,
			'source' => NULL,
			'fk_statut' => static::_pd_map_fk_status($p_data),
			'amount_ht' => '0',
			'remise_percent' => '0',
			'remise_absolue' => NULL,
			'remise' => '0', // @todo
			'total_tva' => ($p_data['orders']['total_paid_tax_incl']-$p_data['orders']['total_paid_tax_excl']),
			'localtax1' => '0',
			'localtax2' => '0',
			'total_ht' => $p_data['orders']['total_paid_tax_excl'],
			'total_ttc' => $p_data['orders']['total_paid_tax_incl'],
			'note_private' => NULL,
			'note_public' => NULL,
			'model_pdf' => NULL,
			'last_main_doc' => '',
			'module_source' => NULL,
			'pos_source' => NULL,
			'facture' => '0', // 1 = facture ?
			'fk_account' => NULL,
			'fk_currency' => NULL,
			'fk_cond_reglement' => NULL,
			'fk_mode_reglement' => static::_pd_map_fk_mode_reglement($p_data),
			'date_livraison' => NULL,
			'fk_shipping_method' => static::_pd_map_fk_shipping_method($p_data),
			'fk_warehouse' => NULL,
			'fk_availability' => NULL,
			'fk_input_reason' => 1, // @todo kesako ?
			'fk_delivery_address' => NULL, // @todo
			'fk_incoterms' => 0,
			'location_incoterms' => '',
			'import_key' => NULL,
			'extraparams' => NULL,
			'fk_multicurrency' => 0,
			'multicurrency_code' => 'EUR',
			'multicurrency_tx' => '1',
			'multicurrency_total_ht' => $p_data['orders']['total_paid_tax_excl'], // @todo
			'multicurrency_total_tva' => ($p_data['orders']['total_paid_tax_incl']-$p_data['orders']['total_paid_tax_excl']), // @todo
			'multicurrency_total_ttc' => $p_data['orders']['total_paid_tax_incl'], // @todo
			//'total_tva ' => '', // @todo
		],
		'commande_extrafields' => [
			'sync' => 1,
		],
		'element_contact_shipping' => [
			'datecreate' => static::$datetime,
			'statut' => 4,
			//'element_id' => $id,
			'fk_c_type_contact' => static::$d_contact_map['shipping'],
			'fk_socpeople' => static::_pd_map_fk_shipping_addr($p_data),
		],
		'element_contact_invoice' => [
			'datecreate' => static::$datetime,
			'statut' => 4,
			//'element_id' => $id,
			'fk_c_type_contact' => static::$d_contact_map['invoice'],
			'fk_socpeople' => static::_pd_map_fk_invoice_addr($p_data),
		],
	];
	
	// 
	if (empty($d_data_map['commande']['fk_soc'])) {
		// Pas de id_customer => Réaffectation
		if (empty($p_data['orders']['id_customer'])) {
		}
		// id_customer mais pas de customer => recréation customer avec données par défaut
		elseif (empty($p_data['customer'])) {
			$customer_data = [
				'id_customer' => $p_data['orders']['id_customer'],
				'',
			];
			//$q = DB::p_insert_row('customer', $customer_data);
		}
	}
	
	return $d_data_map;
}

// -----------

// Field MAPPING

public static function _pd_map_id_tax_rules_group(&$orig_data, &$dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['product']['tva_tx']) {
		case '20':
			return 1;
		case '10':
			return 2;
		case '5.5':
			return 3;
		case '2.1':
			return 4;
		case '0':
			return 5;
	}
}

public static function _pd_map_fk_invoice_addr(&$orig_data, &$dest_tree=[])
{
	return static::_pd_map_fk('address', 'address', $orig_data['orders']['id_address_invoice']);
}

public static function _pd_map_fk_shipping_addr(&$orig_data, &$dest_tree=[])
{
	return static::_pd_map_fk('address', 'address', $orig_data['orders']['id_address_delivery']);
}

public static function _pd_map_fk_customer(&$orig_data, &$dest_tree=[])
{
	return static::_pd_map_fk('customer', 'customer', $orig_data['orders']['id_customer']);
}

// Presta : champs payment & module
// Doli : champs fk_mode_reglement associé à table c_paiement
// @todo : Attention, le mapping se fait à la mano, voir pour améliorer

protected static $_modes_reglement = [
	'cheque' => [
		'p' => [
			'payment' => 'Chèque',
			'module' => 'ps_checkpayment',
		],
		'd' => [
			'fk_mode_reglement' => 7,
		],
	],
	'virement' => [
		'p' => [
			'payment' => 'Virement',
			'module' => 'ps_wirepayment',
		],
		'd' => [
			'fk_mode_reglement' => 2,
		],
	],
	'etransactions' => [
		'p' => [
			'payment' => 'E-Transactions',
			'module' => 'etransactions',
		],
		'd' => [
			// @todo carte internet, rechercher par code !
			'fk_mode_reglement' => D_K_PAIEMENT_CBI,
		],
	],
	'manuel' => [
		'p' => [
			'payment' => 'Commande depuis le backoffice',
			'module' => 'bo_order',
		],
		'd' => [
			'fk_mode_reglement' => NULL,
		],
	],
];

public static function _pd_map_fk_mode_reglement(&$orig_data, &$dest_tree=[])
{
	foreach(static::$_modes_reglement as $mode) {
		if ($orig_data['orders']['module'] == $mode['p']['module'])
			return $mode['d']['fk_mode_reglement'];
	}
}

protected static function _pd_map_fk_shipping_method(&$orig_data, &$dest_tree=[])
{
	// @todo précharger la liste depuis Doli, utiliser les noms court pour synchroniser
	//var_dump($orig_data['orders']['id_carrier'], static::$_p_carriers[$orig_data['orders']['id_carrier']]); die();
	// @todo : mapper proprement avec table de correspondance en utilisant le code Doli !
	if (empty($orig_data['orders']['id_carrier']) || empty(static::$_p_carriers[$orig_data['orders']['id_carrier']]))
		return;
	$carrier = static::$_p_carriers[$orig_data['orders']['id_carrier']];
	//var_dump($carrier); die();

	// Welco
	if($carrier['external_module_name']=='welco')
		return 15;
	// DPD
	elseif($carrier['external_module_name']=='dpdfrance') {
		// Relais pickup
		if (is_numeric(strpos($carrier['name'], 'relais')))
			return 16;
		// DPD predict
		else
			return 13;
	}
	// Geodis
	elseif($carrier['external_module_name']=='geodisofficiel')
		return NULL; // A faire
	// Chronopost
	elseif($carrier['external_module_name']=='Chronopost')
		return NULL; // A faire
	// GLS
	elseif($carrier['external_module_name']=='gls')
		return NULL; // A faire
	// Retrait boutique
	elseif(substr($carrier['name'], 0, 8)=='Retrait ' || substr($carrier['delay'], 0, 8)=='Retrait ')
		return 9;
	//die('no carrier');
}

public static function _pd_map_fk_status(&$orig_data, &$dest_tree=[])
{
	//var_dump(static::$_p_order_state_map);
	return (isset($orig_data['orders']['current_state']) && isset(static::$_p_order_state_map[$orig_data['orders']['current_state']])
		?static::$_p_order_state_map[$orig_data['orders']['current_state']]['statut']
		:NULL);
}

}

sync_order_pd::__init();
