<?php

class sync_order_detail_dp extends sync_order_detail
{

const DP_DELETE = true;

public static function dp_check_sync(&$o, &$d_data)
{
	// On désactive.
	return false;
}

public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
	if ($o['p_tref']=='order_detail') {
		static::p_insert_row('order_detail_tax', ['id_order_detail'=>$o['p_oid']], $p_data_map);
	}
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	if ($o['p_tref']=='order_detail') {
		static::p_update_row('order_detail_tax', ['id_order_detail'=>$o['p_oid']], $p_data_map, $p_data_map_create, $p_data);
	}
}

// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	// @todo vérif si commande statut bloqué
	//if ()
	
	if ($o['p_tref']=='order_cart_rule') {
		$p_data_map = [
			'order_cart_rule' => [
				//'id_order_cart_rule' => NULL,
				//'id_order' => static::_dp_map_fk_order($d_data),
				'id_cart_rule' => static::P_K_DISCOUNT_CART_RULE, // 
				//'id_order_invoice' => 0,
				'name' => ($d_data['commandedet']['description'] ?$d_data['commandedet']['description'] :($d_data['commandedet']['label'] ?$d_data['commandedet']['label'] :$d_data['product']['label'])),
				'value' => -$d_data['commandedet']['total_ttc'],
				'value_tax_excl' => -$d_data['commandedet']['total_ht'],
				'free_shipping' => 1, // si static::P_K_FREESHIPPING_CART_RULE
			],
		];

	}
	elseif ($o['p_tref']=='order_detail') {
		$product = static::_dp_map_fk_product($d_data['commandedet']['fk_product']);
		$id_tax = static::_dp_map_id_tax_rules_group($d_data);

		$p_data_map = [
			'order_detail' => [
				//'id_order_detail' => '',
				//'id_order' => static::_dp_map_fk_order($d_data),
				//'id_order_invoice' => '0',
				//'id_warehouse' => '0',
				//'id_shop' => P_SHOP_ID,
				//'product_id' => $product['id_product'],
				//'product_attribute_id' => $product['id_product_attribute'],
				//'id_customization' => '0', // @todo !
				//'product_name' => ($d_data['commandedet']['label'] ?$d_data['commandedet']['label'] :$d_data['product']['label']),
				'product_quantity' => $d_data['commandedet']['qty'],
				//'product_quantity_in_stock' => $d_data['commandedet']['qty'], // @todo
				//'product_quantity_refunded' => 0,
				//'product_quantity_return' => 0,
				//'product_quantity_reinjected' => 0,
				//'product_price' => $d_data['commandedet']['subprice'],
				'reduction_percent' => 0, //$d_data['commandedet']['remise_percent'], // l'un ou l'autre ..?
				'reduction_amount' => round($d_data['commandedet']['remise']*(1+$d_data['product']['tva_tx']/100), 6),
				'reduction_amount_tax_incl' => round($d_data['commandedet']['remise']*(1+$d_data['product']['tva_tx']/100), 6),
				'reduction_amount_tax_excl' => $d_data['commandedet']['remise'],
				//'group_reduction' => 0,
				//'product_quantity_discount' => 0, // @todo
				//'product_ean13' => static::_dp_map_ean13($d_data),
				//'product_isbn' => static::_dp_map_isbn($d_data),
				//'product_upc' => static::_dp_map_upc($d_data),
				//'product_reference' => $d_data['product']['ref'],
				//'product_supplier_reference' => '', // @todo $d_data['product']['ref'],
				//'product_weight' => ($d_data['product']['weight'] ?$d_data['product']['weight'] :0),
				'id_tax_rules_group' => $id_tax,
				'tax_computation_method' => 0,
				//'tax_name' => '',
				'tax_rate' => $d_data['product']['tva_tx'],
				//'ecotax' => 0,
				//'ecotax_tax_rate' => 0,
				//'discount_quantity_applied' => 0,
				//'download_hash' => '',
				//'download_nb' => 0,
				//'download_deadline' => '0000-00-00 00:00:00',
				'total_price_tax_incl' => $d_data['commandedet']['total_ttc'],
				'total_price_tax_excl' => $d_data['commandedet']['total_ht'],
				'unit_price_tax_incl' => round($d_data['commandedet']['price']*(1+$d_data['product']['tva_tx']/100), 6),
				'unit_price_tax_excl' => $d_data['commandedet']['price'],
				//'total_shipping_price_tax_incl' => 0, // @todo shipping product specific
				//'total_shipping_price_tax_excl' => 0,
				//'purchase_supplier_price' => $d_data['commandedet']['buy_price_ht'],
				//'original_product_price' => (isset($p_data['order_detail']) && $p_data['order_detail']['product_id']==$product['id_product'] && $p_data['order_detail']['product_attribute_id']==$product['id_product_attribute'] ?$p_data['original_product_price'] :$d_data['commandedet']['subprice']), // Pas de changement de produit => pas de changement de prix de base
				//'original_wholesale_price' => $d_data['commandedet']['buy_price_ht'],
				//'sc_attr_infos_v1' => NULL,
				//'sc_qc_product_price' => 0,
			],
			'order_detail_tax' => [
				//'id_order_detail' => NULL,
				'id_tax' => $id_tax,
				'unit_amount' => round($d_data['commandedet']['price']*($d_data['product']['tva_tx']/100), 6),
				'total_amount' => round($d_data['commandedet']['total_ttc']-$d_data['commandedet']['total_ht'], 6),
			],
		];

		// Nouveau produit / Changement de produit
		if (empty($p_data['order_detail']) || $p_data['order_detail']['product_id']!=$product['id_product'] || $p_data['order_detail']['product_attribute_id']!=$product['id_product_attribute']) {
			$p_data_map['order_detail']['total_shipping_price_tax_incl'] = 0; // @todo shipping product specific
			$p_data_map['order_detail']['total_shipping_price_tax_excl'] = 0;
			$p_data_map['order_detail']['product_id'] = $product['id_product'];
			$p_data_map['order_detail']['product_attribute_id'] = $product['id_product_attribute'];
			$p_data_map['order_detail']['id_customization'] = '0'; // @todo !
			$p_data_map['order_detail']['product_name'] = ($d_data['commandedet']['label'] ?$d_data['commandedet']['label'] :$d_data['product']['label']);
			$p_data_map['order_detail']['product_quantity_in_stock'] = $d_data['commandedet']['qty']; // @todo
			$p_data_map['order_detail']['product_price'] = $d_data['commandedet']['subprice'];
			$p_data_map['order_detail']['product_ean13'] = static::_dp_map_ean13($d_data);
			$p_data_map['order_detail']['product_isbn'] = static::_dp_map_isbn($d_data);
			$p_data_map['order_detail']['product_upc'] = static::_dp_map_upc($d_data);
			$p_data_map['order_detail']['product_reference'] = $d_data['product']['ref'];
			$p_data_map['order_detail']['product_supplier_reference'] = ''; // @todo $d_data['product']['ref'],
			$p_data_map['order_detail']['product_weight'] = ($d_data['product']['weight'] ?$d_data['product']['weight'] :0);
			$p_data_map['order_detail']['total_shipping_price_tax_incl'] = 0; // @todo shipping product specific
			$p_data_map['order_detail']['total_shipping_price_tax_excl'] = 0;
			$p_data_map['order_detail']['purchase_supplier_price'] = $d_data['commandedet']['buy_price_ht'];
			$p_data_map['order_detail']['original_product_price'] = $d_data['commandedet']['subprice'];
			$p_data_map['order_detail']['original_wholesale_price'] = $d_data['commandedet']['buy_price_ht'];
		}
	}

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{	
	// Discount => Cart rule
	if (isset($d_data['commandedet']) && $d_data['commandedet']['fk_product']==static::D_K_DISCOUNT_PRODUCT) {
		// Sinon on risque de remapper le même oid sur un autre type d'objet...
		// @todo : Dans ce cas, si on change le mapping, en cas de recréation, il faut supprimer l'ancienne association !
		if (!empty($o['p_tref']) && !empty($o['p_oid']) && $o['p_tref']!='order_cart_rule') {
			var_dump($o);
			return;
		}
		$o['p_tref'] = 'order_cart_rule';

		$p_data_map = [
			'order_cart_rule' => [
				//'id_order_cart_rule' => NULL,
				'id_order' => static::_dp_map_fk_order($d_data),
				'id_cart_rule' => static::P_K_DISCOUNT_CART_RULE, // 
				'id_order_invoice' => 0,
				'name' => ($d_data['commandedet']['description'] ?$d_data['commandedet']['description'] :($d_data['commandedet']['label'] ?$d_data['commandedet']['label'] :$d_data['product']['label'])),
				'value' => -$d_data['commandedet']['total_ttc'],
				'value_tax_excl' => -$d_data['commandedet']['total_ht'],
				'free_shipping' => 1, // si static::P_K_FREESHIPPING_CART_RULE
			],
		];
	}
	else {
		// Sinon on risque de remapper le même oid sur un autre type d'objet...
		// @todo : Dans ce cas, si on change le mapping, en cas de recréation, il faut supprimer l'ancienne association !
		if (!empty($o['p_tref']) && !empty($o['p_oid']) && $o['p_tref']!='order_detail') {
			var_dump($o);
			return;
		}
		$o['p_tref'] = 'order_detail';
		$product = static::_dp_map_fk_product($d_data['commandedet']['fk_product']);
		$id_tax = static::_dp_map_id_tax_rules_group($d_data);

		$p_data_map = [
			'order_detail' => [
				//'id_order_detail' => '',
				'id_order' => static::_dp_map_fk_order($d_data),
				'id_order_invoice' => '0',
				'id_warehouse' => '0',
				'id_shop' => P_SHOP_ID,
				'product_id' => $product['id_product'],
				'product_attribute_id' => $product['id_product_attribute'],
				'id_customization' => '0', // @todo !
				'product_name' => ($d_data['commandedet']['label'] ?$d_data['commandedet']['label'] :$d_data['product']['label']),
				'product_quantity' => $d_data['commandedet']['qty'],
				'product_quantity_in_stock' => $d_data['commandedet']['qty'], // @todo
				'product_quantity_refunded' => 0,
				'product_quantity_return' => 0,
				'product_quantity_reinjected' => 0,
				'product_price' => $d_data['commandedet']['price'],
				'reduction_percent' => $d_data['commandedet']['remise_percent'],
				'reduction_amount' => $d_data['commandedet']['remise'],
				'reduction_amount_tax_incl' => $d_data['commandedet']['remise'],
				'reduction_amount_tax_excl' => $d_data['commandedet']['remise'], // @todo TVA
				'group_reduction' => 0,
				'product_quantity_discount' => 0, // @todo
				'product_ean13' => static::_dp_map_ean13($d_data),
				'product_isbn' => static::_dp_map_isbn($d_data),
				'product_upc' => static::_dp_map_upc($d_data),
				'product_reference' => $d_data['product']['ref'],
				'product_supplier_reference' => '', // @todo $d_data['product']['ref'],
				'product_weight' => ($d_data['product']['weight'] ?$d_data['product']['weight'] :0),
				'id_tax_rules_group' => $id_tax,
				'tax_computation_method' => 0,
				'tax_name' => '',
				'tax_rate' => $d_data['product']['tva_tx'],
				'ecotax' => 0,
				'ecotax_tax_rate' => 0,
				'discount_quantity_applied' => 0,
				'download_hash' => '',
				'download_nb' => 0,
				'download_deadline' => '0000-00-00 00:00:00',
				'total_price_tax_incl' => $d_data['commandedet']['total_ttc'],
				'total_price_tax_excl' => $d_data['commandedet']['total_ht'],
				'unit_price_tax_incl' => $d_data['commandedet']['price']*(1+$d_data['product']['tva_tx']/100),
				'unit_price_tax_excl' => $d_data['commandedet']['price'],
				'total_shipping_price_tax_incl' => 0, // @todo shipping product specific
				'total_shipping_price_tax_excl' => 0,
				'purchase_supplier_price' => $d_data['commandedet']['buy_price_ht'],
				'original_product_price' => $d_data['commandedet']['subprice'],
				'original_wholesale_price' => $d_data['commandedet']['buy_price_ht'],
				'sc_attr_infos_v1' => NULL,
				'sc_qc_product_price' => 0,
			],
			'order_detail_tax' => [
				//'id_order_detail' => NULL,
				'id_tax' => $id_tax,
				'unit_amount' => $d_data['commandedet']['price']*($d_data['product']['tva_tx']/100),
				'total_amount' => $d_data['commandedet']['total_ttc']-$d_data['commandedet']['total_ht'],
			],
		];
	}

	return $p_data_map;
}

// -----------

// Field MAPPING

public static function _dp_map_fk_order(&$orig_data, &$dest_tree=[])
{
	return static::_dp_map_fk('order', 'commande', $orig_data['commandedet']['fk_commande']);
}

public static function _dp_map_id_tax_rules_group(&$orig_data, &$dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['product']['tva_tx']) {
		case '20':
			return 1;
		case '10':
			return 2;
		case '5.5':
			return 3;
		case '2.1':
			return 4;
		case '0':
			return 5;
	}
}

public static function _dp_map_ean13(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==2) ?substr($orig_data['product']['barcode'], 0, 13) :NULL;
}
public static function _dp_map_ean8(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==1) ?$orig_data['product']['barcode'] :NULL;
}
public static function _dp_map_isbn(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==4) ?$orig_data['product']['barcode'] :NULL;
}
public static function _dp_map_upc(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==3) ?$orig_data['product']['barcode'] :NULL;
}

}

sync_order_detail_dp::__init();
