<?php

class sync_order_detail_pd extends sync_order_detail
{

const PD_DELETE = true;

// -- CHECK --

public static function d_locked(&$d_data)
{
	return (!empty($d_data['commande']) && in_array($d_data['commande']['fk_statut'], [2, 3]))
		|| (!empty($d_data['commande_extrafields']) && !$d_data['commande_extrafields']['sync']);
}

public static function pd_check_create(&$o, &$d_data_map, &$p_data)
{
	// @todo refaire, c'est bien de la merde...
	$fk_order = static::_pd_map_fk_order($p_data);
	if (empty($fk_order))
		return false;
	static::_class('order', 'pd');
	$c = new sync_order_pd();
	$order_d_data = $c->d_data('commande', $fk_order);
	var_dump($order_d_data);
	// Si déjà validé on ne met à jour que le status presta
	if (static::d_locked($d_data))
		return false;
	// Si règle panier à 0 => pas de synchro (genre une remise sans remise...)
	if ($o['p_tref']=='order_cart_rule' && !empty($p_data['order_cart_rule']) && $p_data['order_cart_rule']['value_tax_excl']==0)
		return false;
	
	return $d_data_map;
	//die();
}

public static function pd_check_update(&$o, &$d_data_map_update, &$d_data_map_create, &$d_data, &$p_data)
{
	// @todo refaire, c'est bien de la merde...
	if (empty($d_data)) {
		// passage par référence => création de variable obligatoire
		$d_data_map_mixed = array_merge($d_data_map_update, $d_data_map_create);
		if (static::pd_check_create($o, $d_data_map_mixed, $p_data))
			return $d_data_map_update;
	}

	// Si déjà validé on ne met à jour que le status presta
	if (static::d_locked($d_data))
		return false;
	
	return $d_data_map_update;
}

public static function pd_check_delete(&$o, &$d_data)
{
	// Si déjà validé ou désynchronisé, on ne modifie rien
	if (static::d_locked($d_data))
		return false;
	//die();
	return true;
}

// -- SUB ACTIONS --

public function pd_insert_more(&$o, &$d_data, &$p_data)
{
	$id = $o['d_oid'];

	// Pack produit => élatement
	var_dump($p_data);
	if ($o['p_tref']=='order_detail') {
		if (!empty($p_data['product']['cache_is_pack']) && PRODUCT_PACK_SPLIT) {
			$o_id = $p_data['order_detail']['id_order'];
			$p_id = $p_data['order_detail']['product_id'];

			$l = DB::p_get_rows('pack', ['id_product_pack'=>$p_id]);
			//var_dump($l);
			echo '<p>Eclatement du pack</p>';
			foreach($l as $row) {
				$p = DB::p_get_row('product_lang', ['id_product'=>$row['id_product_item']]);
				$row2 = [
					'id_product_pack' => $row['id_product_pack'],
					'id_order' => $o_id,
					'id_product' => $row['id_product_item'],
					'id_product_attribute' => $row['id_product_attribute_item'],
					'qte' => ($row['quantity']*$p_data['order_detail']['product_quantity']),
					'product_name' => $p['name'].' (dans box/pack)',
					'product_description' => 'Contenu dans : '.$p_data['order_detail']['product_name'],
				];
				var_dump($row); var_dump($row2);
				$d_map_row = $this->map_create_pack($o, $row2);
				var_dump($d_map_row);
				$oid = DB::d_insert_row('commandedet', $d_map_row['commandedet']);
				$oid2 = DB::d_insert_row('commandedet_extrafields', array_merge($d_map_row['commandedet_extrafields'], ['fk_object'=>$oid]));
			}
			// Déclenche le trigger de recalcul si le produit est un kit
			$this->trigger_stock_kit_api($p_data['order_detail']['product_id'], $p_data['order_detail']['product_attribute_id']);
		}
		else {
			// Check + Déclenche le trigger de recalcul si le produit est dans un kit
			$this->trigger_stock_inkit_api($p_data['order_detail']['product_id'], $p_data['order_detail']['product_attribute_id']);
		}
	}

}
/**
 * Déclenche le trigger de recalcul si le produit est un kit
 */
public function trigger_stock_kit_api($id_product, $id_product_attribute=0)
{
	if (!($fk_product = static::_pd_map_fk_product2($id_product, $id_product_attribute)))
		return false;
	
	return static::_d_api('GET', 'mmiproductdluoapi/kit_stock_calculate/'.$fk_product);
}
/**
 * Check + Déclenche le trigger de recalcul si le produit est dans un kit
 */
public function trigger_stock_inkit_api($id_product, $id_product_attribute=0)
{
	if (!($fk_product = static::_pd_map_fk_product2($id_product, $id_product_attribute)))
		return false;
	
	$sql = 'SELECT DISTINCT fk_product_pere
		FROM '.DB_D_PREFIX.'product_association
		WHERE fk_product_fils = '.$fk_product;
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc()) {
		$fk_product_kit = $row['fk_product_pere'];
		static::_d_api('GET', 'mmiproductdluoapi/kit_stock_calculate/'.$fk_product_kit);
	}
	return !empty($fk_product_kit);
}
public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
	$id = $o['d_oid'];

	// commandedet_extrafields
	static::d_update_row('commandedet_extrafields', ['fk_object'=>$id], $d_data_map, $d_data_map_create, $d_data);

	$this->trigger_stock_inkit_api($p_data['order_detail']['product_id'], $p_data['order_detail']['product_attribute_id']);

	// Recalcul expé si qte modifiée
	if (!empty($d_data['commande']) && empty($d_data['commande']['fk_statut']>0))
		static::_d_api('GET', 'mmiprestasyncapi/commande_expe_all_calculate/'.$d_data['commande']['rowid']);
}

// -- MAPPING --

public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	$p_id = isset($o['p_oid']) ?$o['p_oid'] :NULL;
	
	if ($o['p_tref']=='order_detail') {
		// subprice = prix de base
		$qte = $p_data['order_detail']['product_quantity'];
		$total_ttc = $p_data['order_detail']['total_price_tax_incl'];

		// Test si le montant presta est ok
		$tva_tx = round($p_data['order_detail']['tax_rate'], 1);
		$tva_tx = static::_pd_map_tva_taux($p_data);
		$tva_coeff = 1+($tva_tx/100);
		$total_ht = $p_data['order_detail']['total_price_tax_excl'];
		$price = $p_data['order_detail']['unit_price_tax_excl'];
		$total_ht_calc = round($qte*$price, 2);
		$total_ttc_calc = round($qte*$price*$tva_coeff, 2);
		
		var_dump($total_ht, $total_ht_calc);
		var_dump($total_ttc, $total_ttc_calc);
		var_dump($total_ttc != $total_ttc_calc || $total_ht != $total_ht_calc);
		if (false && ($total_ttc != $total_ttc_calc || $total_ht != $total_ht_calc)) {
			// Recalcul coeff TVA
			//$tva_tx = static::_pd_map_tva_taux($p_data);
			$tva_coeff = round($total_ttc/$p_data['order_detail']['total_price_tax_excl'], 3);
			$tva_tx = 100*($tva_coeff-1);
			// Recalcul Prix unitaire HT
			$total_ht = round($total_ttc/$tva_coeff, 5); // Prix HT TOTAL censé
			$price = round(($total_ttc/$qte)/$tva_coeff, 5); //$p_data['order_detail']['unit_price_tax_excl']
			$total_ht = round($price*$qte, 2);
		}

		// Réduction en valeur
		if (!empty($p_data['order_detail']['reduction_amount_tax_excl']) && $p_data['order_detail']['reduction_amount_tax_excl']!=0) {
			$remise = $p_data['order_detail']['reduction_amount_tax_excl'];
			$subprice = $price+$p_data['order_detail']['reduction_amount_tax_excl'];
			$remise_percent = $subprice != 0 ?round(100*(1-$price/$subprice), 2) :0;
			die('niet');
		}
		// Réduction en pourcentage
		elseif (!empty($p_data['order_detail']['reduction_percent']) && $p_data['order_detail']['reduction_percent']!=0) {
			$remise_percent = $p_data['order_detail']['reduction_percent'];
			$subprice = ($p_data['order_detail']['reduction_percent']==100 ?$p_data['order_detail']['product_price'] :$price/(1-$p_data['order_detail']['reduction_percent']/100));
			$remise = $subprice-$price;
		}
		else {
			$remise_percent = 0;
			$remise = 0;
			$subprice = $price;
		}
		
		$d_data_map = [
			'commandedet' => [
				'qty' => $qte,
				'remise_percent' => $remise_percent,
				'remise' => $remise,
				'price' => $price, //$p_data['order_detail']['unit_price_tax_excl']
				'subprice' => $subprice,
				'tva_tx' => $tva_tx,
				'total_ht' => $total_ht,
				'total_tva' => ($total_ttc-$total_ht),
				'total_ttc' => $total_ttc,
				'multicurrency_subprice' => $subprice,
				'multicurrency_total_ht' => $total_ht,
				'multicurrency_total_tva' => ($total_ttc-$total_ht),
				'multicurrency_total_ttc' => $total_ttc,
				'buy_price_ht' => $p_data['order_detail']['original_wholesale_price'], // Sinon purchase_supplier_price, mais pas pertinent
			],
		];

		if (ECOTAX && $p_data['order_detail']['ecotax']) {
			// Recalcul à partir du TTC
			$ecotax_tva_tx = 20;
			$ecotax_tva_coeff = 1 + ($ecotax_tva_tx/100);
			$ecotax_price = $p_data['order_detail']['ecotax'];
			$ecotax_price_ttc = round($ecotax_price*$ecotax_tva_coeff, 2);
			$ecotax_total_ttc = round($qte*$ecotax_price_ttc, 2);
			$ecotax_total_ht = round($qte*$ecotax_price, 2);
			$ecotax_total_tva = $ecotax_total_ttc-$ecotax_total_ht;

			$d_data_map['commandedet_extrafields']['ecotaxdeee'] = $ecotax_price;

			$d_data_map['commandedet']['price'] -= $ecotax_price;
			$d_data_map['commandedet']['subprice'] -= $ecotax_price;
			$d_data_map['commandedet']['total_ht'] -= $ecotax_total_ht;
			$d_data_map['commandedet']['total_tva'] -= $ecotax_total_tva;
			$d_data_map['commandedet']['total_ttc'] -= $ecotax_total_ttc;

			$d_data_map['commandedet']['multicurrency_subprice'] -= $ecotax_price;
			$d_data_map['commandedet']['multicurrency_total_ht'] -= $ecotax_total_ht;
			$d_data_map['commandedet']['multicurrency_total_tva'] -= $ecotax_total_tva;
			$d_data_map['commandedet']['multicurrency_total_ttc'] -= $ecotax_total_ttc;
		}
	}
	// Remise
	elseif ($o['p_tref']=='order_cart_rule') {
		$row = $p_data['order_cart_rule'];

		$tva = ($row['value']-$row['value_tax_excl']);

		// On a pas le taux
		// Normalement 3 chiffres suffisent dans la pratique
		// Coeff à 1 si pas valeur nulle (@todo supprimer la ligne dans ce cas)
		$tva_coeff = $row['value_tax_excl']>0 ?round($row['value']/$row['value_tax_excl'], 3) :1;
		$tva_coeff_2 = $row['value_tax_excl']>0 ?round($row['value']/$row['value_tax_excl'], 2) :1;
		// Si bug d'arrondi sur du 20% (transport), ce qui est fréquent avec Presta, on impose une TVA à 20%.
		if ($tva_coeff_2==1.2)
			$tva_coeff=1.2;
		// Taux à un chiffre après la virgule
		$tva_tx = round(100*($tva_coeff-1), 1);

		$d_data_map = [
			'commandedet' => [
				//'rowid' => NULL,
				'qty' => -1,
				'remise_percent' => 0,
				'remise' => 0,
				'price' => $row['value_tax_excl'],
				'subprice' => $row['value_tax_excl'],
				'tva_tx' => $tva_tx,
				'total_ht' => -$row['value_tax_excl'],
				'total_tva' => -$tva,
				'total_ttc' => -$row['value'],
				'multicurrency_subprice' => $row['value_tax_excl'],
				'multicurrency_total_ht' => -$row['value_tax_excl'],
				'multicurrency_total_tva' => -($row['value']-$row['value_tax_excl']),
				'multicurrency_total_ttc' => -$row['value'],
				'buy_price_ht' => 0,
			],
		];
	}

	return $d_data_map;
}

public function map_create_pack(&$o, &$row)
{
	if ($row['id_product_attribute'])
		$fk_product = static::_pd_map_fk('product', 'product_attribute', $row['id_product_attribute']);
	else
		$fk_product = static::_pd_map_fk('product', 'product', $row['id_product']);

	$d_data_map = [
		'commandedet' => [
			//'rowid' => NULL,
			'fk_commande' => static::_pd_map_fk('order', 'orders', $row['id_order']),
			'fk_parent_line' => NULL,
			'fk_product' => $fk_product,
			'label' => $row['product_name'],
			'description' => $row['product_description'],
			'vat_src_code' => '',
			'tva_tx' => 0, // @todo
			'localtax1_tx' => 0,
			'localtax1_type' => 0,
			'localtax2_tx' => 0,
			'localtax2_type' => 0,
			'qty' => $row['qte'],
			'remise_percent' => 0,
			'remise' => 0,
			'fk_remise_except' => NULL,
			'price' => 0,
			'subprice' => 0,
			'total_ht' => 0,
			'total_tva' => 0,
			'total_localtax1' => 0,
			'total_localtax2' => 0,
			'total_ttc' => 0,
			'product_type' => 0,
			'date_start' => NULL,
			'date_end' => NULL,
			'info_bits' => 0,
			'buy_price_ht' => 0,
			'fk_product_fournisseur_price' => NULL, // @todo
			'special_code' => 0,
			'rang' => 0,
			'fk_unit' => NULL,
			'import_key' => NULL,
			'fk_commandefourndet' => NULL,
			'fk_multicurrency' => NULL,
			'multicurrency_code' => 'EUR',
			'multicurrency_subprice' => 0,
			'multicurrency_total_ht' => 0,
			'multicurrency_total_tva' => 0,
			'multicurrency_total_ttc' => 0,
			'ref_ext' => NULL,
		],
		'commandedet_extrafields' => [
			//'fk_object' => '',
			'tms' => static::$datetime,
			'fk_parent_pack' => $o['d_oid'],
		],
	];

	return $d_data_map;
}

public function pd_map_create(&$o, &$p_data)
{
	$fk_order = static::_pd_map_fk_order($p_data);

	if (isset($p_data['order_detail'])) {
		$fk_product = static::_pd_map_fk_product($p_data);
		// product_type : product/service
		if ($fk_product) {
			$sql = 'SELECT fk_product_type FROM '.DB_D_PREFIX.'product WHERE rowid='.$fk_product;
			$q = DB::d_select($sql);
			if ($q->num_rows)
				list($product_type) = $q->fetch_row();
			else
				$product_type = 0;
		}
		else
			$product_type = 0;

		$d_data_map = [
			'commandedet' => [
				//'rowid' => NULL,
				'fk_commande' => $fk_order,
				'fk_parent_line' => NULL,
				'fk_product' => $fk_product,
				'label' => $p_data['order_detail']['product_name'],
				'description' => '',
				'vat_src_code' => '',
				'tva_tx' => static::_pd_map_tva_taux($p_data),
				'localtax1_tx' => 0,
				'localtax1_type' => 0,
				'localtax2_tx' => 0,
				'localtax2_type' => 0,
				'qty' => $p_data['order_detail']['product_quantity'],
				'remise_percent' => $p_data['order_detail']['reduction_percent'],
				'remise' => $p_data['order_detail']['reduction_amount'],
				'fk_remise_except' => NULL,
				'price' => $p_data['order_detail']['product_price'],
				'subprice' => $p_data['order_detail']['original_product_price'],
				'total_ht' => $p_data['order_detail']['total_price_tax_excl'],
				'total_tva' => ($p_data['order_detail']['total_price_tax_incl']-$p_data['order_detail']['total_price_tax_excl']),
				'total_localtax1' => 0,
				'total_localtax2' => 0,
				'total_ttc' => $p_data['order_detail']['total_price_tax_incl'],
				'product_type' => $product_type,
				'date_start' => NULL,
				'date_end' => NULL,
				'info_bits' => 0,
				'buy_price_ht' => $p_data['order_detail']['original_wholesale_price'],
				'fk_product_fournisseur_price' => NULL, // @todo
				'special_code' => 0,
				'rang' => 0,
				'fk_unit' => NULL,
				'import_key' => NULL,
				'fk_commandefourndet' => NULL,
				'fk_multicurrency' => NULL,
				'multicurrency_code' => 'EUR',
				'multicurrency_subprice' => $p_data['order_detail']['original_product_price'],
				'multicurrency_total_ht' => $p_data['order_detail']['total_price_tax_excl'],
				'multicurrency_total_tva' => ($p_data['order_detail']['total_price_tax_incl']-$p_data['order_detail']['total_price_tax_excl']),
				'multicurrency_total_ttc' => $p_data['order_detail']['total_price_tax_incl'],
				'ref_ext' => NULL,
			],
			'commandedet_extrafields' => [
				'tms' => static::$datetime,
			],
		];
	}
	elseif (isset($p_data['order_cart_rule'])) {
		$row = $p_data['order_cart_rule'];

		$tva = ($row['value']-$row['value_tax_excl']);
		$tva_tx = round(100*$tva/$row['value_tax_excl'], 1);

		$d_data_map = [
			'commandedet' => [
				//'rowid' => NULL,
				'fk_commande' => $fk_order,
				'fk_parent_line' => NULL,
				'fk_product' => static::D_K_DISCOUNT_PRODUCT,
				'label' => static::D_DISCOUNT_PRODUCT_NAME,
				'description' => $row['name'],
				'vat_src_code' => '',
				'tva_tx' => $tva_tx, // @todo
				'localtax1_tx' => 0,
				'localtax1_type' => 0,
				'localtax2_tx' => 0,
				'localtax2_type' => 0,
				'qty' => -1,
				'remise_percent' => 0,
				'remise' => 0,
				'fk_remise_except' => NULL,
				'price' => $row['value_tax_excl'],
				'subprice' => $row['value_tax_excl'],
				'total_ht' => -$row['value_tax_excl'],
				'total_tva' => -$tva,
				'total_localtax1' => 0,
				'total_localtax2' => 0,
				'total_ttc' => -$row['value'],
				'product_type' => 1,
				'date_start' => NULL,
				'date_end' => NULL,
				'info_bits' => 0,
				'buy_price_ht' => 0,
				'fk_product_fournisseur_price' => NULL, // @todo
				'special_code' => 0,
				'rang' => 0,
				'fk_unit' => NULL,
				'import_key' => NULL,
				'fk_commandefourndet' => NULL,
				'fk_multicurrency' => NULL,
				'multicurrency_code' => 'EUR',
				'multicurrency_subprice' => $row['value_tax_excl'],
				'multicurrency_total_ht' => -$row['value_tax_excl'],
				'multicurrency_total_tva' => -$tva,
				'multicurrency_total_ttc' => -$row['value'],
				'ref_ext' => NULL,
			],
			'commandedet_extrafields' => [
				'tms' => static::$datetime,
			],
		];
	}	
	return $d_data_map;
}

// -----------

// Field MAPPING

public static function _pd_map_tva_taux(&$orig_data, &$dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['order_detail']['id_tax_rules_group']) {
		case 1:
			return 20;
		case 2:
			return 10;
		case 3:
			return 5.5;
		case 4:
			return 2.1;
		case 5:
			return 0;
	}
}

public static function _pd_map_fk_product(&$orig_data, &$dest_tree=[])
{
	// Product type
	if ($orig_data['order_detail']['product_attribute_id'])
		return static::_pd_map_fk('product', 'product_attribute', $orig_data['order_detail']['product_attribute_id']);
	else
		return static::_pd_map_fk('product', 'product', $orig_data['order_detail']['product_id']);
}
public static function _pd_map_fk_product2($id_product, $id_product_attribute=0)
{
	// Product type
	if ($id_product_attribute)
		return static::_pd_map_fk('product', 'product_attribute', $id_product_attribute);
	else
		return static::_pd_map_fk('product', 'product', $id_product);
}

public static function _pd_map_fk_order(&$orig_data, &$dest_tree=[])
{
	if (isset($orig_data['order_detail']))
		return static::_pd_map_fk('order', 'orders', $orig_data['order_detail']['id_order']);
	elseif ($orig_data['order_cart_rule'])
		return static::_pd_map_fk('order', 'orders', $orig_data['order_cart_rule']['id_order']);
}

}

sync_order_detail_pd::__init();
