<?php

// Payment

class sync_payment extends sync
{

const MODEL_NAME = 'payment';
const MODEL_ID = 19;
const MAP_ID = 13;

const P_TABLE_MAIN = 'order_payment';
const P_TABLE_MAIN_ID = 'id_order_payment';

const D_TABLE_MAIN = 'paiement';
const D_TABLE_MAIN_REF = 'ref';
const D_REF_CODE = 'PAY';
const D_REF_LENGTH = 6;
const D_REF_DATE = true;
protected static $nb;

public static function __init()
{
	parent::__init();

	static::_paiement_load();
}

public function d_data($otype, $oid)
{
	$data = [];

	// paiement
	$data['paiement'] = DB::d_get_row('paiement', ['rowid'=>$oid]);
	if (empty($data['paiement']))
		return;
	$data['paiement_extrafields'] = DB::d_get_row('paiement_extrafields', ['fk_object'=>$oid]);
	
	// objets liés/payés
	$data['paiement_object'] = DB::d_get_rows('paiement_object', ['fk_paiement'=>$oid]);
	
	// Reçu de paiement etransactions cb
	if (D_PAYMENT_ETRANSACTIONS) {
		$data['mbi_etransactions_return'] = DB::d_get_row('mbi_etransactions_return', ['fk_paiement'=>$oid]);
		if (!empty($data['mbi_etransactions_return']))
			$data['mbi_etransactions_hash'] = DB::d_get_row('mbi_etransactions_hash', ['rowid'=>$data['mbi_etransactions_return']['fk_mbi_etransactions']]);
	}

	return $data;
}

public function p_data($otype, $oid)
{
	$data = [];

	// order_payment
	$data['order_payment'] = DB::p_get_row('order_payment', ['id_order_payment'=>$oid]);
	if (empty($data['order_payment']))
		return;
	
	$o_ref = $data['order_payment']['order_reference'];
	var_dump($o_ref);

	// orders
	$data['orders'] = DB::p_get_row('orders', ['reference'=>$o_ref]);
	$o_id = $data['orders']['id_order'];
	$c_id = $data['orders']['id_customer'];

	if (P_PAYMENT_ETRANSACTIONS) {
		// Module E-Transactions
		$data['etransactions_order'] = DB::p_get_row('etransactions_order', ['id_order'=>$o_id]);
		// Module E-Transactions nouveau module Up2Pay
		$data['up2pay_transaction'] = DB::p_get_row('up2pay_transaction', ['id_order'=>$o_id]);
		$data['up2pay_deadlines'] = DB::p_get_rows('up2pay_deadlines', ['id_order'=>$o_id]);
	}

	if (P_PAYMENT_CHECKOUT) {
		// Module Prestashop checkout
		$data['pscheckout_order_matrice'] = DB::p_get_row('pscheckout_order_matrice', ['id_order_prestashop'=>$o_id]);
	}

	if (P_PAYMENT_PAYPAL) {
		// Module Paypal Officiel
		$data['paypal_order'] = DB::p_get_row('paypal_order', ['id_order'=>$o_id]);
	}

	// customer
	$data['customer'] = DB::p_get_row('customer', ['id_customer'=>$c_id]);

	return $data;
}

}
