<?php

// Product

class sync_product extends sync
{

const MODEL_NAME='product';
const MODEL_ID = 1;
const MAP_ID = 1; // default
const MAP_SIMPLE_ID = 1;
const MAP_COMBI_ID = 2;

const D_TABLE_MAIN = 'product';
const D_TABLE_MAIN_REF = 'ref';
const D_REF_CODE = 'PI';
const D_REF_LENGTH = 5;
const D_REF_DATE = false;
protected static $nb;

const P_TABLE_MAIN = 'product';
const P_SIMPLE_TABLE_MAIN = 'product';
const P_SIMPLE_TABLE_MAIN_ID = 'id_product';
const P_COMBI_TABLE_MAIN = 'product_attribute';
const P_COMBI_TABLE_MAIN_ID = 'id_product_attribute';

const P_TABLE_MAIN_REF = 'reference';

function d_data($otype, $oid)
{
	$data = [];

	$data['product'] = DB::d_get_row('product', ['rowid'=>$oid]);
	$data['product_extrafields'] = DB::d_get_row('product_extrafields', ['fk_object'=>$oid]);

	// Pack/Kit
	$data['product_association'] = DB::d_get_rows('product_association', ['fk_product_pere'=>$oid]);

	if (STOCK_SYNC)
		$this->d_data_stock($otype, $oid, $data);
	// stock entrepots

	// lots
	if (PRODUCT_LOT) {
		$data['product_lot'] = DB::d_get_rows('product_lot', ['fk_product'=>$oid]);
	}
	
	return $data;
}

function d_data_stock($otype, $oid, &$data)
{
	// D_WAREHOUSE_SYNC_MODE : ALL
	if (!empty('D_WAREHOUSE_SYNC_MODE') || D_WAREHOUSE_SYNC_MODE=='ALL') {
		$data['product_stock'] = DB::d_get_rows('product_stock', ['fk_product'=>$oid]);
	}
	// D_WAREHOUSE_SYNC_MODE : LIST
	elseif (D_WAREHOUSE_SYNC_MODE=='LIST') {
		$data['product_stock'] = DB::d_get_rows('product_stock', ['fk_product'=>$oid, 'fk_entrepot'=>explode(',', D_WAREHOUSE_SYNC_IDS)]);
	}
	// D_WAREHOUSE_SYNC_MODE : ONE
	else {
		$data['product_stock'] = DB::d_get_row('product_stock', ['fk_product'=>$oid, 'fk_entrepot'=>D_WAREHOUSE_SYNC_IDS]);
	}
	
	if(PRODUCT_LOT) {
		$fk_product_stock = [];
		if (in_array(D_WAREHOUSE_SYNC_MODE, ['ALL', 'LIST']))
			foreach($data['product_stock'] as $row)
				$fk_product_stock[] = $row['rowid'];
		elseif(!empty($data['product_stock']))
			$fk_product_stock[] = $data['product_stock']['rowid'];
		if (!empty($fk_product_stock))
			$data['product_batch'] = DB::d_get_rows('product_batch', ['fk_product_stock'=>$fk_product_stock]);
	}
}

function p_data($otype, $oid)
{
	$data = [];

	if ($otype=='product_attribute') {
		$pa_id = $oid;
		if (empty($data['product_attribute'] = DB::p_get_row('product_attribute', ['id_product_attribute'=>$pa_id])))
			return;
		$p_id = $data['product_attribute']['id_product'];
		$data['product_attribute_shop'] = DB::p_get_row('product_attribute_shop', ['id_product'=>$p_id, 'id_product_attribute'=>$pa_id, 'id_shop'=>P_SHOP_ID]);
		$data['product_attribute_combination'] = DB::p_get_rows('product_attribute_combination', ['id_product_attribute'=>$pa_id]);
		if (PRODUCT_FIELD_DECLI_DISABLED)
			$data['tot_switch_attribute_disabled'] = DB::p_get_row('tot_switch_attribute_disabled', ['id_product_attribute'=>$pa_id, 'id_shop'=>P_SHOP_ID]);
	}
	elseif ($otype=='product') {
		$pa_id = 0;
		$p_id = $oid;
	}
	else {
		return;
	}
	
	if (empty($data['product'] = DB::p_get_row('product', ['id_product'=>$p_id])))
		return;

	if (P_URL_PREFIX_CAT) {
		$data['category_lang'] = DB::p_get_row('category_lang', ['id_category'=>$data['product']['id_category_default'], 'id_lang'=>P_LANG_ID]);
	}
	
	// Image
	if ($otype=='product_attribute') {
		$sql = 'SELECT i.*, il.*
			FROM '.DB_P_PREFIX.'product_attribute_image pai
			INNER JOIN '.DB_P_PREFIX.'image i ON i.id_image=pai.id_image
			LEFT JOIN '.DB_P_PREFIX.'image_lang il ON il.id_image=i.id_image AND il.id_lang='.P_LANG_ID.'
			WHERE pai.id_product_attribute='.$pa_id.'
			ORDER BY IF(i.cover=1, 0, 1), i.position
			LIMIT 1';
		$q = DB::p_select($sql);
		if($row=$q->fetch_assoc()) {
			$data['image'] = $row;
		}
	}
	if (empty($data['image'])) {
		$sql = 'SELECT i.*, il.*
			FROM '.DB_P_PREFIX.'image i
			LEFT JOIN '.DB_P_PREFIX.'image_lang il ON il.id_image=i.id_image AND il.id_lang='.P_LANG_ID.'
			WHERE i.id_product='.$p_id.'
			ORDER BY IF(i.cover=1, 0, 1), i.position
			LIMIT 1';
		$q = DB::p_select($sql);
		if($row=$q->fetch_assoc()) {
			$data['image'] = $row;
		}
	}

	$data['product_lang'] = DB::p_get_row('product_lang', ['id_product'=>$p_id, 'id_shop'=>P_SHOP_ID, 'id_lang'=>P_LANG_ID]);
	$data['product_shop'] = DB::p_get_row('product_shop', ['id_product'=>$p_id, 'id_shop'=>P_SHOP_ID]);

	// Pack/Kit
	$data['pack'] = DB::p_get_rows('pack', ['id_product_pack'=>$p_id]);

	// @todo mapping !

	// Stock
	$data['stock_available'] = DB::p_get_row('stock_available', ['id_product'=>$p_id, 'id_product_attribute'=>$pa_id, 'id_shop'=>P_SHOP_ID]);

	// Lot
	if (PRODUCT_LOT)
		$data['products_dlc_dluo'] = DB::p_get_rows('products_dlc_dluo', ['id_product'=>$p_id, 'id_combinaison'=>$pa_id]);

	// Supplier
	$data['product_supplier'] = DB::p_get_rows('product_supplier', ['id_product'=>$p_id, 'id_product_attribute'=>$pa_id]);

	// Categories
	//$data['category_product'] = DB::p_get_rows('category_product', ['id_product'=>$p_id]);

	// Garantie
	if (PRODUCT_FIELD_GARANTIE) {
		$sql = 'SELECT t.id_product_tab, tl.content
			FROM '.DB_P_PREFIX.'product_tab_lang tl
			INNER JOIN '.DB_P_PREFIX.'product_tab t ON t.id_product_tab=tl.id_product_tab
			WHERE t.product_id='.$p_id.' AND tl.title="GARANTIE" AND tl.id_lang='.P_LANG_ID;
		$q = DB::p_select($sql);
		if ($row=$q->fetch_assoc())
			$data['garantie'] = $row;
	}

	// Dimensions sur déclinaisons
	if (P_PRODUCT_CDC_DIMENSIONS && $pa_id) {
		$data['cdcd_product_combination_dimensions'] = DB::p_get_row('cdcd_product_combination_dimensions', ['id_product'=>$p_id, 'id_product_attribute'=>$pa_id]);
	}

	return $data;
}

public static function p_product_check_combi($oid)
{
	// Check simple ou combi
	$sql = 'SELECT id_product_attribute
		FROM '.DB_P_PREFIX.'product_attribute
		WHERE id_product='.$oid.'
		LIMIT 1';
	$q = DB::p_select($sql);

	if ($q->num_rows) {
		if (DEBUG_AFF)
			var_dump('COMBI ! ACHTUNG !');
		return true;
	}
	
	return false;
}

public static function d_reserved_qty($fk_product)
{
	$qty = 0;

	// Commandes brouilons et validées
	// c.fk_statut IN (0, 1, 2) => brouillons, validés, envoi en cours (brouillons aussi afin  !)
	$sql = 'SELECT COUNT(DISTINCT c.fk_soc) as nb_customers, COUNT(DISTINCT c.rowid) as nb, COUNT(cd.rowid) as nb_rows, SUM(cd.qty) as qty
		FROM '.DB_D_PREFIX.'commandedet as cd
		INNER JOIN '.DB_D_PREFIX.'commande as c ON c.rowid = cd.fk_commande
		WHERE cd.fk_product = '.$fk_product.'
			AND c.fk_statut IN (1, 2)';
	$q = DB::d_select($sql);
	if (!empty($cmd_row = $q->fetch_assoc()))
		$qty += $cmd_row['qty'] ?: 0;
	if (DEBUG_AFF)
		var_dump($cmd_row);

	// Expéditions effectuées sur les commandes en cours
	// e.fk_statut IN (1, 2) => validated et closed
	$sql = 'SELECT COUNT(DISTINCT e.fk_soc) as nb_customers, COUNT(DISTINCT e.rowid) as nb, COUNT(ed.rowid) as nb_rows, SUM(ed.qty) as qty
		FROM '.DB_D_PREFIX.'expeditiondet as ed
		INNER JOIN '.DB_D_PREFIX.'commandedet as cd ON cd.rowid=ed.fk_origin_line
		INNER JOIN '.DB_D_PREFIX.'commande as c ON c.rowid = cd.fk_commande
		INNER JOIN '.DB_D_PREFIX.'expedition as e ON e.rowid = ed.fk_expedition
		WHERE cd.fk_product = '.$fk_product.'
			AND c.fk_statut IN (1, 2)
			AND e.fk_statut IN (1, 2)';
	$q = DB::d_select($sql);
	if (!empty($exp_row = $q->fetch_assoc()))
		$qty -= $exp_row['qty'] ?: 0;
	if (DEBUG_AFF)
		var_dump($exp_row);

	//var_dump($row);

	return $qty;
}

}
