<?php

class sync_product_dp extends sync_product
{

public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
	// Produit simple
	if ($o['p_tref']=='product')
		return $this->dp_insert_simple_more($o, $p_data_map, $d_data);
	// Produit décliné
	elseif ($o['p_tref']=='product_attribute')
		return $this->dp_insert_combi_more($o, $p_data_map, $d_data);
	// @see update
}
public function dp_insert_simple_more(&$o, &$p_data_map, &$d_data)
{
	// @see update
}
public function dp_insert_combi_more(&$o, &$p_data_map, &$d_data)
{
	// @see update
}

public static function dp_check_sync(&$o, &$d_data)
{
	// @todo modifier avec P >= 1.7.8
	// Si produit maître avec déclinaisons, on stoppe la synchro pour pas foutre le border
	if (isset($o['p_tref']) && $o['p_tref']=='product' && static::p_product_check_combi($o['p_oid']))
		return false;
	
	if (empty($d_data['product_extrafields']) || empty($d_data['product_extrafields']['sync']))
		return false;
	
	return true;
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	if (DEBUG_AFF)
		var_dump('dp_update_more()');
	if (DEBUG_AFF)
		var_dump($o);
	// Produit simple
	if ($o['p_tref']=='product')
		return $this->dp_update_simple_more($o, $p_data_map, $p_data_map_create, $p_data, $d_data);
	// Produit décliné
	elseif ($o['p_tref']=='product_attribute')
		return $this->dp_update_combi_more($o, $p_data_map, $p_data_map_create, $p_data, $d_data);
}

public function dp_update_common_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	if ($o['p_tref']=='product')
		$id = $o['p_oid'];
	// Forcément créé depuis Presta et donc déjà sync dans ce cas
	elseif ($o['p_tref']=='product_attribute')
		$id = $p_data['product']['id_product'];
	
	// category_product (par defaut)
	if (empty($p_data['category_product']) && isset($p_data_map_create['category_product'])) {
		static::p_insert_row('category_product', ['id_product'=>$id, 'id_category'=>P_CATEGORY_DEFAULT_ID], $p_data_map, $p_data_map_create, $p_data);
	}

	// product_lang
	static::p_update_row('product_lang', ['id_product'=>$id, 'id_lang'=>P_LANG_ID, 'id_shop'=>P_SHOP_ID], $p_data_map, $p_data_map_create, $p_data);

	// product_shop
	static::p_update_row('product_shop', ['id_product'=>$id, 'id_shop'=>P_SHOP_ID], $p_data_map, $p_data_map_create, $p_data);

	// Objets liés

	// stock
	// @todo better should use Config Const MANAGE_STOCK true/false
	if (!empty($d_data['product_stock'])) {
		return $this->dp_update_stock($o, $d_data, $p_data);
	}
}

public function dp_update_stock(&$o, &$d_data, &$p_data)
{
	//var_dump($d_data); die();
	if ($o['p_tref']=='product') {
		$id_product = $o['p_oid'];
		$id_product_attribute = 0;
	}
	// Forcément créé depuis Presta et donc déjà sync dans ce cas
	elseif ($o['p_tref']=='product_attribute') {
		$id_product = $p_data['product']['id_product'];
		$id_product_attribute = $o['p_oid'];
	}
	else {
		return;
	}
	
	$reserved_qty = sync_product::d_reserved_qty($o['d_oid']);
	//var_dump($reserved_qty); die();

	$normal = true;

	// Si on ne synchronise que le stock des lots périmés s'il y en a pour pas tout mélanger
	if (PRODUCT_LOT && PRODUCT_LOT_STOCK_PERIME && !empty($d_data['product_batch'])) {
		$reel = 0;
		$fk_product_stocks = [];
		if (D_WAREHOUSE_SYNC_MODE == 'LIST') {
			$fk_entrepots = explode(',', D_WAREHOUSE_SYNC_IDS);
		}
		elseif (D_WAREHOUSE_SYNC_MODE == 'ONE') {
			$fk_entrepots = [D_WAREHOUSE_SYNC_IDS];
		}
		foreach($d_data['product_stock'] as $stock) {
			// Tous les stocks
			if (empty(D_WAREHOUSE_SYNC_MODE) || D_WAREHOUSE_SYNC_MODE == 'ALL') {
				$fk_product_stocks[] = $stock['rowid'];
			}
			// Uniquement stocks dépôts choisis
			else {
				if (in_array($stock['fk_entrepot'], $fk_entrepots))
					$fk_product_stocks[] = $stock['rowid'];
			}
		}
		//foreach()
		// J+2
		$date = date('Y-m-d', time()+86400*2);
		foreach($d_data['product_batch'] as $row) {
			var_dump($row);
			//$eatby = '';
			$sellby = '';
			// Récupération eatby
			foreach($d_data['product_lot'] as $row2) {
				if ($row2['batch']==$row['batch']) {
					//$eatby = $row2['eatby'];
					$sellby = $row2['sellby'];
					break;
				}
			}
			if (in_array($row['fk_product_stock'], $fk_product_stocks) && substr($sellby, 0, 10) <= $date) {
				$reel += $row['qty'];
			}
			if ($reel>0)
				$normal = false;
		}
	}
	// Sinon, cas normal
	if ($normal) {
		// ALL
		if (empty(D_WAREHOUSE_SYNC_MODE) || D_WAREHOUSE_SYNC_MODE == 'ALL') {
			$reel = $d_data['product']['stock'];
		}
		// FROM LIST || ONE
		else {//if (in_array(D_WAREHOUSE_SYNC_MODE, ['LIST', 'ONE']) {
			$reel = 0;
			$fk_entrepots = explode(',', D_WAREHOUSE_SYNC_IDS);
			//var_dump($d_data['product_stock']);
			if (!empty($d_data['product_stock'])) foreach($d_data['product_stock'] as $stock) if (in_array($stock['fk_entrepot'], $fk_entrepots))  {
				$reel += $stock['reel'];
			}
		}
	}

	// Pour éviter les anomalies
	if ($reserved_qty>$reel)
		$reel = $reserved_qty;
	if ($reel < 0) {
		$reserved_qty -= $reel;
		$reel = 0;
	}
	
	$p_data_map = [
		'stock_available' => [
			'quantity' => ($reel - $reserved_qty), // @todo
			'physical_quantity' => $reel,
			'reserved_quantity' => $reserved_qty,
		],
	];
	$p_data_create = [
		'stock_available' => [
			'id_shop' => P_SHOP_ID,
			'id_shop_group' => P_SHOP_GROUP_ID,
			'depends_on_stock' => 0,
			'out_of_stock' => 2, // @todo kézako
			'location' => '',
		],
	];
	//var_dump($p_data_map, $p_data_create); //die();
	//trigger_error(json_encode([$p_data_map, $p_data_create]));

	$ret = static::p_update_row('stock_available', ['id_product'=>$id_product, 'id_product_attribute'=>$id_product_attribute], $p_data_map, $p_data_create, $p_data);
	$this->p_promo_update($o);

	return true;
}

public function dp_update_simple_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	$ret = $this->dp_update_common_more($o, $p_data_map, $p_data_map_create, $p_data, $d_data);
	
	$id = $o['p_oid'];
	
	// pack
	if (isset($p_data_map['pack'])) {
		// analyse old assoc
		$p_assoc_old = [];
		if (isset($p_data['pack'])) {
			foreach($p_data['pack'] as &$row)
				$p_assoc_old[$row['id_product_item'].'-'.$row['id_product_attribute_item']] = $row;
		}
		$p_assoc_update = [];
		$p_assoc_insert = [];
		$p_assoc_delete = [];
		// analyse new assoc => look into new and updated
		foreach($p_data_map['pack'] as $row) {
			// ajout id père
			$row['id_product_pack'] = $id;
			if (empty($p_assoc_old[$row['id_product_item'].'-'.$row['id_product_attribute_item']]))
				$p_assoc_insert[] = $row;
			else
				$p_assoc_update[$row['id_product_item'].'-'.$row['id_product_attribute_item']] = $row;
		}
		// Remove deleted
		foreach($p_assoc_old as $k=>$row) {
			if (!isset($p_assoc_update[$k]))
				$p_assoc_delete[] = [$row['id_product_item'], $row['id_product_attribute_item']];
		}

		if (DEBUG_AFF)
			var_dump($p_assoc_insert);
		if (DEBUG_AFF)
			var_dump($p_assoc_update);
		if (DEBUG_AFF)
			var_dump($p_assoc_delete);
		//die();

		// DB actions
		foreach($p_assoc_insert as $row)
			DB::p_insert_row('pack', $row);
		foreach($p_assoc_update as $k=>$row)
			DB::p_update_row('pack', $row, ['id_product_pack'=>$p_assoc_old[$k]['id_product_pack'], 'id_product_item'=>$p_assoc_old[$k]['id_product_item'], 'id_product_attribute_item'=>$p_assoc_old[$k]['id_product_attribute_item']], $p_assoc_old[$k]);
		foreach($p_assoc_delete as $k)
			DB::p_delete('DELETE FROM `'.DB_P_PREFIX.'pack` WHERE id_product_pack='.$id.' AND id_product_item='.$k[0].' AND id_product_attribute_item='.$k[1]);
	}	
	elseif(!empty($p_data['pack'])) {
		// Suppression de tout, puisque on a rien en entrée
		DB::p_delete('DELETE FROM `'.DB_P_PREFIX.'pack` WHERE `id_product_pack`='.$id);
	}

	return $ret;
}

public function dp_update_combi_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	$ret = $this->dp_update_common_more($o, $p_data_map, $p_data_map_create, $p_data, $d_data);

	// product
	DB::p_update_row('product', $p_data_map['product'], ['id_product'=>$p_data['product']['id_product']], $p_data['product']);
	// product_attribute_shop
	DB::p_update_row('product_attribute_shop', $p_data_map['product_attribute_shop'], ['id_product_attribute'=>$p_data['product_attribute_shop']['id_product_attribute']], $p_data['product_attribute_shop']);
	if (P_PRODUCT_CDC_DIMENSIONS) {
		//var_dump($p_data_map['cdcd_product_combination_dimensions']); die();
		// cdcd_product_combination_dimensions
		static::p_update_row('cdcd_product_combination_dimensions', ['id_product'=>$p_data['product']['id_product'], 'id_product_attribute'=>$p_data['product_attribute_shop']['id_product_attribute']], $p_data_map, ['cdcd_product_combination_dimensions'=>['id_product'=>$p_data['product']['id_product'], 'id_product_attribute'=>$p_data['product_attribute_shop']['id_product_attribute']]], $p_data);
	}

	return $ret;
}

// -- MAPPING --


public function dp_map_create(&$o, &$d_data)
{
	if (empty($o['p_tref']))
		$o['p_tref'] = static::P_TABLE_MAIN;
	
	if ($o['p_tref']=='product')
		return $this->map_create_simple($o, $d_data);
	elseif ($o['p_tref']=='product_attribute')
		return []; //$this->map_create_combi($o, $d_data);
}
public function map_create_simple(&$o, &$d_data)
{
	$o['p_tref'] = 'product';
	
	$p_data_map = [
		'product' => [
			//'id_product' => NULL,
			//'id_supplier' => '',
			//'id_manufacturer' => '',
			'id_category_default' => P_CATEGORY_DEFAULT_ID,
			'id_shop_default' => P_SHOP_ID,
			'id_tax_rules_group' => static::P_ID_TAX_RULES_GROUP,
			'on_sale' => '0',
			//'online_only' => '0',
			//'ean13' => NULL,
			//'isbn' => null
			//'upc' => null
			'ecotax' => '0',
			'quantity' => '0',
			'minimal_quantity' => '1',
			'low_stock_threshold' => '0',
			'low_stock_alert' => '1',
			//'price' => '0',
			//'wholesale_price' => '0',
			'unity' => '',
			'unit_price_ratio' => 1,
			'additional_shipping_cost' => 0,
			'reference' => '',
			'supplier_reference' => '',
			'location' => '',
			'width' => 0,
			'height' => 0,
			'depth' => 0,
			'weight' => 0,
			'out_of_stock' => 0,
			'additional_delivery_times' => 0,
			'quantity_discount' => 0,
			'customizable' => 0,
			'uploadable_files' => 0,
			'text_fields' => '0',
			'active' => '0',
			'redirect_type' => '301-category',
			'id_type_redirected' => '0',
			'available_for_order' => '1',
			'available_date' => '0000-00-00',
			'show_condition' => '0',
			'condition' => 'new',
			'show_price' => '1',
			'indexed' => '1',
			'visibility' => 'both',
			'cache_is_pack' => '0',
			'cache_has_attachments' => '0',
			'is_virtual' => '0',
			'cache_default_attribute' => '0',
			'date_add' => static::$datetime,
			'date_upd' => static::$datetime,
			//'date_online' => $datetime,
			'advanced_stock_management' => '0',
			'pack_stock_type' => '3',
			'state' => '1',
		],
		'product_lang' => [
			//'id_product' => NULL,
			'id_shop' => P_SHOP_ID,
			'id_lang' => P_LANG_ID,
			'description' => '',
			'description_short' => $d_data['product']['description'],
			'link_rewrite' => '',
			'meta_description' => '',
			'meta_keywords' => '',
			'meta_title' => '',
			'name' => $d_data['product']['label'],
			//'available_now' => '',
			//'available_later' => '',
			//'delivery_in_stock' => '',
			//'delivery_out_stock' => '',
			//'expert_advice_image' => '',
			//'expert_advice_name' => '',
			//'expert_advice_text' => '',
			//'gluten_free_certification_number' => '',
			//'product_tab_link_label' => '',
			//'product_tab_link_anchor' => '',
			//'product_brand_link' => '',
			//'quotation_form_id' => '',
		],
		'product_shop' => [
			//'id_product' => NULL,
			'id_shop' => P_SHOP_ID,
			'id_category_default' => P_CATEGORY_DEFAULT_ID,
			'id_tax_rules_group' => static::P_ID_TAX_RULES_GROUP,
			'on_sale' => '0',
			'online_only' => '0',
			'ecotax' => '0',
			'minimal_quantity' => static::P_MINIMAL_QUANTITY,
			'low_stock_threshold' => static::P_LOW_STOCK_THRESHOLD,
			'low_stock_alert' => static::P_LOW_STOCK_ALERT,
			'price' => '0',
			'wholesale_price' => '0',
			'unity' => static::P_UNITY,
			'unit_price_ratio' => '0',
			'additional_shipping_cost' => '0',
			'customizable' => '0',
			'uploadable_files' => '0',
			'text_fields' => '0',
			'active' => '0',
			'redirect_type' => '301-category',
			'id_type_redirected' => '0',
			'available_for_order' => '1',
			'available_date' => '0000-00-00',
			'show_condition' => '0',
			'condition' => 'new',
			'show_price' => '1',
			'indexed' => '1',
			'visibility' => 'both',
			'cache_default_attribute' => '0',
			'advanced_stock_management' => '0',
			'date_add' => static::$datetime,
			'date_upd' => static::$datetime,
			//'date_online' => NULL,
			'pack_stock_type' => static::P_PACK_STOCK_TYPE,
		],
		'category_product' => [],
	];

	// New product type fiels : standard, pack, virtual, combinations, etc.
	if (P_VERSION >= '1.7.8') {
		$p_data_map['product']['product_type'] = 'standard';
	}

	// Additional optionnal fields
	if (PUBLIC_PRICE) {
		$p_data_map['product']['recommended_public_price'] = $d_data['product_extrafields']['public_price']>0 ?$d_data['product_extrafields']['public_price'] :0;
	}
	if (ECOTAX) {
		$ecotax = ($d_data['product_extrafields']['ecotaxdeee']>0 ?$d_data['product_extrafields']['ecotaxdeee'] :0);
		$p_data_map['product']['ecotax'] = $ecotax;
		$p_data_map['product_shop']['ecotax'] = $ecotax;
	}
	if (PRODUCT_FIELD_CUSTOM && array_key_exists('custom', $d_data['product_extrafields'])) {
		$p_data_map['product']['sur_mesure'] = $d_data['product_extrafields']['custom'] ?1 :0;
	}
	if (PRODUCT_FIELD_SUPPLIER_DIRECT_DELIVERY && array_key_exists('supplier_direct_delivery', $d_data['product_extrafields'])) {
		$p_data_map['product']['supplier_direct_delivery'] = $d_data['product_extrafields']['supplier_direct_delivery'] ?1 :0;
	}

	return $p_data_map;
}

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	if (DEBUG_AFF)
		var_dump('dp_map_update()');
	if (DEBUG_AFF)
		var_dump($o);
	if ($o['p_tref']=='product')
		return $this->map_update_simple($o, $d_data, $p_data);
	elseif ($o['p_tref']=='product_attribute')
		return $this->map_update_combi($o, $d_data, $p_data);
}

public function map_update_simple(&$o, &$d_data, &$p_data=[])
{
	$tms = max((isset($p_data['product']['date_upd']) ?$p_data['product']['date_upd'] :'0000-00-00'), $d_data['product']['tms']);
	
	$p_data_map = [
		'product' => [
			//'id_product' => $p_id,
			//'id_supplier' => '',
			//'id_manufacturer' => '',
			//'id_category_default' => static::P_ID_CATEGORY_DEFAULT,
			//'id_shop_default' => P_SHOP_ID,
			'id_tax_rules_group' => static::_dp_map_id_tax_rules_group($d_data),
			//'on_sale' => string '0',
			'online_only' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_online_only'] ?1 :0) :'1'),
			'ean13' => static::_dp_map_ean13($d_data),
			'isbn' => static::_dp_map_isbn($d_data),
			'upc' => static::_dp_map_upc($d_data),
			//'ecotax' => '0',
			//'quantity' => '0',
			//'minimal_quantity' => '1',
			//'low_stock_threshold' => '0',
			//'low_stock_alert' => '1',
			'price' => $d_data['product']['price'],
			'wholesale_price' => ($d_data['product']['cost_price'] ?$d_data['product']['cost_price'] :0), // achat hors tva
			//'unity' => '',
			//'unit_price_ratio' => 1,
			//'additional_shipping_cost' => 0,
			'reference' => $d_data['product']['ref'],
			//'supplier_reference' => '',
			//'location' => '',
			'width' => ($d_data['product']['width'] ?$d_data['product']['width'] :0),
			'height' => ($d_data['product']['height'] ?$d_data['product']['height'] :0),
			'depth' => ($d_data['product']['length'] ?$d_data['product']['length'] :0),
			'weight' => ($d_data['product']['weight'] ?$d_data['product']['weight'] :0),
			//'out_of_stock' => '0',
			//'additional_delivery_times' => '0',
			//'quantity_discount' => '0',
			//'customizable' => '0',
			//'uploadable_files' => '0',
			//'text_fields' => '0',
			'active' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_active'] ?1 :0) :'1'),
			//'redirect_type' => '301-category',
			//'id_type_redirected' => '0',
			'available_for_order' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_available_for_order'] ?1 :0) :'1'),
			//'available_date' => '',
			//'show_condition' => '0',
			//'condition' => 'new',
			//'show_price' => '1',
			//'indexed' => '1',
			//'visibility' => 'both',
			//'cache_is_pack' => '0',
			//'cache_has_attachments' => '0',
			//'is_virtual' => '0', // @todo
			//'cache_default_attribute' => '0',
			//'date_add' => $datetime,
			'date_upd' => $tms,
			//'date_online' => $datetime,
			//'advanced_stock_management' => '0', // @todo
			//'pack_stock_type' => '3',
			//'state' => '1',

		],
		'product_lang' => [
			//'id_product' => $p_id,
			//'id_shop' => P_SHOP_ID,
			//'id_lang' => P_LANG_ID,
			//'description' => html_entity_decode($d_data['product']['description']),
			//'link_rewrite' => static::_dp_map_link_rewrite($d_data),
			//'meta_description' => html_entity_decode($d_data['product']['description']),
			//'meta_keywords' => '',
			//'meta_title' => html_entity_decode($d_data['product']['label']),
			//'name' => html_entity_decode($d_data['product']['label']),
			//'available_now' => '',
			//'available_later' => '',
			//'delivery_in_stock' => '',
			//'delivery_out_stock' => '',
			//'expert_advice_image' => '',
			//'expert_advice_name' => '',
			//'expert_advice_text' => '',
			//'gluten_free_certification_number' => '',
			//'product_tab_link_label' => '',
			//'product_tab_link_anchor' => '',
			//'product_brand_link' => '',
		],
		'product_shop' => [
			//'id_product' => $p_id,
			//'id_shop' => P_SHOP_ID,
			//'id_category_default' => static::P_ID_CATEGORY_DEFAULT
			'id_tax_rules_group' => static::_dp_map_id_tax_rules_group($d_data),
			//'on_sale' => '0',
			'online_only' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_online_only'] ?1 :0) :'1'),
			//'ecotax' => '0',
			//'minimal_quantity' => static::P_MINIMAL_QUANTITY,
			//'low_stock_threshold' => static::P_LOW_STOCK_THRESHOLD,
			//'low_stock_alert' => static::P_LOW_STOCK_ALERT,
			'price' => $d_data['product']['price'],
			'wholesale_price' => ($d_data['product']['cost_price'] ?$d_data['product']['cost_price'] :0), // achat hors tva
			//'unity' => static:P_UNITY,
			//'unit_price_ratio' => '0',
			//'additional_shipping_cost' => '0',
			//'customizable' => '0',
			//'uploadable_files' => '0',
			//'text_fields' => '0',
			'active' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_active'] ?1 :0) :'1'),
			//'redirect_type' => '301-category',
			//'id_type_redirected' => '0',
			'available_for_order' => (isset($d_data['product_extrafields']) ?($d_data['product_extrafields']['p_available_for_order'] ?1 :0) :'1'),
			//'available_date' => '0000-00-00',
			//'show_condition' => '0',
			//'condition' => 'new',
			//'show_price' => '1',
			//'indexed' => '1',
			//'visibility' => 'both',
			//'cache_default_attribute' => '0',
			//'advanced_stock_management' => '0',
			//'date_add' => static::$datetime,
			'date_upd' => $tms,
			//'date_online' => NULL,
			//'pack_stock_type' => static::P_PACK_STOCK_TYPE,
		],
	];

	$p_data_map['pack'] = [];
	if (isset($d_data['product_association'])) {
		foreach($d_data['product_association'] as $row) {
			$product_fils = static::_dp_map_fk_product($row['fk_product_fils']);
			if (!empty($product_fils['id_product'])) {
				$p_data_map['pack'][] = [
					//'id_product_pack' => $o['p_oid'],
					'id_product_item' => $product_fils['id_product'],
					'id_product_attribute_item' => $product_fils['id_product_attribute'],
					'quantity' => $row['qty'],
				];
			}
		}
	}

	if (PRODUCT_FIELD_CUSTOM && array_key_exists('custom', $d_data['product_extrafields'])) {
		$p_data_map['product']['sur_mesure'] = $d_data['product_extrafields']['custom'] ?1 :0;
		//$p_map_data['product']['sur_mesure_available'] = $d_data['product_extrafields']['custom'];
		//$p_map_data['product']['sur_mesure_quotation'] = $d_data['product_extrafields']['custom'];
	}
	if (PRODUCT_FIELD_SUPPLIER_DIRECT_DELIVERY && array_key_exists('supplier_direct_delivery', $d_data['product_extrafields'])) {
		$p_data_map['product']['supplier_direct_delivery'] = $d_data['product_extrafields']['supplier_direct_delivery'] ?1 :0;
		//$p_map_data['product']['supplier_direct_delivery_available'] = $d_data['product_extrafields']['supplier_direct_delivery'];
	}

	return $p_data_map;
}

public function map_update_combi(&$o, &$d_data, &$p_data=[])
{
	$tms = max((isset($p_data['product']['date_upd']) ?$p_data['product']['date_upd'] :'0000-00-00'), $d_data['product']['tms']);
	
	$p_data_map = [
		'product' => [
			//'id_product' => $p_id,
			//'id_supplier' => '',
			//'id_manufacturer' => '',
			//'id_category_default' => static::P_ID_CATEGORY_DEFAULT,
			//'id_shop_default' => P_SHOP_ID,
			'id_tax_rules_group' => static::_dp_map_id_tax_rules_group($d_data),
			//'on_sale' => string '0',
			//'online_only' => '0',
			'ean13' => '', //static::_dp_map_ean13($d_data),
			'isbn' => '', //static::_dp_map_isbn($d_data),
			'upc' => '', //static::_dp_map_upc($d_data),
			//'ecotax' => '0',
			//'quantity' => '0',
			//'minimal_quantity' => '1',
			//'low_stock_threshold' => '0',
			//'low_stock_alert' => '1',
			'price' => 0,
			'wholesale_price' => 0, // achat hors tva
			//'unity' => '',
			//'unit_price_ratio' => 1,
			//'additional_shipping_cost' => 0,
			//'reference' => '', //$d_data['product']['ref'], // on laisse tel quel, c'est la liste des différentes déclinaisons
			//'supplier_reference' => '',
			//'location' => '',
			'width' => (!P_PRODUCT_CDC_DIMENSIONS && $d_data['product']['width'] ?$d_data['product']['width'] :0),
			'height' => (!P_PRODUCT_CDC_DIMENSIONS && $d_data['product']['height'] ?$d_data['product']['height'] :0),
			'depth' => (!P_PRODUCT_CDC_DIMENSIONS && $d_data['product']['length'] ?$d_data['product']['length'] :0),
			'weight' => 0,
			//'out_of_stock' => '0',
			//'additional_delivery_times' => '0',
			//'quantity_discount' => '0',
			//'customizable' => '0',
			//'uploadable_files' => '0',
			//'text_fields' => '0',
			//'active' => '0',
			//'redirect_type' => '301-category',
			//'id_type_redirected' => '0',
			//'available_for_order' => '1',
			//'available_date' => '',
			//'show_condition' => '0',
			//'condition' => 'new',
			//'show_price' => '1',
			//'indexed' => '1',
			//'visibility' => 'both',
			//'cache_is_pack' => '0',
			//'cache_has_attachments' => '0',
			//'is_virtual' => '0', // @todo
			//'cache_default_attribute' => '0',
			//'date_add' => $datetime,
			'date_upd' => $tms,
			//'date_online' => $datetime,
			//'advanced_stock_management' => '0', // @todo
			//'pack_stock_type' => '3',
			//'state' => '1',
		],
		'product_lang' => [
			//'id_product' => $p_id,
			//'id_shop' => P_SHOP_ID,
			//'id_lang' => P_LANG_ID,
			//'description' => html_entity_decode($d_data['product']['description']),
			//'link_rewrite' => static::_dp_map_link_rewrite($d_data),
			//'meta_description' => html_entity_decode($d_data['product']['description']),
			//'meta_keywords' => '',
			//'meta_title' => html_entity_decode($d_data['product']['label']),
			//'name' => html_entity_decode($d_data['product']['label']),
			//'available_now' => '',
			//'available_later' => '',
			//'delivery_in_stock' => '',
			//'delivery_out_stock' => '',
			//'expert_advice_image' => '',
			//'expert_advice_name' => '',
			//'expert_advice_text' => '',
			//'gluten_free_certification_number' => '',
			//'product_tab_link_label' => '',
			//'product_tab_link_anchor' => '',
			//'product_brand_link' => '',
		],
		'product_shop' => [
			//'id_product' => $p_id,
			//'id_shop' => P_SHOP_ID,
			//'id_category_default' => static::P_ID_CATEGORY_DEFAULT
			'id_tax_rules_group' => static::_dp_map_id_tax_rules_group($d_data),
			//'on_sale' => '0',
			//'online_only' => '0',
			//'ecotax' => '0',
			//'minimal_quantity' => static::P_MINIMAL_QUANTITY,
			//'low_stock_threshold' => static::P_LOW_STOCK_THRESHOLD,
			//'low_stock_alert' => static::P_LOW_STOCK_ALERT,
			'price' => 0,
			'wholesale_price' => 0, // achat hors tva
			//'unity' => static:P_UNITY,
			//'unit_price_ratio' => '0',
			//'additional_shipping_cost' => '0',
			//'customizable' => '0',
			//'uploadable_files' => '0',
			//'text_fields' => '0',
			//'active' => '0',
			//'redirect_type' => '301-category',
			//'id_type_redirected' => '0',
			//'available_for_order' => '1',
			//'available_date' => '0000-00-00',
			//'show_condition' => '0',
			//'condition' => 'new',
			//'show_price' => '1',
			//'indexed' => '1',
			//'visibility' => 'both',
			//'cache_default_attribute' => '0',
			//'advanced_stock_management' => '0',
			//'date_add' => static::$datetime,
			'date_upd' => $tms,
			//'date_online' => NULL,
			//'pack_stock_type' => static::P_PACK_STOCK_TYPE,
		],
		'product_attribute' => [
			'reference' => $d_data['product']['ref'],
			'price' => $d_data['product']['price'],
			'wholesale_price' => ($d_data['product']['cost_price'] ?$d_data['product']['cost_price'] :0), // achat hors tva
			'ean13' => static::_dp_map_ean13($d_data),
			'isbn' => static::_dp_map_isbn($d_data),
			'upc' => static::_dp_map_upc($d_data),
			'weight' => ($d_data['product']['weight'] ?$d_data['product']['weight'] :0),
		],
		'product_attribute_shop' => [
			'price' => $d_data['product']['price'],
			'wholesale_price' => ($d_data['product']['cost_price'] ?$d_data['product']['cost_price'] :0), // achat hors tva
		],
	];

	if (PRODUCT_FIELD_CUSTOM && array_key_exists('custom', $d_data['product_extrafields'])) {
		$p_data_map['product']['sur_mesure'] = $d_data['product_extrafields']['custom'] ?1 :0;
		//$p_map_data['product']['sur_mesure_available'] = $d_data['product_extrafields']['custom'];
		//$p_map_data['product']['sur_mesure_quotation'] = $d_data['product_extrafields']['custom'];
	}
	if (PRODUCT_FIELD_SUPPLIER_DIRECT_DELIVERY && array_key_exists('supplier_direct_delivery', $d_data['product_extrafields'])) {
		$p_data_map['product']['supplier_direct_delivery'] = $d_data['product_extrafields']['supplier_direct_delivery'] ?1 :0;
		//$p_map_data['product']['supplier_direct_delivery_available'] = $d_data['product_extrafields']['supplier_direct_delivery'];
	}

	if (P_PRODUCT_CDC_DIMENSIONS) {
		$p_data_map['cdcd_product_combination_dimensions']['width'] = ($d_data['product']['width'] ?$d_data['product']['width'] :0);
		$p_data_map['cdcd_product_combination_dimensions']['height'] = ($d_data['product']['height'] ?$d_data['product']['height'] :0);
		$p_data_map['cdcd_product_combination_dimensions']['depth'] = ($d_data['product']['length'] ?$d_data['product']['length'] :0);
	}

	return $p_data_map;
}

public function map_update_pack(&$o, &$d_data, &$p_data=[])
{
	//$p_data_map = $this->dp_map_update_common($o, $d_data, $p_data);

	$p_data_map['product']['cache_is_pack'] = 1;

	return $p_data_map;
}

// -----------

// Field MAPPING

public static function _dp_product_fils(&$orig_data)
{
	return static::_dp_map_fk_product($orig_data['fk_product_fils']);
}

public static function _dp_map_id_tax_rules_group(&$orig_data, &$dest_tree=[])
{
	// @todo mapper les taxes proprement !!
	switch($orig_data['product']['tva_tx']) {
		case '20':
			return 1;
		case '10':
			return 2;
		case '5.5':
			return 3;
		case '2.1':
			return 4;
		case '0':
			return 5;
	}
}
public static function _dp_map_ean13(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==2) ?substr($orig_data['product']['barcode'], 0, 13) :'';
}
public static function _dp_map_ean8(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==1) ?$orig_data['product']['barcode'] :'';
}
public static function _dp_map_isbn(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==4) ?$orig_data['product']['barcode'] :'';
}
public static function _dp_map_upc(&$orig_data, &$dest_tree=[])
{
	return ($orig_data['product']['fk_barcode_type']==3) ?$orig_data['product']['barcode'] :'';
}
public static function _dp_map_link_rewrite(&$orig_data, &$dest_tree=[])
{
	return static::_slugify($orig_data['product']['label']);
}

}

sync_product_dp::__init();
