<?php

class sync_product_lot_dp extends sync_product_lot
{

public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
	if (empty($o['p_oid']))
		return;

	// Décalage des positions existantes pour insérer le nouveau lot
	// Normalement pas besoin, sauf si la ddm est inférieure à l'existant
	$sql = 'UPDATE '.DB_P_PREFIX.'products_dlc_dluo
		SET is_current_stock = is_current_stock+1
		WHERE id_product='.$p_data_map['products_dlc_dluo']['id_product'].' AND id_combinaison='.$p_data_map['products_dlc_dluo']['id_combinaison'].'
			AND is_current_stock>='.$p_data_map['products_dlc_dluo']['is_current_stock'].'
			AND id != '.$o['p_oid'];
	DB::p_update($sql);
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	// Check Mise à jour is_current_stock
	if (!empty($p_data['products_dlc_dluo'])) {
		$sql_where = 'id_product='.$p_data['products_dlc_dluo']['id_product'].' AND id_combinaison='.$p_data['products_dlc_dluo']['id_combinaison'];

		// Plus de stock : 0
		if ($p_data_map['products_dlc_dluo']['stock']==0) {
			// Vérif si is_current_stock>0 (sinon bug mais on sait jamais...)
			if ($p_data['products_dlc_dluo']['is_current_stock']>0) {
				// Mise à 0 is_current_stock
				$sql = 'UPDATE '.DB_P_PREFIX.'products_dlc_dluo
					SET is_current_stock=0
					WHERE id='.$o['p_oid'];
				DB::p_update($sql);
			}
		}
		// Remise en stock ou modif ddm : Stock>0
		elseif($p_data_map['products_dlc_dluo']['stock']>0) {
			// Remise en stock => repositionnement à l'arrache
			if (empty($p_data['products_dlc_dluo']['is_current_stock'])) {
				$sql = 'SELECT MAX(is_current_stock)
					FROM '.DB_P_PREFIX.'products_dlc_dluo
					WHERE '.$sql_where;
				$q = DB::p_select($sql);
				list($is_current_stock) = $q->fetch_row();
				if (empty($is_current_stock))
					$is_current_stock = 0;
				$is_current_stock++;
				$sql = 'UPDATE '.DB_P_PREFIX.'products_dlc_dluo
					SET is_current_stock='.$is_current_stock.'
					WHERE id='.$o['p_oid'];
				DB::p_update($sql);
			}
		}

		// Analyse des lots / Détection d'anomalie
		$sql = 'SELECT id, is_current_stock, dluo
			FROM '.DB_P_PREFIX.'products_dlc_dluo
			WHERE '.$sql_where.'
				AND stock>0
			ORDER BY dluo, entry_date';
		$q = DB::p_select($sql);
		$is_current_stock = 0;
		while($row=$q->fetch_assoc()) {
			$is_current_stock++;
			// Repositionnement si erreur
			if ($row['is_current_stock']!=$is_current_stock) {
				$sql = 'UPDATE '.DB_P_PREFIX.'products_dlc_dluo
					SET is_current_stock='.$is_current_stock.'
					WHERE id='.$row['id'];
				DB::p_update($sql);
			}
		}
	}

	// Synchro stock global
	if (!empty($d_data['product_stock'])) {
		 static::_action('stock', 'dp', 'osync', 'product_stock', $d_data['product_stock']['rowid']);
	}

	// Trigger Presta
	$o2 = static::d_o_oid('product', 'product', $d_data['product_lot']['fk_product']);
	$this->p_promo_update($o2);
}

// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	// @todo refaire c'est de la merde voir dans common

	// Stock
	$sql = 'SELECT SUM(pb.qty)
		FROM '.DB_D_PREFIX.'product_batch pb
		INNER JOIN '.DB_D_PREFIX.'product_stock s ON s.rowid=pb.fk_product_stock
		WHERE s.fk_product='.$d_data['product_lot']['fk_product'].' AND pb.batch="'.$d_data['product_lot']['batch'].'"';
	
	// Tous dépôts
	if (D_WAREHOUSE_SYNC_MODE=='ALL') {
		// RAS
	}
	// Mono-dépôt mal défini ou à ne pas synchroniser
	elseif (D_WAREHOUSE_SYNC_MODE=='ONE' || is_numeric(D_WAREHOUSE_SYNC_IDS)) {
		if (D_WAREHOUSE_SYNC_IDS)
			$sql .= ' AND s.fk_entrepot = '.D_WAREHOUSE_SYNC_IDS;
		else
			$sql = '';
	}
	// Liste de dépôts
	elseif (D_WAREHOUSE_SYNC_MODE=='LIST') {
		if (D_WAREHOUSE_SYNC_IDS)
			$sql .= ' AND s.fk_entrepot IN ('.D_WAREHOUSE_SYNC_IDS.')';
		else
			$sql = '';
	}
	// Synchro mal paramétrée
	else {
		return $sql = '';
	}
	if ($sql) {
		echo '<p>'.$sql.'</p>';
		$q = DB::d_select($sql);
		list($qty) = $q->fetch_row();
	}
	// Synchro mal paramétrée
	// @todo
	if (empty($qty)) {
		$qty = 0;
	}

	$p_data_map = [
		'products_dlc_dluo' => [
			//'id' => '',
			//'id_product' => '',
			//'id_combinaison' => '',
			//'id_warehouse' => '',
			//'is_current_stock' => '',
			//'numero_lot' => '',
			'dlc' => !empty($d_data['product_lot']['eatby']) ?$d_data['product_lot']['eatby'] :'0000-00-00',
			'dluo' => !empty($d_data['product_lot']['sellby']) ?$d_data['product_lot']['sellby'] :'0000-00-00',
			'stock' => $qty,
			//'entry_date' => '',
			//'alert1' => '',
			//'alert2' => '',
		],
	];

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	if (empty($product=static::_dp_map_fk_product($d_data['product_stock']['fk_product'], false))) {
		//var_dump($product);
		return;
	}

	// Position actuelle !
	// Si stock
	if (isset($d_data['product_batch']['qty']) && $d_data['product_batch']['qty']>0) {
		$position = 1;
		// Recherche & parcours lots pour trouver meilleur emplacement selon date
		$rows = DB::p_get_rows('products_dlc_dluo', ['id_product'=>$product['id_product'], 'id_combinaison'=>$product['id_product_attribute']]);
		if (is_array($rows)) {
			// Parcours existant
			foreach($rows as $row) {
				// On zappe si inactif
				if ($row['is_current_stock']==0)
					continue;
				// Si ddm nouveau lot > on incrémente
				if ($position <= $row['is_current_stock'] && $d_data['product_lot']['sellby'] >= $row['dluo'])
					$position = $row['is_current_stock']+1;
			}
		}
	}
	// Pas de stock
	else {
		$position = 0;
	}
	//var_dump($position); var_dump($rows); die();

	$p_data_map = [
		'products_dlc_dluo' => [
			//'id' => '',
			'id_product' => $product['id_product'],
			'id_combinaison' => $product['id_product_attribute'],
			'id_warehouse' => static::P_ID_WAREHOUSE,
			'is_current_stock' => $position,
			'numero_lot' => $d_data['product_lot']['batch'],
			//'dlc' => $d_data['product_lot']['eatby'],
			//'dluo' => $d_data['product_lot']['sellby'],
			//'stock' => $d_data['product_batch']['qty'],
			'entry_date' => substr($d_data['product_lot']['datec'], 0, 10),
			'alert1' => static::P_DLC_ALERT1,
			'alert2' => static::P_DLC_ALERT2,
		],
	];

	return $p_data_map;
}

}

sync_product_lot_dp::__init();
