<?php

class sync_stock_dp extends sync_stock
{

// -- ACTIONS --

public function dp_execute_osync($otype, $oid)
{
	if (!STOCK_SYNC)
		return;
	
	return parent::dp_execute_osync($otype, $oid);
}

public function dp_execute_create($otype, $oid)
{
	if (!STOCK_SYNC)
		return;
	if (!defined('D_WAREHOUSE_SYNC_MODE'))
		return;
	
	return parent::dp_execute_create($otype, $oid);
}

// -- SUB ACTIONS --

// @todo à réécrire c'est dégueu et répétitif

public function dp_create($otype, $oid)
{
	$o = [
		'model_id'=>static::MODEL_ID,
		'map_id'=>static::MAP_ID,
		'd_tref'=>$otype,
		'd_oid'=>$oid,
		'p_tref'=>NULL,
		'p_oid'=>NULL,
	];

	return $this->dp_osync($o);
}

public function dp_osync($o)
{
	if (DEBUG_AFF)
		var_dump($o);
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'dp', 'action'=>'osync', 'otype'=>$o['d_tref'], 'oid'=>$o['d_oid']];

	$otype = $o['d_tref'];
	$oid = $o['d_oid'];
	
	$d_data = $this->d_data($otype, $oid);

	// Retrieve Product
	$o2 = static::d_o_oid('product', 'product', $d_data['product_stock']['fk_product']);
	static::_class('product', 'dp');
	$sync_product_dp = sync_product_dp::_instance();
	//var_dump($sync_product_dp);
	$p2_data = $sync_product_dp->p_data($o2['p_tref'], $o2['p_oid']);
	$d2_data = $sync_product_dp->d_data($o2['d_tref'], $o2['d_oid']);

	return $sync_product_dp->dp_update_stock($o2, $d2_data, $p2_data);
}

public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	// Trigger Presta
	$o2 = static::d_o_oid('product', 'product', $d_data['product_stock']['fk_product']);
	$this->p_promo_update($o2);
}

// -- MAPPING --

public static function d_reserved_qty($fk_product)
{
	$qty = 0;

	// Commandes brouilons et validées
	// c.fk_statut IN (0, 1, 2) => brouillons, validés, envoi en cours (brouillons aussi afin  !)
	$sql = 'SELECT COUNT(DISTINCT c.fk_soc) as nb_customers, COUNT(DISTINCT c.rowid) as nb, COUNT(cd.rowid) as nb_rows, SUM(cd.qty) as qty
		FROM '.DB_D_PREFIX.'commandedet as cd
		INNER JOIN '.DB_D_PREFIX.'commande as c ON c.rowid = cd.fk_commande
		LEFT JOIN '.DB_D_PREFIX.'commande_extrafields c2 ON c2.fk_object=c.rowid
		LEFT JOIN '.DB_D_PREFIX.'ps_order_state st ON st.id_order_state=c2.p_state
		WHERE cd.fk_product = '.$fk_product.' AND (c.fk_statut in (1, 2) OR (c.fk_statut=0 AND st.statut >= 1))';
	$q = DB::d_select($sql);
	if (!empty($cmd_row = $q->fetch_assoc()))
		$qty += $cmd_row['qty'];
	var_dump($cmd_row);

	// Expéditions effectuées sur les commandes en cours
	// e.fk_statut IN (1, 2) => validated et closed
	$sql = 'SELECT COUNT(DISTINCT e.fk_soc) as nb_customers, COUNT(DISTINCT e.rowid) as nb, COUNT(ed.rowid) as nb_rows, SUM(ed.qty) as qty
		FROM '.DB_D_PREFIX.'expeditiondet as ed
		INNER JOIN '.DB_D_PREFIX.'commandedet as cd ON cd.rowid=ed.fk_origin_line
		INNER JOIN '.DB_D_PREFIX.'commande as c ON c.rowid = cd.fk_commande
		INNER JOIN '.DB_D_PREFIX.'expedition as e ON e.rowid = ed.fk_expedition
		WHERE cd.fk_product = '.$fk_product.' AND c.fk_statut IN (0, 1, 2) AND e.fk_statut IN (1, 2)';
	$q = DB::d_select($sql);
	if (!empty($exp_row = $q->fetch_assoc()))
		$qty -= $exp_row['qty'];
	var_dump($exp_row);

	//var_dump($row);

	return $qty;
}

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	if (! empty($d_data['product_stock']['fk_product']))
		$reserved_qty = static::d_reserved_qty($d_data['product_stock']['fk_product']);
	else
		$reserved_qty = 0;
	
	if ($d_data['product_stock']['reel'] < 0) {
		$qty = 0;
		$reserved_qty -= $d_data['product_stock']['reel'];
	}
	else {
		$qty = $d_data['product_stock']['reel'];
	}
		
	$p_data_map = [
		'stock_available' => [
			'quantity' => $qty - $reserved_qty, // @todo
			'physical_quantity' => $qty,
			'reserved_quantity' => $reserved_qty,
		],
	];

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	$product = static::_dp_map_fk_product($d_data['product_stock']['fk_product']);
	var_dump($product);
	
	$p_data_map = [
		'stock_available' => [
			//'id_stock_available' => '',
			'id_product' => $product['id_product'],
			'id_product_attribute' => $product['id_product_attribute'],
			'id_shop' => P_SHOP_ID,
			'id_shop_group' => 0,
			'quantity' => $d_data['product_stock']['reel'], // @todo
			'physical_quantity' => $d_data['product_stock']['reel'],
			'reserved_quantity' => 0,
			'depends_on_stock' => 0,
			'out_of_stock' => static::P_OUT_OF_STOCK_DEFAULT,
			'location' => '',
		],
	];

	return $p_data_map;
}

}

sync_stock_dp::__init();
