<?php

class sync_supplier_pd extends sync_supplier
{

// -- SUB ACTIONS --

public function pd_insert_more(&$o, &$d_data_map, &$p_data)
{
	$id = $o['d_oid'];

	if (!empty($p_data['address']))
		static::_action('address', 'pd', 'osync', 'address', $p_data['address']['id_address']);
}

public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
	$id = $o['d_oid'];
	
	if (!empty($p_data['address']))
		static::_action('address', 'pd', 'osync', 'address', $p_data['address']['id_address']);
}

// -- MAPPING --

public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	$d_data_map = [
		'societe' => [
			'nom' => $p_data['supplier']['name'],
			//'address' => (!empty($p_data['address']) ?$p_data['address']['address1'].($p_data['address']['address2'] ?"\r\n".$p_data['address']['address2'] :'') :''),
			//'zip' => (!empty($p_data['address']) ?$p_data['address']['postcode'] :NULL),
			//'town' => (!empty($p_data['address']) ?$p_data['address']['city'] :NULL),
			//'fk_pays' => static::_pd_map_fk_pays($p_data),
			////'phone' => (!empty($p_data['address']) ?$p_data['address']['phone'] :NULL),
			'fk_user_modif' => static::D_K_USER,
			'tms' => $p_data['supplier']['date_upd'],
		],
	];

	return $d_data_map;
}

public function pd_map_create(&$o, &$p_data)
{
	$d_data_map = [
		'societe' => [
			//'rowid' => NULL,
			'nom' => $p_data['supplier']['name'],
			'name_alias' => NULL,
			'entity' => 1,
			'ref_ext' => NULL,
			'ref_int' => NULL,
			'statut' => 1, // activé, sinon inutile...
			'parent' => NULL,
			'status' => 1,
			'code_client' => NULL,
			'code_fournisseur' => static::d_ref($p_data['supplier']['date_add']),
			'code_compta' => NULL,
			'code_compta_fournisseur' => NULL,
			'address' => (!empty($p_data['address']) ?$p_data['address']['address1'].($p_data['address']['address2'] ?"\r\n".$p_data['address']['address2'] :'') :''),
			'zip' => (!empty($p_data['address']) ?$p_data['address']['postcode'] :NULL),
			'town' => (!empty($p_data['address']) ?$p_data['address']['city'] :NULL),
			'fk_departement' => NULL,
			'fk_pays' => static::_pd_map_fk_pays($p_data),
			'fk_account' => NULL,
			'phone' => (!empty($p_data['address']) ?$p_data['address']['phone'] :NULL),
			'fax' => NULL,
			'url' => NULL,
			'email' => NULL,
			// 'socialnetworks' => NULL,
			// 'skype' => NULL,
			// 'twitter' => NULL,
			// 'facebook' => NULL,
			// 'linkedin' => NULL,
			// 'instagram' => NULL,
			// 'snapchat' => NULL,
			// 'googleplus' => NULL,
			// 'youtube' => NULL,
			// 'whatsapp' => NULL,
			'fk_effectif' => NULL,
			'fk_typent' => 0,
			'fk_forme_juridique' => NULL,
			'fk_currency' => NULL,
			'siren' => NULL,
			'siret' => NULL,
			'ape' => NULL,
			'idprof4' => '',
			'idprof5' => '',
			'idprof6' => '',
			'tva_intra' => '',
			'capital' => NULL,
			'fk_stcomm' => 0,
			'note_private' => NULL,
			'note_public' => NULL,
			'model_pdf' => NULL,
			'prefix_comm' => NULL,
			'client' => 0,
			'fournisseur' => 1,
			'supplier_account' => NULL,
			'fk_prospectlevel' => '',
			'fk_incoterms' => 0,
			'location_incoterms' => NULL,
			'customer_bad' => 0,
			'customer_rate' => 0,
			'supplier_rate' => 0,
			'remise_client' => 0,
			'remise_supplier' => 0,
			'mode_reglement' => NULL,
			'cond_reglement' => NULL,
			'mode_reglement_supplier' => NULL,
			'cond_reglement_supplier' => NULL,
			'fk_shipping_method' => NULL,
			'tva_assuj' => 1,
			'localtax1_assuj' => NULL,
			'localtax1_value' => 0,
			'localtax2_assuj' => NULL,
			'localtax2_value' => 0,
			'barcode' => NULL,
			'fk_barcode_type' => 0,
			'price_level' => NULL,
			'outstanding_limit' => NULL,
			'order_min_amount' => NULL,
			'supplier_order_min_amount' => NULL,
			'default_lang' => NULL,
			'logo' => NULL,
			'logo_squarred' => NULL,
			'canvas' => NULL,
			'webservices_url' => NULL,
			'webservices_key' => NULL,
			'tms' => $p_data['supplier']['date_upd'],
			'datec' => $p_data['supplier']['date_add'],
			'fk_user_creat' => static::D_K_USER,
			'fk_user_modif' => static::D_K_USER,
			'fk_multicurrency' => 0,
			'multicurrency_code' => '',
			'import_key' => NULL,
			'transport_mode' => NULL,
			'transport_mode_supplier' => NULL,
			'fk_warehouse' => NULL,
			'accountancy_code_sell' => NULL,
			'accountancy_code_buy' => NULL,
		],
		//'commandedet' => [],
	];

	//var_dump($d_data_map); die();

	return $d_data_map;
}

// -----------

// Field MAPPING

public static function _p_map_code_client(&$orig_data)
{
	return NULL; // @todo récupérer la prochaine valeur !
}

public static function _pd_map_fk_pays(&$orig_data)
{
	static::_country_load();

	if (!empty($orig_data['address']['id_country'])) {
		$id_country = $orig_data['address']['id_country'];
		if (isset(static::$_pd_country[$id_country]))
			return static::$_pd_country[$id_country];
	}
}

}

sync_supplier_pd::__init();
