<?php

class sync_supplier_price_dp extends sync_supplier_price
{

// -- MAPPING --

public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	$p_data_map = [
		'product_supplier' => [
			//'id_product_supplier' => NULL,
			'product_supplier_reference' => $d_data['product_fournisseur_price']['ref_fourn'],
			'product_supplier_price_te' => $d_data['product_fournisseur_price']['unitprice'],
		],
	];

	return $p_data_map;
}

public function dp_map_create(&$o, &$d_data)
{
	$product = static::_dp_map_product($d_data);

	$p_data_map = [
		'product_supplier' => [
			//'id_product_supplier' => NULL,
			'id_product' => $product['id_product'],
			'id_product_attribute' => $product['id_product_attribute'],
			'id_supplier' => static::_dp_map_fk_supplier($d_data),
			'product_supplier_reference' => $d_data['product_fournisseur_price']['ref_fourn'],
			'product_supplier_price_te' => $d_data['product_fournisseur_price']['unitprice'],
			'id_currency' => static::P_ID_CURRENCY,
		],
	];

	return $p_data_map;
}

// -----------

// Field MAPPING

public static function _dp_map_product(&$orig_data, &$dest_tree=[])
{
	$product = [];
	// Déjà mappé
	if ($o = static::d_o_oid('product', 'product', $orig_data['product_fournisseur_price']['fk_product'])) {
		// Combi
		if ($o['p_tref']=='product_attribute') {
			$row = DB::p_get_row('product_attribute', ['id_product_attribute'=>$o['p_oid']]);
			return ['id_product'=>$row['id_product'], 'id_product_attribute'=>$o['p_oid']];
		}
		// Simple
		else {
			return ['id_product'=>$o['p_oid'], 'id_product_attribute'=>0];
		}
	}
	// Création simple
	else {
		if ($o = static::_action('product', 'dp', 'create', 'product', $orig_data['product_fournisseur_price']['fk_product']))
			return ['id_product'=>$o['p_oid'], 'id_product_attribute'=>0];
	}
}

public static function _dp_map_fk_supplier(&$orig_data, &$dest_tree=[])
{
	return static::_dp_map_fk('supplier', 'societe', $orig_data['product_fournisseur_price']['fk_soc']);
}

}

sync_supplier_price_dp::__init();
