<?php

// -- SYNC CLASS --

class sync
{

protected static $_instance = [];

protected static $_triggers = [
	'url' => [],
];

// Prestashop

// Tables
// Primaires
const P_TABLE_ID = [
	'address' => 'id_address',
	'customer' => 'id_customer',
	'manufacturer' => 'id_manufacturer',
	'orders' => 'id_order',
	'order_cart_rule' => 'id_order_cart_rule',
	'order_detail' => 'id_order_detail',
	'order_invoice' => 'id_order_invoice',
	'order_payment' => 'id_order_payment',
	'order_slip' => 'id_order_slip',
	'order_slip_detail' => 'id_order_slip_detail',
	'product' => 'id_product',
	'product_attribute' => 'id_product_attribute',
	'product_supplier' => 'id_product_supplier',
	'products_dlc_dluo' => 'id',
	'stock_available' => 'id_stock_available',
	'supplier' => 'id_supplier',
];
// Secondaires
const P_TABLE_ID2 = [
	'product_lang' => 'id_product',
	'product_shop' => 'id_product',
];

// Overloaded in each src/sync/model_name/common.inc.php
const MODEL_NAME = '';
const MODEL_ID = 0;
const MAP_ID = 0;

const D_TABLE_MAIN = '';
const D_TABLE_MAIN_REF = '';
const D_REF_CODE = '';
const D_REF_LENGTH = 5;
const D_REF_DATE = '';

const P_TABLE_MAIN = '';
const P_TABLE_MAIN_REF = '';
const P_TABLE_MAIN_ID = 0;

// Cascade delete
const DP_DELETE = false;
const DP_DELETE_LINK = false;
const PD_DELETE = false;
const PD_DELETE_LINK = false;

// @todo : déplacer en constante globale !

// Général
const P_ID_LANG = 1; // Depeacated use global const P_LANG_ID
const P_ID_SHOP = 1; // Depeacated use global const P_SHOP_ID
const P_ID_SHOP_GROUP = 3; // Client by default
const P_ID_TAX_RULES_GROUP = 3;
// Product
const P_ID_CATEGORY_DEFAULT = 2; // Depeacated use global const P_CATEGORY_DEFAULT_ID
const P_MINIMAL_QUANTITY = 1;
const P_LOW_STOCK_THRESHOLD = 5;
const P_LOW_STOCK_ALERT = 1;
const P_UNITY = 'Le KG';
const P_PACK_STOCK_TYPE = 3;
// Product Lot
const P_DLC_ALERT1 = 30;
const P_DLC_ALERT2 = 60;
// Stock
const P_ID_WAREHOUSE = 0;
const P_OUT_OF_STOCK_DEFAULT = 2;
// Customer
const P_ID_GROUP_DEFAULT = 3;
// Order
const P_ID_CURRENCY = 1;
// Cart rule
const P_K_FREESHIPPING_CART_RULE = 18;
const P_K_DISCOUNT_CART_RULE = 17;

// Dolibarr

// Général
const D_K_USER = 2;
// Stock
const D_K_WAREHOUSE = 1;
// Product Shipping Price (PrestaShipping)
const D_K_SHIPPING_PRODUCT = 1;
const D_SHIPPING_PRODUCT_NAME = 'Frais de Transport';
const D_SHIPPING_PRODUCT_TVA = 20; // Pas certain... mais assez sûr !
// Product Discount Price
const D_K_DISCOUNT_PRODUCT = 2;
const D_DISCOUNT_PRODUCT_NAME = 'Remise exceptionnelle';
const D_DISCOUNT_PRODUCT_TVA = 20; // Pas certain...
// Banque par défaut etransactions
const D_K_BANK_DEFAULT = 1;

protected static $timestamp;
protected static $datetime;
protected static $date;

protected static $nb;

public static function __init()
{
	$classname = get_called_class();
	static::$_instance[$classname] = new static();
	if (empty(static::$timestamp)) {
		static::$timestamp = time();
		static::$datetime = date('Y-m-d H:i:s', static::$timestamp);
		static::$date = substr(static::$datetime, 0, 10);
	}
}

// -- CACHING --

protected static $_p_country = [];
protected static $_d_country = [];
protected static $_pd_country = [];
protected static $_dp_country = [];

protected static $_p_attribute = [];
protected static $_p_attribute_group = [];

protected static $_d_c_paiement = [];

protected static $_p_order_state_map = [];
protected static $_p_carriers = [];

protected static $_d_units = [];
protected static $_d_units_code = [];

protected static $_d_type_contact = [];
protected static $_d_type_contact_code = [];

protected static function _attributes_load()
{
	if (!empty(static::$_p_attribute))
		return;

	// Presta
	$sql = 'SELECT al.id_attribute, al.name, '.(P_ATTRIBUTE_TITLE_NAME ?'agl.title_name' :'agl.public_name').' name2
		FROM '.DB_P_PREFIX.'attribute_lang al
		INNER JOIN '.DB_P_PREFIX.'attribute a ON a.id_attribute=al.id_attribute
		INNER JOIN '.DB_P_PREFIX.'attribute_group_lang agl ON agl.id_attribute_group=a.id_attribute_group
		WHERE al.id_lang='.P_LANG_ID.' AND agl.id_lang='.P_LANG_ID ;
	$q = DB::p_select($sql);
	while($row=$q->fetch_assoc()) {
		static::$_p_attribute[$row['id_attribute']] = ($row['name2'] ?$row['name2'].' ' :'').$row['name'];
	}
	//var_dump(static::$_p_attribute);
}

protected static function _paiement_load()
{
	if (!empty(static::$_d_c_paiement))
		return;

	// Presta
	$sql = 'SELECT *
		FROM '.DB_D_PREFIX.'c_paiement';
	
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc())
		static::$_d_c_paiement[$row['code']] = $row;
	//var_dump(static::$_d_paiement);
}

protected static function _country_load()
{
	if (!empty(static::$_p_country))
		return;

	// Presta
	$sql = 'SELECT * FROM '.DB_P_PREFIX.'country';
	$q = DB::p_select($sql);
	//var_dump($q); die();
	while($row=$q->fetch_assoc())
		static::$_p_country[$row['iso_code']] = $row['id_country'];
	//var_dump(static::$_p_country);

	// Doli
	$sql = 'SELECT * FROM '.DB_D_PREFIX.'c_country';
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc()) 
		static::$_d_country[$row['code']] = $row['rowid'];
	//var_dump(static::$_d_country);

	// Presta => Doli
	foreach(static::$_p_country as $iso=>$id)
		if (isset(static::$_d_country[$iso]))
			static::$_pd_country[$id] = static::$_d_country[$iso];
	//var_dump(static::$_pd_country);

	// Doli => Presta
	foreach(static::$_d_country as $iso=>$id)
		if (isset(static::$_p_country[$iso]))
			static::$_dp_country[$id] = static::$_p_country[$iso];
	//var_dump(static::$_dp_country);

}

public static function _p_order_state_map_load()
{
	if (!empty(static::$_p_order_state_map))
		return;

	$sql = 'SELECT *
		FROM '.DB_D_PREFIX.'ps_order_state';
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc()) {
		static::$_p_order_state_map[$row['id_order_state']] = $row;
	}
	//var_dump(static::$_p_order_state_map);
}

public static function _p_carriers_load()
{
	if (!empty(static::$_p_carriers))
		return;

	$sql = 'SELECT *
		FROM '.DB_P_PREFIX.'carrier t
		LEFT JOIN '.DB_P_PREFIX.'carrier_lang tl ON tl.id_carrier=t.id_carrier
		WHERE tl.id_lang='.P_LANG_ID.' AND tl.id_shop='.P_SHOP_ID.'
		GROUP BY t.id_carrier';
	$q = DB::p_select($sql);
	while($row=$q->fetch_assoc()) {
		static::$_p_carriers[$row['id_carrier']] = $row;
	}
	//var_dump(static::$_p_carriers); die();
}

public static function _d_units_load()
{
	if (!empty(static::$_d_units))
		return;

	$sql = 'SELECT *
		FROM '.DB_D_PREFIX.'c_units u';
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc()) {
		static::$_d_units[$row['rowid']] = $row;
		static::$_d_units_code[$row['code']] = $row['scale'];
	}
	//var_dump(static::$_p_carriers); die();
}

public static function _d_type_contact_load()
{
	if (!empty(static::$_d_type_contact))
		return;

	$sql = 'SELECT *
		FROM '.DB_D_PREFIX.'c_type_contact';
	$q = DB::d_select($sql);
	while($row=$q->fetch_assoc()) {
		static::$_d_type_contact[$row['rowid']] = $row;
		static::$_d_type_contact_code[$row['element']][$row['source']][$row['code']] = $row['rowid'];
	}
	//var_dump(static::$_d_type_contact_code); die();
}

public static function _p_order_state_map()
{
	return static::$_p_order_state_map;
}

// --

public static function _class($type, $sens='')
{
	// Load common model class
	try {
		if (DEBUG_AFF)
			var_dump(SYNC_PATH.'/'.$type.'/common.inc.php');
		require_once(SYNC_PATH.'/'.$type.'/common.inc.php');
	} catch(Throwable $e) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($type, $sens)", "Could not load common sync class for type ".$type, NULL, $e);
	}
	
	if (!in_array($sens, ['pd', 'dp']))
		return;
	// Load specific direction model class
	try {
		if (DEBUG_AFF)
			var_dump(SYNC_PATH.'/'.$type.'/'.$sens.'.inc.php');
		require_once(SYNC_PATH.'/'.$type.'/'.$sens.'.inc.php');
	} catch(Throwable $e) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($type, $sens)", "Could not load controller sync class for type ".$type.', sens '.$sens, NULL, $e);
	}
	
	$classname = 'sync_'.$type.'_'.$sens;
	return $classname;
}

public static function _action($type, $sens, $action, $otype, $oid)
{
	$classname = static::_class($type, $sens);
	$method = $sens.'_execute_'.$action;
	
	// Initialise controller and execute action
	try {
		$controller = $classname::_instance();
		$r = $controller->$method($otype, $oid);
	} catch(Throwable $e) {
		$context = ['type'=>$type, 'sens'=>$sens, 'action'=>$action, 'otype'=>$otype, 'oid'=>$oid];
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($type, $sens, $action, $otype, $oid)", 'Error executing controller '.$classname.'::'.$method.'('.$otype.','.$oid.')', $context, $e);
	}
	
	if (isset($r) && !empty($r))
		return $r;
}

public static function _instance()
{
	$classname = get_called_class();
	return static::$_instance[$classname];
}
public static function _getInstance()
{
	return static::_instance();
}
protected function __construct()
{

}

public function __destruct()
{
	if (empty(static::$_triggers))
		return;
	
	if (DEBUG_AFF)
		echo '<h3>Sync Object Destruct Triggers</h3>';
	
	if (!empty(static::$_triggers['url'])) {
		foreach(static::$_triggers['url'] as $k=>$url) {
			$ch = curl_init();
			if (DEBUG_AFF)
				echo $url;
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_exec($ch);
			curl_close($ch);
		}
		unset(static::$_triggers['url']);
	}
}

// TRIGGERS


public function trigger_add($type, $value)
{
	if (!isset(static::$_triggers[$type]))
	static::$_triggers[$type] = [];
	if (!in_array($value, static::$_triggers[$type]))
		static::$_triggers[$type][] = $value;
}


// -- OBJECT MAPPING RELATION MANAGEMENT --

public function o_create($o)
{
	//var_dump($o);
	if (empty($o) || empty($o['d_tref']) || empty($o['d_oid']) || empty($o['p_tref']) || empty($o['p_oid']))
		return;

	// Insert main object
	$sql = 'INSERT INTO `_objects` (`mid`, `map_id`) VALUES ('.$o['model_id'].', '.$o['map_id'].')';
	if (!($id = DB::o_insert($sql)))
		return;
	// Insert relations
	$sql = 'INSERT INTO `_objects_d` (`id`, `tid`, `oid`) SELECT '.$id.', `id`, '.$o['d_oid'].' FROM `_d_tables` WHERE `ref`="'.$o['d_tref'].'"';
	DB::o_insert($sql);
	$sql = 'INSERT INTO `_objects_p` (`id`, `tid`, `oid`) SELECT '.$id.', `id`, '.$o['p_oid'].' FROM `_p_tables` WHERE `ref`="'.$o['p_tref'].'"';
	DB::o_insert($sql);
	return $id;
}

public static function o_oid($sens, $type, $otype, $oid)
{
	$sql = 'SELECT o.id,
			od.tid d_tid, td.ref d_tref, od.oid d_oid,
			op.tid p_tid, tp.ref p_tref, op.oid p_oid
		FROM _objects o
		INNER JOIN _map ma ON ma.id=o.map_id
		INNER JOIN _models mo ON mo.id=ma.model_id
		INNER JOIN _objects_d od ON od.id=o.id
		INNER JOIN _d_tables td ON td.id=od.tid
		INNER JOIN _objects_p op ON op.id=o.id
		INNER JOIN _p_tables tp ON tp.id=op.tid
		WHERE mo.ref="'.$type.'"
		  AND '.($sens=='dp' ?'td' :'tp').'.ref="'.$otype.'"
		  AND '.($sens=='dp' ?'od' :'op').'.oid="'.$oid.'"';

	$q = DB::o_select($sql);
	return $q->fetch_assoc();
}
public static function d_o_oid($type, $otype, $oid)
{
	return static::o_oid('dp', $type, $otype, $oid);
}
public static function p_o_oid($type, $otype, $oid)
{
	return static::o_oid('pd', $type, $otype, $oid);
}


// -- HELPERS --

// chaine de caractères aléatoires
public static function uniqid($lenght = 13)
{
    // uniqid gives 13 chars, but you could adjust it to your needs.
    if (function_exists("random_bytes")) {
        $bytes = random_bytes(ceil($lenght / 2));
    } elseif (function_exists("openssl_random_pseudo_bytes")) {
        $bytes = openssl_random_pseudo_bytes(ceil($lenght / 2));
    } else {
        throw new Exception("no cryptographically secure random function available");
    }
    return substr(bin2hex($bytes), 0, $lenght);
}

// @todo mettre ailleurs, c'est un helper bien plus général
public static function _array_merge_recursive(&$map, $tmap)
{
	if (!is_array($map))
		$map = [];
	if (is_array($tmap)) foreach($tmap as $i=>$j) {
		if (!isset($map[$i]))
			$map[$i] = $j;
		elseif (!is_array($map[$i]) || !is_array($j))
			$map[$i] = $j;
		else
			static::_array_merge_recursive($map[$i], $j);
	}
}

/**
 * Text to slug
 * @return string
 */
public static function _slugify($text, string $divider='-')
{
	// Remove HTML entities
	$text = html_entity_decode($text);

	// replace non letter or digits by divider
	$text = preg_replace('~[^\pL\d]+~u', $divider, $text);

	// transliterate
	$text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

	// remove unwanted characters
	$text = preg_replace('~[^-\w]+~', '', $text);

	// trim
	$text = trim($text, $divider);

	// remove duplicate divider
	$text = preg_replace('~-+~', $divider, $text);

	// lowercase
	$text = strtolower($text);

	if (empty($text)) {
		return 'n-a-'.rand(1, 1000000000);
	}

	return $text;
}

// TABLE REF MAP

//protected static $nb;

public static function _d_ref_nb($tablename, $fieldname, $str, $length=6, $date_aff=true)
{
	$sql = 'SELECT rowid, MAX('.$fieldname.')
		FROM '.DB_D_PREFIX.$tablename.'
		WHERE '.$fieldname.' REGEXP "'.$str.($date_aff ?'[0-9]{4}' :'').'-[0-9]{'.$length.'}"';
	$q = DB::d_select($sql);
	if ($q->num_rows) {
		list($id, $ref) = $q->fetch_row();
		//var_dump($id); var_dump($ref);
		if ($ref)
			$nb = (int)substr($ref, strlen($str.($date_aff ?'YYMM' :''))+1);
		else
			$nb = 0;
	}
	else {
		$nb = 0;
	}

	if (DEBUG_AFF)
		var_dump($nb);
	return $nb;
}
public static function d_ref_nb()
{
	static::$nb = static::_d_ref_nb(static::D_TABLE_MAIN, static::D_TABLE_MAIN_REF, static::D_REF_CODE, static::D_REF_LENGTH, static::D_REF_DATE);
	return static::$nb;
}

public static function _d_ref($nb, $str, $length=6, $date=NULL)
{
	$nb++;
	for ($i=strlen($nb); $i<$length; $i++)
		$nb = '0'.$nb;

	$ref = $str.($date ?substr($date, 2, 2).substr($date, 5, 2) :'').'-'.$nb;
	
	return $ref;
}
public static function d_ref($date=NULL)
{
	$nb = static::d_ref_nb();
	if (static::D_REF_DATE && empty($date))
		$date = date('Y-m-d');
	return static::_d_ref($nb, static::D_REF_CODE, static::D_REF_LENGTH, $date);
}


// -- MAP FK LINKS --

public static function _dp_map_fk($modelname, $tablename, $id)
{
	if (empty($id))
		return;
	
	if (!($o = static::d_o_oid($modelname, $tablename, $id))) {
		$o = static::_action($modelname, 'dp', 'create', $tablename, $id);
	}
	if (DEBUG_AFF)
		var_dump($o);
	if (empty($o))
		return;
	return $o['p_oid'];
}
public static function _pd_map_fk($modelname, $tablename, $id)
{
	if (empty($id))
		return;

	if (!($o = static::p_o_oid($modelname, $tablename, $id))) {
		$o = static::_action($modelname, 'pd', 'create', $tablename, $id);
	}
	if (DEBUG_AFF)
		var_dump($o);
	if (empty($o))
		return;
	return $o['d_oid'];
}


// RETRIEVE DATA

public function p_data($otype, $oid)
{
	// Overload
}

public function d_data($otype, $oid)
{
	// Overload
}


// -- NOTIF Sync TS --

public static function _notif_ts($sens, $otype, $oid, $result=NULL)
{
	$sql = 'UPDATE `_sync`
		SET `sync_ts`=NOW(), `sync_result`='.($result==NULL ?'NULL' :'"'.$result.'"').'
		WHERE `type`="'.static::MODEL_NAME.'" AND `t_name`="'.$otype.'" AND `t_oid`="'.$oid.'"
			AND `sync_ts` IS NULL';
	// @todo vérif si c'ets la bonne méthode...
	// AND `action` IN ("create", "osync")
	return ($sens=='p' ?DB::p_update($sql) :DB::d_update($sql));
}


// -- PD COMMON METHODS --

// EXECUTE_DELETE
public function pd_execute_delete($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->p_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	if (empty($o)) {
		$context = ['type'=>static::MODEL_NAME, 'sens'=>'pd', 'action'=>'delete', 'otype'=>$otype, 'oid'=>$oid];
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Source data link does not exists", $context, NULL, 'nodata');
		return false;
	}
	
	return $this->pd_delete($o);
}
public function dp_execute_delete($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->d_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	if (empty($o)) {
		$context = ['type'=>static::MODEL_NAME, 'sens'=>'dp', 'action'=>'delete', 'otype'=>$otype, 'oid'=>$oid];
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Source data link does not exists", $context, NULL, 'nodata');
		return false;
	}
	
	return $this->dp_delete($o);
}
// EXECUTE_OSYNC
public function pd_execute_osync($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->p_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	//die();

	// Création
	if (empty($o)) {
		return $this->pd_create($otype, $oid);
	}

	return $this->pd_osync($o);
}
public function dp_execute_osync($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->d_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	//die();

	// Création
	if (empty($o)) {
		return $this->dp_create($otype, $oid);
	}
	
	return $this->dp_osync($o);
}

// execute_create
public function pd_execute_create($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->p_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	//die();

	// Création
	if (empty($o)) {
		return $this->pd_create($otype, $oid);
	}
}
public function dp_execute_create($otype, $oid)
{
	// Vérif lien existant
	// Récupère lien
	$o = $this->d_o_oid(static::MODEL_NAME, $otype, $oid);
	if (DEBUG_AFF)
		var_dump($o);

	//die();

	// Création
	if (empty($o)) {
		return $this->dp_create($otype, $oid);
	}
}

// Check Synchro

public static function pd_check_sync(&$o, &$p_data)
{
	// @override
	return true;
}
public static function pd_check_create(&$o, &$d_data_map, &$p_data)
{
	// @override
	//return false to block
	//return $d_data_map to change db_insert
}
public static function pd_check_update(&$o, &$d_data_map_update, &$d_data_map_create, &$d_data, &$p_data)
{
	// @override
	//return false to block
	//return $d_data_map_update to change db_update
}
public static function pd_check_delete(&$o, &$d_data)
{
	return static::PD_DELETE;

	// @override
	//return false to block
}

public static function dp_check_sync(&$o, &$d_data)
{
	// @override
	return true;
}
public static function dp_check_create(&$o, &$p_data_map, &$d_data)
{
	// @override
	//return false to block
	//return $p_data_map;
}
public static function dp_check_update(&$o, &$p_data_map_update, &$p_data_map_create, &$p_data, &$d_data)
{
	// @override
	//return false to block
	//return $p_data_map_update;
}
public static function dp_check_delete(&$o, &$p_data)
{
	return static::DP_DELETE;

	// @override
	//return false to block
}

public static function p_o_byref($type, $otype, $ref)
{
	if (empty(static::P_TABLE_MAIN_REF))
		false;

	$row = DB::p_get_row($otype, [static::P_TABLE_MAIN_REF=>$ref]);
	if (DEBUG_AFF)
		var_dump($row);

	if (!empty($row))
		return static::p_o_oid($type, $otype, $row[static::P_TABLE_ID[$otype]]);
}

public static function d_o_byref($type, $otype, $ref)
{
	if (empty(static::D_TABLE_MAIN_REF))
		return false;

	$row = DB::d_get_row($otype, [static::D_TABLE_MAIN_REF=>$ref]);
	if (DEBUG_AFF)
		var_dump($row);

	if (!empty($row))
		return static::d_o_oid($type, $otype, $row['rowid']);
}

// CREATE
public function pd_create($otype, $oid)
{
	$o = [
		'model_id'=>static::MODEL_ID,
		'map_id'=>static::MAP_ID,
		'p_tref'=>$otype,
		'p_oid'=>$oid,
	];
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'pd', 'action'=>'create', 'otype'=>$otype, 'oid'=>$oid];

	// Récupère données source
	$p_data = $this->p_data($otype, $oid);
	if (!($check_sync=$this->pd_check_sync($o, $p_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);
		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Object marked not to sync", $context, NULL, 'nosync');
		return false;
	}
	if (DEBUG_AFF)
		var_dump($p_data);
	if (empty($p_data[$otype])) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Source data does not exists", $context, NULL, 'nodata');
		return;
	}
	
	if (empty($o['d_tref']))
		$o['d_tref'] = static::D_TABLE_MAIN;
	if (DEBUG_AFF)
		var_dump($o);

	// Check Doublon ref unique à resynchroniser
	if (static::P_TABLE_MAIN_REF && static::D_TABLE_MAIN_REF && !empty($p_data[$otype][static::P_TABLE_MAIN_REF])) {
		$ref = $p_data[$otype][static::P_TABLE_MAIN_REF];
		// Object qui a déjà été synchronisé
		$o2 = static::d_o_byref(static::MODEL_NAME, static::D_TABLE_MAIN, $ref);
		// Données de l'autre côté avec la même ref
		$d_row = DB::d_get_row($o['d_tref'], [static::D_TABLE_MAIN_REF=>$ref]);
		if (DEBUG_AFF)
			var_dump($ref, $o2, $d_row);

		// Trouvé règle de synchro
		if (!empty($o2)) {
			// Récupération object p
			$p_row = DB::p_get_row($o2['p_tref'], [static::P_TABLE_ID[$o2['p_tref']]=>$o2['p_oid']]);
			if (DEBUG_AFF)
				var_dump($p_row);
			// Si pas d'object on réaffecte
			if (empty($p_row)) {
				if (DEBUG_AFF)
					echo 'REAFFECTER';
				$sql = 'UPDATE _objects_p op
					INNER JOIN _p_tables t
					SET op.oid='.$o['p_oid'].', op.tid=t.id
					WHERE t.ref="'.$o['p_tref'].'" AND op.id='.$o2['id'];
				if (DEBUG_AFF)
					echo $sql;
				DB::o_update($sql);
				// Remettre l'objet en synchro active
				if (in_array($o['d_tref'], ['product'])) {
					DB::d_update_row('product_extrafields', ['sync'=>1], ['fk_object'=>$o2['d_oid']]);
				}
			}
			// Déjà synchronisé => blocage
			else {
				sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Referrence already exists and synced on the other side", $context, NULL, 'ref_exists');
			}
			return;
		}
		// Réassociation
		elseif (!empty($d_row)) {
			// Create Mapping Object
			$o['d_oid'] = $d_row['rowid'];
			if (!($this->o_create($o))) {
				// @todo : delete useless inserted data
				sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "o_create() returns false", $context, NULL, 'object');
				return;
			}

			// Sync notif ts
			static::_notif_ts('p', $otype, $oid);
			return;
		}
	}
	
	//die();

	// Construit nouvel objet
	$d_data_map = $d_data_map_create = $this->pd_map_create($o, $p_data);
	if (DEBUG_AFF)
		var_dump($d_data_map);
	
	// Construit données objet & Check
	if (is_null($d_data_map)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "map_create() : NULL", $context, NULL, 'nodatamap');
		return;
	}
	elseif (empty($d_data_map)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "map_create() : empty", $context, NULL, 'nodatamap');
		return;
	}
	$d_data_map_update = $this->pd_map_update($o, $p_data);
	static::_array_merge_recursive($d_data_map, $d_data_map_update);
	if (DEBUG_AFF)
		var_dump($d_data_map);
	if (($d_data_map_insert=$this->pd_check_create($o, $d_data_map, $p_data)) === false)
		return;
	
	if (DEBUG_AFF)
		echo '<p>CREATION OBJETS</p>';
	
	// insert main row
	try {
		$id = DB::d_insert_row($o['d_tref'], !empty($d_data_map_insert) ?$d_data_map_insert[$o['d_tref']] :$d_data_map[$o['d_tref']]);
	} catch(Throwable $e) {
		if (DEBUG_AFF)
			var_dump($e);
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "DB::d_insert_row() : ".json_encode($d_data_map[$o['d_tref']]), $context, $e);
	}
	if (!isset($id) || empty($id)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "DB::d_insert_row() NO ID : ".json_encode($d_data_map[$o['d_tref']]), $context, NULL, 'db');
		return;
	}

	// Create Mapping Object
	$o['d_oid'] = $id;
	if (!($this->o_create($o))) {
		// @todo : delete useless inserted data
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "o_create() returns false", $context, NULL, 'object');
		return;
	}
	
	$this->pd_insert_more($o, $d_data_map, $p_data);
	$d_data = [];
	$this->pd_update_more($o, $d_data_map_update, $d_data_map_create, $d_data, $p_data);

	// Sync notif ts
	static::_notif_ts('p', $otype, $oid);
	
	return $o;
}
public function pd_insert_more(&$o, &$d_data_map, &$p_data)
{
	// @override
}
public function pd_map_create(&$o, &$p_data)
{
	// @override
}
public function dp_create($otype, $oid)
{
	$o = [
		'model_id'=>static::MODEL_ID,
		'map_id'=>static::MAP_ID,
		'd_tref'=>$otype,
		'd_oid'=>$oid,
	];
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'dp', 'action'=>'create', 'otype'=>$otype, 'oid'=>$oid];
	
	if (DEBUG_AFF)
		var_dump($o);

	// Récupère données source
	$d_data = $this->d_data($otype, $oid);
	if (!($check_sync=$this->dp_check_sync($o, $d_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);
		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Object marked not to", $context, NULL, 'nosync');
		return false;
	}
	if (DEBUG_AFF)
		var_dump($d_data);
	if (empty($d_data[$otype])) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Source data does not exists", $context, NULL, 'nodata');
		return;
	}
	
	if (empty($o['p_tref']))
		$o['p_tref'] = static::P_TABLE_MAIN;

	// Check Doublon ref à resynchroniser
	if (static::D_TABLE_MAIN_REF && static::P_TABLE_MAIN_REF && !empty($d_data[$otype][static::D_TABLE_MAIN_REF])) {
		$ref = $d_data[$otype][static::D_TABLE_MAIN_REF];
		// Object qui a déjà été synchronisé
		$o2 = static::p_o_byref(static::MODEL_NAME, static::P_TABLE_MAIN, $ref);
		// Données de l'autre côté avec la même ref
		$p_row = DB::p_get_row($o['p_tref'], [static::P_TABLE_MAIN_REF=>$ref]);
		if (DEBUG_AFF)
			var_dump($o2, $p_row);

		// Trouvé règle de synchro
		if (!empty($o2)) {
			// Récupération object d
			$d_row = DB::d_get_row($o2['d_tref'], ['rowid'=>$o2['d_oid']]);
			if (DEBUG_AFF)
				var_dump($d_row);
			// Si pas d'object on réaffecte
			if (empty($d_row)) {
				if (DEBUG_AFF)
					echo 'REAFFECTER';
				$sql = 'UPDATE _objects_d od
					INNER JOIN _d_tables t
					SET od.oid='.$o['d_oid'].', od.tid=t.id
					WHERE t.ref="'.$o['d_tref'].'" od.id='.$o2['id'];
				if (DEBUG_AFF)
					echo $sql;
				//die();
				DB::o_update($sql);
				// Remettre l'objet en synchro active
				if (in_array($o['p_tref'], ['product'])) {
					//DB::p_update_row($o['p_tref', ['sync'=>1], [static::P_TABLE_ID[$o['p_tref']]=>$o2['d_oid']]);
				}
			}
			// Déjà synchronisé => blocage
			else {
				sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "Referrence already exists and synced on the other side", $context, NULL, 'ref_exists');
			}
			return;
		}
		// Réassociation (fonctionne si une seule table... sinon il faut boucler/chercher dans product et product_attribute par ex.)
		elseif (!empty($p_row)) {
			// Create Mapping Object
			$o['p_oid'] = $p_row[static::P_TABLE_ID[$o['p_tref']]];
			if (!($this->o_create($o))) {
				// @todo : delete useless inserted data
				sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "o_create() returns false", $context, NULL, 'object');
				return;
			}

			// Sync notif ts
			static::_notif_ts('d', $otype, $oid);
			return;
		}
	}

	// Construit données objet & Check
	$p_data_map = $p_data_map_create = $this->dp_map_create($o, $d_data);
	if (is_null($p_data_map)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "map_create() : NULL", $context, NULL, 'nodatamap');
		return;
	}
	elseif (empty($p_data_map)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "map_create() : empty", $context, NULL, 'nodatamap');
		return;
	}
	$p_data_map_update = $this->dp_map_update($o, $d_data);
	static::_array_merge_recursive($p_data_map, $p_data_map_update);
	if (DEBUG_AFF)
		var_dump($p_data_map);
	if ($this->dp_check_create($o, $p_data_map, $d_data) === false)
		return;

	//die();

	if (DEBUG_AFF)
		echo '<p>CREATION OBJETS</p>';

	try {
		// insert main row
		$id = DB::p_insert_row($o['p_tref'], $p_data_map[$o['p_tref']]);
	} catch(Throwable $e) {
		if (DEBUG_AFF)
			var_dump($e);
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "DB::p_insert_row() : ".$o['p_tref']." -> ".json_encode($p_data_map[$o['p_tref']]), $context, $e);
	}
	
	if (!isset($id) || empty($id)) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "DB::p_insert_row() NO ID : ".$o['p_tref']." -> ".json_encode($p_data_map[$o['p_tref']]), $context, NULL, 'db');
		return;
	}
	
	// Create Mapping Object
	$o['p_oid'] = $id;
	if (!($this->o_create($o))) {
		// @todo : delete useless inserted data
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($otype, $oid)", "o_create() returns false", $context, NULL, 'object');
		return;
	}
	
	$this->dp_insert_more($o, $p_data_map, $d_data);
	$p_data = [];
	$this->dp_update_more($o, $p_data_map_update, $p_data_map_create, $p_data, $d_data);
	
	// Sync notif ts
	static::_notif_ts('d', $otype, $oid);

	return $o;
}
public function dp_insert_more(&$o, &$p_data_map, &$d_data)
{
}
public function dp_map_create(&$o, &$d_data)
{
	// Override
}

// OSYNC
public function pd_osync($o)
{
	if (DEBUG_AFF)
		var_dump($o);
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'pd', 'action'=>'osync', 'otype'=>$o['p_tref'], 'oid'=>$o['p_oid']];
	
	// Récupère données source
	$p_data = $this->p_data($o['p_tref'], $o['p_oid']);
	if (!($check_sync=$this->pd_check_sync($o, $p_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);
		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[p_tref], $o[p_oid])", "Object marked not to sync", $context, NULL, 'nosync');
		return false;
	}
	if (DEBUG_AFF)
		var_dump($p_data);
	if (empty($p_data[$o['p_tref']])) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[p_tref], $o[p_oid])", "Source data does not exists", $context, NULL, 'nodata');
		return;
	}
	
	// Récupère données actuelles en comparaison
	$d_data = $this->d_data($o['d_tref'], $o['d_oid']);
	if (DEBUG_AFF)
		var_dump($d_data);
	
	//die();

	// Construit update
	$d_data_map = $this->pd_map_update($o, $p_data, $d_data);
	if (DEBUG_AFF)
		var_dump($d_data_map);
	
	// Construit create
	if (empty($o['d_tref']))
		$o['d_tref'] = static::D_TABLE_MAIN;
	$d_data_map_create = $this->pd_map_create($o, $p_data);
	
	// Check
	if (($d_data_map_real=$this->pd_check_update($o, $d_data_map, $d_data_map_create, $d_data, $p_data)) === false)
		return;
	
	// Update base
	try {
		static::d_update_row($o['d_tref'], ['rowid'=>$o['d_oid']], is_array($d_data_map_real) ?$d_data_map_real  :$d_data_map, $d_data_map_create, $d_data);
	} catch(Throwable $e) {
		if (DEBUG_AFF)
			var_dump($e);
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."(".json_encode($o).")", "d_update_row() : ".json_encode($d_data_map), $context, $e, 'db');
		return;
	}
	
	// Update more
	$this->pd_update_more($o, $d_data_map, $d_data_map_create, $d_data, $p_data);

	// Sync notif ts
	static::_notif_ts('p', $o['p_tref'], $o['p_oid']);
	
	return $o;
}
public function pd_update_more(&$o, &$d_data_map, &$d_data_map_create, &$d_data, &$p_data)
{
}
public function pd_map_update(&$o, &$p_data, &$d_data=[])
{
	// Overload
}

public function dp_osync($o)
{
	if (DEBUG_AFF)
		var_dump($o);
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'dp', 'action'=>'osync', 'otype'=>$o['d_tref'], 'oid'=>$o['d_oid']];
	
	// Récupère données source
	$d_data = $this->d_data($o['d_tref'], $o['d_oid']);
	if (!($check_sync=$this->dp_check_sync($o, $d_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);
		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[d_tref], $o[d_oid])", "Object marked not to", $context, NULL, 'nosync');
		return false;
	}
	
	if (DEBUG_AFF)
		var_dump($d_data);
	if (empty($d_data[static::D_TABLE_MAIN])) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[d_tref], $o[d_oid])", "Source data does not exists", $context, NULL, 'nodata');
		return;
	}

	// Récupère données actuelles en comparaison
	$p_data = $this->p_data($o['p_tref'], $o['p_oid']);
	if (DEBUG_AFF)
		var_dump($p_data);
	
	//die();
	//var_dump('dp_osync()'); var_dump($o);
	
	// Construit update
	$p_data_map = $this->dp_map_update($o, $d_data, $p_data);
	if (DEBUG_AFF)
		var_dump($p_data_map);
	
	// Construit create
	if (empty($o['p_tref']))
		$o['p_tref'] = static::P_TABLE_MAIN;
	$p_data_map_create = $this->dp_map_create($o, $d_data);
	
	// Check
	if ($this->dp_check_update($o, $p_data_map, $p_data_map_create, $p_data, $d_data) === false)
		return;

	// Update base
	if (DEBUG_AFF)
		var_dump('before base sync::p_update_row()');
	if (DEBUG_AFF)
		var_dump($o);
	try {
		static::p_update_row($o['p_tref'], [static::P_TABLE_ID[$o['p_tref']]=>$o['p_oid']], $p_data_map, $p_data_map_create, $p_data);
	} catch(Throwable $e) {
		if (DEBUG_AFF)
			var_dump($e);
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."(".json_encode($o).")", "p_update_row() : ".json_encode($p_data_map), $context, $e, 'db');
		return;
	}
	
	// Update more
	$this->dp_update_more($o, $p_data_map, $p_data_map_create, $p_data, $d_data);
	
	// Sync notif ts
	static::_notif_ts('d', $o['d_tref'], $o['d_oid']);
	
	return $o;
}
public function dp_update_more(&$o, &$p_data_map, &$p_data_map_create, &$p_data, &$d_data)
{
	// Overload
}
public function dp_map_update(&$o, &$d_data, &$p_data=[])
{
	// Overload
}

// DELETE


public function pd_delete(&$o)
{
	if (DEBUG_AFF)
		var_dump($o);
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'pd', 'action'=>'delete', 'otype'=>$o['d_tref'], 'oid'=>$o['d_oid']];
	//var_dump($context); die();

	$d_data = $this->d_data($o['d_tref'], $o['d_oid']);
	// Check cascade delete
	if (!($check_sync=$this->pd_check_delete($o, $d_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);

		// Delete more
		// In that case this is more a delete substitute
		$this->pd_delete_more($o);

		if (static::PD_DELETE_LINK) {
			$sql = 'DELETE FROM _objects WHERE id='.$o['id'];
			DB::o_delete($sql);
		}
		
		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[d_tref], $o[d_oid])", "Object marked not to delete", $context, NULL, 'nosync');
		else
			static::_notif_ts('p', $o['p_tref'], $o['p_oid']);

		return false;
	}

	if (! ($r=DB::d_delete_row($o['d_tref'], ['rowid'=>$o['d_oid']]))) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[d_tref], $o[d_oid])", "Source data does not exists", $context, NULL, 'nodata');
		return false;
	}
	//$r=DB::p_delete_row($o['p_tref']], [static::P_TABLE_ID[$o['p_tref']]]=>$o['p_oid']]);
	
	// Delete more
	$this->pd_delete_more($o);

	// Delete link object (@todo check if this is a good idea... maybe it would be better to keep the link..?)
	$sql = 'DELETE FROM _objects WHERE id='.$o['id'];
	DB::o_delete($sql);

	// Sync notif ts
	static::_notif_ts('p', $o['p_tref'], $o['p_oid']);
	
	return true;
}
public function pd_delete_more(&$o)
{
	// Overload
}

public function dp_delete(&$o)
{
	if (DEBUG_AFF)
		var_dump($o);
	$context = ['type'=>static::MODEL_NAME, 'sens'=>'dp', 'action'=>'delete', 'otype'=>$o['p_tref'], 'oid'=>$o['p_oid']];

	$p_data = $this->p_data($o['p_tref'], $o['p_oid']);
	// Check cascade delete
	if (!($check_sync=$this->dp_check_delete($o, $p_data))) {
		if (DEBUG_AFF)
			var_dump($check_sync);

		// Delete more
		// In that case this is more a delete substitute
		$this->dp_delete_more($o);

		if (static::DP_DELETE_LINK) {
			$sql = 'DELETE FROM _objects WHERE id='.$o['id'];
			DB::o_delete($sql);
		}

		if ($check_sync!==false)
			sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[p_tref], $o[p_oid])", "Object marked not to delete", $context, NULL, 'nosync');
		else
			static::_notif_ts('d', $o['d_tref'], $o['d_oid']);

		return false;
	}

	if (! ($r=DB::p_delete_row($o['p_tref'], [static::P_TABLE_ID[$o['p_tref']]=>$o['p_oid']]))) {
		sync_error(__FILE__.':'.__LINE__.' : '.__METHOD__."($o[p_tref], $o[p_oid])", "Source data does not exists", $context, NULL, 'nodata');
		return false;
	}
	
	// Update more
	$this->dp_delete_more($o);

	// Delete link object (@todo check if this is a good idea... maybe it would be better to keep the link..?)
	$sql = 'DELETE FROM _objects WHERE id='.$o['id'];
	DB::o_delete($sql);

	// Sync notif ts
	static::_notif_ts('d', $o['d_tref'], $o['d_oid']);

	return true;
}
public function dp_delete_more(&$o)
{
	// Overload
}

// DB UPDATE ROW

public static function p_update_row($tablename, $params, $data_map, $data_map_create=[], $data=[])
{
	// Déjà => Update
	if (isset($data[$tablename]))
		return DB::p_update_row($tablename, (isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params, $data[$tablename]);
	// Pas => Insert
	else
		return DB::p_insert_row($tablename, array_merge((isset($data_map_create[$tablename]) ?$data_map_create[$tablename] :[]), (isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params));
}
public static function p_insert_row($tablename, $params, $data_map, $data=[])
{
	// Pas déjà => Insert
	if (!isset($data[$tablename]))
		return DB::p_insert_row($tablename, array_merge((isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params));
}
public static function d_update_row($tablename, $params, $data_map, $data_map_create=[], $data=[])
{
	// Déjà => Update
	if (isset($data[$tablename]))
		return DB::d_update_row($tablename, (isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params, $data[$tablename]);
	// Pas => Insert
	else
		return DB::d_insert_row($tablename, array_merge((isset($data_map_create[$tablename]) ?$data_map_create[$tablename] :[]), (isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params));
}
public static function d_insert_row($tablename, $params, $data_map, $data=[])
{
	// Pas déjà => Insert
	if (!isset($data[$tablename]))
		return DB::d_insert_row($tablename, array_merge((isset($data_map[$tablename]) ?$data_map[$tablename] :[]), $params));
}

// Triggers


// Presta promo_update
public function p_promo_update(&$o)
{
	if (!PRODUCT_LOT)
		return;
	$url = P_WEBSITE.'/modules/productsdlcdluo/cronpromo.php?go'; //p_table='.$o['p_tref'].'&p_id='.$o['p_oid'].'&go';
	$this->trigger_add('url', $url);
}

// Dolibarr API

public static function _d_api($method='POST', $url, $data=NULL)
{
	if (empty(D_API_KEY))
		return;

	$curl = curl_init();
	$httpheader = [
		'DOLAPIKEY: '.D_API_KEY,
		"Accept-Language: fr-FR,fr;q=0.9,en-US;q=0.8,en;q=0.7,la;q=0.6,de;q=0.5"
	];

	if (DEBUG_AFF)
		echo $url;
	$url = D_WEBSITE.'/api/index.php/'.$url;

	switch($method) {
		case 'POST':
            curl_setopt($curl, CURLOPT_POST, 1);
            $httpheader[] = "Content-Type:application/json";

            if ($data!==NULL)
                curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
			break;
		case 'PUT':
			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'PUT');
			$httpheader[] = "Content-Type:application/json";

			if ($data!==NULL)
				curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
			break;
		default :
			if ($data!==NULL)
				$url = sprintf("%s?%s", $url, http_build_query($data));
			break;
	}

    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $httpheader);

	$result = curl_exec($curl);
	if (DEBUG_AFF)
		var_dump($result);
	curl_close($curl);

	return $result;
}

// OID MAPPING


public static function _dp_map_fk_product($fk_product, $create=true)
{
	$product = [];
	// Déjà mappé
	if ($o = static::d_o_oid('product', 'product', $fk_product)) {
		// Combi
		if ($o['p_tref']=='product_attribute') {
			$row = DB::p_get_row('product_attribute', ['id_product_attribute'=>$o['p_oid']]);
			return ['id_product'=>$row['id_product'], 'id_product_attribute'=>$o['p_oid']];
		}
		// Simple
		else {
			return ['id_product'=>$o['p_oid'], 'id_product_attribute'=>0];
		}
	}
	// Création simple
	elseif($create) {
		$o = static::_action('product', 'dp', 'create', 'product', $fk_product);
		return ['id_product'=>$o['p_oid'], 'id_product_attribute'=>0];
	}
}

}
